ifdef::txt[]
== Very detailed Change Log
:ascii-ids:
endif::txt[]

NOTE: This change log section represents git commits in range 'v2.6.0..HEAD' (commits '8103b4e5c..0e051f9f6').

=== 2026-04-07  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/maintainer-guide.txt: add "make -j 8 distcheck-completeness"
	  into the mix
	* NEWS.adoc: fix indentation [#3395]
	* docs/nut.dict: add APC models from recent NEWS.adoc bumps [#3227,
	  #3395]
	* docs/maintainer-guide.txt: clarify last check of driver version
	  bumps
	* docs/Makefile.am: spellcheck: fix tracking of FAILED state for
	  SPELLCHECK_NOEXT_DOCS_FIRST [#2871]

=== 2026-04-06  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: note dual-byte command support in apcsmart [#3327]
	* drivers/apc_modbus.c: apc_modbus_outlet_cmd_suffixes[]: avoid
	  literal 0 as initializer for enum-typed field [#3395]
	* drivers/dstate.c: fix whitespaces around parentheses and commas
	  (WIN32) [#3302]
	* drivers/dstate.c: fix style of CreateNamedPipe() etc. args for
	  maintainability [#3302]

=== 2026-04-05  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/01-make-dist.yml: convert tarball URL messages to
	  one-line markup [#1400]
	* common/wincompat.c: use TABs in variable declarations [#3302]
	* common/wincompat.c: move variable declarations to top of methods
	  [#3302]
	* common/wincompat.c: settle on pipe_full_name variable names; fix
	  style of CreateNamedPipe() etc. args for maintainability [#3302]
	* common/wincompat.c: fix whitespaces around parentheses and commas
	  [#3302]
	* common/wincompat.c, include/wincompat.h: fix (C) heading [#3302]

=== 2026-04-04  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/00-preclean.yml: Introduce GHA workflow to clean
	  away Appveyor Bot PR comments upon re-pushes [#1400]
	* appveyor.yml: do not repeat commit info in 7Z URL message [#1400]
	  It is also misleading in PR builds
	* appveyor.yml: customize GH notification message template and add a
	  message when 7Z is generated [#1400]
	* .github/workflows/01-make-dist.yml: add GH notifications for
	  download URL [#1400]

=== 2026-04-04  Axel Gembe <axel@gembe.net>

	* NEWS.adoc, drivers/apc_modbus.c, drivers/apc_modbus.h: apc_modbus:
	  Fix outlet group command handling to be dynamic  Replace hardcoded
	  outlet group commands with dynamic detection and handling based on
	  the `SOGRelayConfigSetting` register. This ensures commands and
	  variables are only exposed for outlet groups that are actually
	  present on the UPS.  Key changes:  - Add `APC_VF_UNAVAILABLE` flag
	  to mark registers for absent outlet groups - Add outlet group info
	  table tracking presence and target bits for each group (`MOG`,
	  `SOG0` to `SOG2`) - Dynamically enumerate `outlet.group.N.id`,
	  `outlet.group.N.designator` and `outlet.group.N.status` variables
	  based on detected groups - Replace static outlet command entries
	  with `_apc_modbus_handle_outlet_cmd()` which parses `load.*`,
	  `shutdown.*`, and `outlet.group.N.*` commands at runtime - Global
	  `load.*` and `shutdown.*` commands now target all available outlet
	  groups instead of only the main outlet group (`MOG`) - Add
	  `outlet.group.N.*` commands (`load.off`, `load.on`, `load.cycle`,
	  etc.) for each detected group - Update `upsdrv_shutdown()` to use
	  the unified command handler - Add `OutletStatus_BF` bitfield
	  definitions to header  This fixes issues where commands were
	  exposed for non-existent outlet groups and ensures load/shutdown
	  operations affect all outlets on UPS units with switched outlet
	  groups.
	* NEWS.adoc, drivers/apc_modbus.c: apc_modbus: Add outlet group
	  timers  Values of SOG[0..2].TurnOffCountdown_EN for easier
	  diagnostics.
	* configure.ac: autotools: pass tar-pax to AM_INIT_AUTOMAKE  Running
	  `make distcheck` using a user account with a large UID produces:
	  ``` tardir=nut-2.8.4.0.6314 && ${TAR-tar} chof - "$tardir" \| eval
	  GZIP= gzip -9 -c >nut-2.8.4.0.6314.tar.gz tar: value 1968000001 out
	  of uid_t range 0..2097151 tar: Exiting with failure status due to
	  previous errors ```  To fix this we can pass `tar-pax` to
	  `AM_INIT_AUTOMAKE`. This tells automake to use POSIX 1003.1-2001
	  PAX format for `.tar` archives, which supports a larger UID range.

=== 2026-04-03  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/Makefile.am, docs/images/nut-logo-256x256.png: Add
	  docs/images/nut-logo-256x256.png rendition and distribute this and
	  nut-logo.svg per se
	* UPGRADING.adoc, data/htmlcgi/Makefile.am, data/htmlcgi/index.html,
	  docs/Makefile.am, docs/images/{nut-logo.png => nut-logo-60x60.png},
	  docs/images/{nut.svg => nut-logo-original-A4.svg},
	  docs/images/{nut-squared.svg => nut-logo.svg}, docs/nut.dict:
	  Rename "nut.svg" and other logo variants more structurally
	* clients/upsmon.c, NEWS.adoc: loadconfig(): extend the special
	  message for lack of POWERDOWNFLAG on upsmon non-PRIMARY instances,
	  stress if this server is fed by an UPS it is PRIMARY for [#3391]
	* docs/config-notes.txt: more clarifications about POWERDOWNFLAG file
	  [#3391]
	* clients/upsmon.c: loadconfig(): add a special message for lack of
	  POWERDOWNFLAG on upsmon PRIMARY instances [#3391]

=== 2026-04-02  Dan Langille <dan@langille.org>

	* docs/config-notes.txt: Adjust POWERDOWNFLAG explantion of temp file
	  system  Make it easier for readers.

=== 2026-04-01  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsclient.c: update comments about "built-in(blocking)"
	  connect timeout default [#2847]
	* NEWS.adoc, clients/upscmd.c, clients/upsrw.c, docs/nut.dict:
	  clients/ups{cmd,rw}.c: make the "OK" without "TRACKING" warning
	  visible; introduce NUT_QUIET_OK_NOTRACKING to hide it though
	  [#3383]
	* drivers/upsdrvctl.c: fix broken debug message and update comments

=== 2026-03-31  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsclient.c, clients/upsclient.h, docs/man/Makefile.am,
	  docs/man/upscli_readline.txt, docs/man/upscli_sendline.txt:
	  Introduce upscli_sendline_timeout_may_disconnect() and
	  upscli_readline_timeout_may_disconnect() [#3302]
	* clients/upsclient.c:
	  upscli_sendline_timeout()/upscli_readline_timeout(): report
	  "disconnecting" explicitly [#3379]
	* clients/upsclient.c: upscli_sslinit(): track and report
	  upscli_strerror() from read/write failures more diligently, and
	  handle "ERR*" replies with separate logging [#3379, #3331]
	* clients/upsclient.c: upscli_select_write()/upscli_select_read():
	  track and report errno from select/read/write failures more
	  diligently [#3379, #3331]
	* clients/upsclient.c: net_read()/net_write(): set
	  ups->upserror=UPSCLI_ERR_SSLERR when (Open)SSL read/write fails
	  during/despite retry loop [#3331]
	* clients/upsclient.c: pepper read/write and SSL init operations with
	  debug messages, update comments [#3331]
	* server/upsd.c: client_disconnect(): sleep a bit if dropping a
	  semi-initialised SSL client [#3331]
	* server/netssl.c: net_starttls(): update comment about
	  SSL_ForceHandshake() [#3331]
	* server/netssl.c: net_starttls(): debug-trace calls into NSS, to
	  profile their timing [#3379, #3331]
	* clients/upsclient.c: upscli_strerror(): detail NSS errors more
	  [#3379, #3331]
	* common/common.c: xbasename_no_ext(): use ubiquitous strcasecmp()
	  for "nut.exe" [#3379]

=== 2026-03-30  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/dstate.c: send_to_one(): revise log messages [#3302]
	* docs/config-prereqs.txt, docs/nut.dict: docs/config-prereqs.txt:
	  update MSYS2 chapter with notes on symlink enablement
	* AUTHORS, NEWS.adoc, docs/FAQ.txt, docs/configure.txt,
	  docs/developers.txt, docs/documentation.txt, docs/download.txt,
	  docs/man/NUT-Monitor.txt, docs/man/generic_modbus.txt,
	  docs/man/nut-scanner.txt, docs/man/nut.conf.txt, docs/man/nut.txt,
	  docs/man/nutupsdrv.txt, docs/nut-names.txt, docs/nut.dict,
	  docs/solaris-usb.txt: docs/*: update dictionary and rephrase clumsy
	  texts, cater to MSYS2 aspell defaults
	* tools/nutconf/nutconf-cli.cpp: fix NULL=>nullptr [#3379]
	* drivers/dummy-ups.c, drivers/main.c, drivers/main.h:
	  drivers/main.{c,h}, drivers/dummy-ups.c: introduce
	  *upsdrv_callback_setproctag and upsdrv_setproctag() [#3379]
	* drivers/dummy-ups.c: fix upsdrv_tweak_prognames() to only set
	  upscli procname/proctag with duplicates if cookies differ [#3378,
	  #3379]
	* drivers/dummy-ups.c: diligently call upscli_cleanup() to minimize
	  valgrind alerts [#3378, #3379]
	* NEWS.adoc, clients/Makefile.am, clients/upsc.c,
	  clients/upsclient.c, clients/upsclient.h, clients/upscmd.c,
	  clients/upsimage.c, clients/upslog.c, clients/upsmon.c,
	  clients/upsrw.c, clients/upsset.c, clients/upsstats.c,
	  common/common.c, docs/man/Makefile.am, ...evel.txt =>
	  nutscan_upslog_set_debug_level.txt}, ...level.txt =>
	  upscli_upslog_set_debug_level.txt}, docs/nut.dict,
	  drivers/dummy-ups.c, include/common.h,
	  tools/nut-scanner/nut-scanner.c, tools/nut-scanner/nutscan-init.c,
	  tools/nut-scanner/nutscan-init.h, tools/nut-scanner/scan_nut.c,
	  tools/nutconf/nutconf-cli.cpp: Rename libnutscan and libupsclient
	  API methods related to logging with libname_upslog_ prefix; use
	  cookies to differentiate library run-time instances; update
	  consumers accordingly [#3378, #3379]
	* clients/upsc.c, clients/upscmd.c, clients/upsimage.c,
	  clients/upslog.c, clients/upsrw.c, clients/upsset.c,
	  clients/upsstats.c: clients/*.c: diligently call upscli_cleanup()
	  to minimize valgrind alerts [#3378, #3379]

=== 2026-03-29  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c: satisfy compilers where default char is signed
	  [#3379]
	* drivers/main.c: setproctag(prognames[0]) as soon as we can, so
	  CLI/CONF processing is better traceable [#3379]
	* drivers/dummy-ups.c: as a libupsclient consumer, use
	  upscli_upslog_start_sync() and upscli_setprocname() to initialize
	  consistent logging [#3379]
	* clients/upsc.c, clients/upscmd.c, clients/upsimage.c,
	  clients/upslog.c, clients/upsmon.c, clients/upsrw.c,
	  clients/upsset.c, clients/upsstats.c: clients/*.c: redefine
	  setproctag() to cover both in-program common code and libupsclient
	  copy [#3379, #3378]
	* clients/upsc.c, clients/upscmd.c, clients/upsimage.c,
	  clients/upslog.c, clients/upsmon.c, clients/upsrw.c,
	  clients/upsset.c, clients/upsstats.c,
	  tools/nut-scanner/nut-scanner.c, tools/nutconf/nutconf-cli.cpp: NUT
	  consumers of libupsclient/libnutscan: call *_setprocname() early to
	  avoid re-getting the value in the library copy of the code [#3379]
	* clients/upsclient.c, clients/upsclient.h, common/common.c,
	  docs/man/Makefile.am, docs/man/nutscan_set_debug_level.txt,
	  docs/man/upscli_set_debug_level.txt, docs/nut.dict,
	  include/common.h, tools/nut-scanner/nutscan-init.c,
	  tools/nut-scanner/nutscan-init.h, tools/nut-scanner/scan_nut.c: NUT
	  common code, libupsclient, libnutscan: expose setmyprocname() to
	  initialize libs quietly where we can [#3379]
	* clients/upsc.c: revise main processing loop to setproctag(prog)
	  once instead of NULL [#3378]
	* common/common.c: proctag_cleanup()/procname_cleanup(): log
	  "finished" messages with odd markup at lower verbosity [#3379]
	* clients/upsc.c, clients/upscmd.c, clients/upsimage.c,
	  clients/upslog.c, clients/upsmon.c, clients/upsrw.c,
	  clients/upsset.c, clients/upsstats.c: clients/*.c: for consumers of
	  libupsclient, start with initialization of shared logging time
	  stamps [#3378, #3379]
	* drivers/main.c: fix preprocessor macro indentation of
	  DRIVERS_MAIN_WITHOUT_MAIN
	* common/common.c: proctag_cleanup()/procname_cleanup(): simplify
	  "starting"/"finished" log messages [#3379]
	* common/common.c: proctag_cleanup(): clarify in log messages if it
	  is the library unloading [#3379]
	* tools/nutconf/nutconf-cli.cpp: hack for early enough nutscan_free()
	  to yield reasonable debug logs is no longer needde [#3384]
	* common/common.c: introduce nut_common_atexit() to clean-up once and
	  in a deterministic order [#3384]
	* tools/nutconf/nutconf-cli.cpp: limit calls to nutscan_* to builds
	  WITH_NUTSCANNER, and call nutscan_free() explicitly when debugging
	  (so logs make better sense) [#3379]
	* common/common.c: debug-log registrations of atexit() handlers
	  [#3384]
	* common/common.c: track procname_cleanup_registered; report what
	  context a proctag_cleanup() and/or procname_cleanup() ran for; do
	  not run cleaners twice [#3379]
	* common/common.c: vupslog(): handle reported invalid inputs for
	  vsnprintf() gracefully [#3379, #317]  Not each failed situation is
	  a cause for (unlimited) memory extension.
	* tools/nut-scanner/nutscan-init.c: debug-log starting/ending of
	  nutscan_init()/nutscan_free() [#3379]

=== 2026-03-28  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c: ensure that proctag_cleanup() does its work before
	  procname_cleanup() [#3379]
	* common/common.c: vupslog(): only warn about buffer realloc at high
	  verbosity or big previous bufsize; prefix with [D0] [#3379, #317]
	* common/common.c: xbasename_no_ext(): keep or even add ext for
	  "nut.exe" in WIN32 builds [#3378]
	* tools/nut-scanner/scan_nut.c: nutscan_upscli*(): avoid calls after
	  libupsclient was unloaded [#3379]
	* common/common.c: debug first run of setproctag() and runs of
	  proctag_cleanup() [#3379]
	* clients/upsclient.c, common/common.c,
	  tools/nut-scanner/nutscan-init.c: Introduce private
	  setproctag_lib() for libupsclient and libnutscan [#3379]
	* .gitignore, Makefile.am, NEWS.adoc: Makefile.am, NEWS.adoc: Added
	  `make .libs-dev-PATH` recipe to help devs and CI [#3379]
	* Makefile.am: add {all,check,install}-quick goals integrated with
	  NUT CI envvars for limited parallelism [#2871]

=== 2026-03-27  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/nutconf/nutconf-cli.cpp: init common timestamps with
	  *upslog_start_sync() [#3378]
	* docs/man/Makefile.am, docs/man/nutscan_set_debug_level.txt,
	  tools/nut-scanner/nutscan-init.c, tools/nut-scanner/nutscan-init.h,
	  tools/nut-scanner/scan_nut.c: tools/nut-scanner/*, docs: expose
	  nutscan_upslog_start_sync() [#3378]
	* clients/upsclient.c, clients/upsclient.h, docs/man/Makefile.am,
	  docs/man/upscli_set_debug_level.txt,
	  tools/nut-scanner/nutscan-init.c: clients/upsclient.{c,h}, docs:
	  expose upscli_upslog_start_sync() [#3378]
	* common/common.c, include/common.h: refactor with
	  upslog_start_sync() [#3379]
	* tools/nutconf/nutconf-cli.cpp: convert to using
	  nutscan_setproctag() instead of directly setproctag() [#3378,
	  #3379]
	* tools/nut-scanner/nut-scanner.c: convert to using
	  nutscan_setproctag() instead of directly setproctag() [#3378,
	  #3379]
	* docs/man/Makefile.am, docs/man/nutscan_set_debug_level.txt,
	  tools/nut-scanner/nutscan-init.c, tools/nut-scanner/nutscan-init.h,
	  tools/nut-scanner/scan_nut.c: tools/nut-scanner/*, docs: expose
	  nutscan_{g,s}etproctag() [#3379]
	* clients/upsclient.c, clients/upsclient.h, common/common.c,
	  docs/man/Makefile.am, docs/man/upscli_set_debug_level.txt:
	  clients/upsclient.{c,h}, docs: expose upscli_{g,s}etproctag()
	  [#3379]
	* NEWS.adoc, docs/man/nutconf.txt, tools/nutconf/nutconf-cli.cpp:
	  tools/nutconf/nutconf-cli.cpp, docs: support "-D" and
	  `NUT_DEBUG_LEVEL` with `nutconf`; fix processing of short
	  (single-char) optargs even if stacked after one dash [#3378]
	* tools/nut-scanner/nut-scanner.c: stop using nut_debug_level
	  directly: call nutscan_set_debug_level() now [#3378]
	* docs/man/Makefile.am, docs/man/nutscan_set_debug_level.txt,
	  tools/nut-scanner/nutscan-init.c, tools/nut-scanner/nutscan-init.h,
	  tools/nut-scanner/scan_nut.c: tools/nut-scanner/*, docs/man/*:
	  introduce nutscan_{g,s}et_debug_level() [#3378]
	* clients/upslog.c: handle "-D" option before others, so it can
	  impact help() and version() more naturally (regardless of CLI
	  argument order) [#3378]
	* drivers/main.c: refactor to use getprogname_argv0_default(), get
	  rid of WIN32 hacks [#3378]
	* tools/nutconf/nutconf-cli.cpp: refactor to use
	  getprogname_argv0_default() for "nutconf" [#3378]
	* tools/nut-scanner/nut-scanner.c, tools/nut-scanner/Makefile.am:
	  refactor to use getprogname_argv0_default() [#3378]
	* clients/upsc.c, clients/upscmd.c, clients/upslog.c,
	  clients/upsmon.c, clients/upsrw.c, clients/upssched.c,
	  scripts/Windows/wininit.c, server/pipedebug.c, server/sockdebug.c,
	  server/upsd.c: Refactor various NUT programs to use
	  getprogname_argv0_default(), and with safer access to argv[0]
	  [#3378]
	* common/common.c, include/common.h: introduce
	  xbasename_no_ext_default() and getprogname_argv0_default() to
	  refactor NUT programs later [#3378]
	* drivers/main.c: rename "drv_pipe_name" for maintainability (WIN32)
	  [#3302]
	* drivers/main.c: comment the complexity of many debug-level vars
	  [#3378]
	* drivers/main.c: define optstring near help_msg() to match other
	  sources [#3378]
	* server/upsd.c: refactor with xbasename_no_ext() [#3373]
	* drivers/main.c: refactor with xbasename_no_ext() [#3373]
	* clients/upsmon.c: refactor with xbasename_no_ext() [#3373]
	* common/common.c, include/common.h: introduce xbasename_no_ext() to
	  refactor setproctag() and other code later [#3302, #3368, #3373]
	* NEWS.adoc: rephrase change about upsset [#3164]
	* NEWS.adoc, clients/upsc.c, clients/upscmd.c, clients/upsrw.c,
	  docs/man/upsc.txt, docs/man/upscmd.txt, docs/man/upsrw.txt:
	  clients/ups{c,cmd,rw}.c, man pages, NEWS.adoc: add "-D" option
	  support [#3378]
	* clients/upsc.c, clients/upscmd.c, clients/upslog.c,
	  clients/upsmon.c, clients/upsrw.c, clients/upssched.c,
	  drivers/main.c, drivers/upsdrvctl.c, scripts/Windows/wininit.c,
	  server/upsd.c: Clients and daemons with command-line options:
	  converge to using opt_ret=getopt(...), use a different variable for
	  unrelated iteration [#3378]
	* clients/upsc.c, clients/upscmd.c, clients/upsrw.c:
	  clients/ups{c,cmd,rw}.c: converge to naming the help() method same
	  way as other programs [#3778]
	* clients/upsc.c, clients/upscmd.c, clients/upslog.c,
	  clients/upsmon.c, clients/upsrw.c, clients/upssched.c,
	  drivers/upsdrvctl.c, scripts/Windows/wininit.c, server/upsd.c:
	  Clients and daemons with command-line options: converge to using
	  getopt(...optstring) with the latter defined near the help/usage
	  method [#3378]
	* clients/upsc.c: move usage() to top like in other clients [#3378]

=== 2026-03-27  Axel Gembe <axel@gembe.net>

	* NEWS.adoc, drivers/apc_modbus.c: apc_modbus: Fix log message
	  register range

=== 2026-03-26  Jim Klimov <jimklimov+nut@gmail.com>

	* server/conf.c: parse_upsd_conf_args(): debug-log keywords that are
	  recognized, but pertain to another build configuration [#3331]
	* clients/nutclient.cpp: resync nss_error() implementation with
	  server/netssl.c [#3302, #1711]
	* clients/upsclient.c: resync nss_error() implementation with
	  server/netssl.c [#3302, #1711]
	* server/netssl.c: nss_error(): wrap printout lines to help sync with
	  other variants of this code
	* server/netssl.c: nss_error(): only allocate buffer for
	  PR_GetErrorText() when projected err_len>0, and request the right
	  size right away
	* server/upsd.c: mainloop(): add a comment for future rework of WIN32
	  loop [#3302, #3365, #3376]
	* server/upsd.c: mainloop(): log incoming connections/data events for
	  POSIX and WIN32, revise logging disconnect events for POSIX [#3302]
	* server/upsd.c: mainloop(): log how many hits polling returned
	  (POSIX), or that it failed and we would sleep 0.1s [#3302]
	* docs/FAQ.txt: stress that MODE from nut.conf is important for
	  nutshutdown hook script [#3364]
	* docs/FAQ.txt, docs/nut.dict: docs/FAQ.txt: update about generated
	  tarballs [#1400]
	* common/nutstream.cpp: NutSocket::Address::Address() copier:
	  sanity-check that socklen_t is in size_t range [#1651]

=== 2026-03-25  Jim Klimov <jimklimov+nut@gmail.com>

	* server/netssl.c: try to get PR_ErrorToName()/PR_ErrorToString() for
	  actionable error messages [#3302, #1711]
	* drivers/dummy-ups.c: pepper parse_data_file() with debug tracing
	  logs [#3368]
	* tests/NIT/nit.sh: revise certutil signing to satisfy python 3.13\+
	  [#1711, #1600]
	* Makefile.am: rename "generated-headers-with-a-touch" =>
	  "generated-sources-with-a-touch" as more generic
	* Makefile.am: fix typo (generated-generated) in rule names

=== 2026-03-24  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsclient.c: upscli_disconnect(): after LOGOUT, let the
	  server say OK Goodbye [#3302, #1711]
	* server/upsd.c: mainloop(): report chosen/seen socket counts per
	  type (driver, client...) [#3302]
	* common/common.c: hide `if (strlen(EXEEXT))` from
	  "-Wunreachable-code" [#3302]  On platforms without EXEEXT the
	  compiler is smart enough to say this is always false.
	* tools/nut-scanner/nut-scanner.c: revise use of setproctag()
	  avoiding pthreads so far [#3302, #3368]
	* tools/nut-scanner/nut-scanner.c, tools/nut-scanner/Makefile.am: PoC
	  using setproctag() [#3302, #3368]  Did not work for parallel
	  scanning threads where it would be most useful, because they are in
	  same process space...
	* clients/upsc.c, clients/upscmd.c, clients/upsrw.c: setproctag()
	  initially and flip to specified upsname later [#3302, #3368]
	* clients/upslog.c: use setproctag() to identify the client in debug
	  logs [#3302, #3368]
	* server/upsd.c: use setproctag() to identify upsd in debug logs
	  [#3302, #3368]
	* drivers/main.c: use setproctag() to identify upsname in debug logs
	  [#3302, #3368]
	* NEWS.adoc, common/common.c, conf/nut.conf.sample,
	  docs/man/nut.conf.txt, docs/nut.dict, scripts/systemd/README.adoc,
	  tests/NIT/nit.sh: Introduce NUT_DEBUG_PROCNAME envvar (handled for
	  debug logging if setproctag() is called) [#3302, #3368]
	* tests/NIT/nit.sh: request NSS server cert with SubjAltName
	  extension [#1711]
	* tests/NIT/nit.sh: bump NUT_DEFAULT_CONNECT_TIMEOUT when testing
	  with a swarm of clients/drivers [#3302]
	* clients/nutclient.cpp: Socket(): consider
	  NUT_DEFAULT_CONNECT_TIMEOUT envvar [#2847, #2869]
	* scripts/python/module/PyNUT.py.in: consider
	  NUT_DEFAULT_CONNECT_TIMEOUT envvar [#2847, #2869]
	* tests/NIT/nit.sh: work around crashes and serial number clashes
	  with certutil on some platforms; report success in crypto setup
	  [#1711]
	* tests/NIT/nit.sh: die() not exit() upon hiccups in SSL setup to
	  help troubleshoot [#1711]
	* tests/NIT/nit.sh: setenv_ssl_cppnit()/setenv_ssl_python(): neuter
	  NUT_SSL etc. even if inherited from caller (earlier `. NIT.env`),
	  but current setup is unwilling [#1711, #1599, #1600]
	* tests/NIT/nit.sh: our MAXCONN requirement scales much faster than
	  thought initially [#3302]  Each swarm `upslog` client monitors all
	  UPSes, establishing a new TCP connection to `upsd` for each
	  discovered device.

=== 2026-03-23  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c: background(): when reporting "Startup successful",
	  also report getmyprocbasename() [#1711]  In particular, help
	  discern replies from the drivers launched by upsdrvctl en masse.
	* Makefile.am, docs/man/Makefile.am: apply ticks similar to those for
	  generated headers to generated linkman*.txt snippets, to avoid
	  re-evaluating them verbosely in parallel/recursive builds [#2871]
	* .gitignore: GitIgnore .all.*-generated.timestamp files [#2871]
	* docs/FAQ.txt: expand the section on driver inability to connect to
	  a device [#3356]
	* Makefile.am: fix "make check" done from scratch [#2871, #3039]  *
	  Goal for "generated-headers-with-a-touch" stepped on "all" done as
	  part of "check". * Not using `\+` prefix in that goal was not right
	  too. * Made cleanup dependencies separate for all/check/install
	  recursive rules.
	* Makefile.am: revise tracing of SUBDIR-MAKE reports to make them
	  consitent and easier for troubleshooting [#2871, #3039]
	* docs/Makefile.am: spellcheck: prioritize certain
	  SPELLCHECK_NOEXT_DOCS_FIRST (if present) even before parallel rules
	  [#2871]
	* docs/Makefile.am: spellcheck: debug SPELLCHECK_SRCDIR and
	  SPELLCHECK_SRC values [#2871]
	* docs/Makefile.am: move NEWS.adoc and UPGRADING.adoc to top of
	  SPELLCHECK_SRC_DEFAULT and comment why they may not be the first
	  checked anyway [#2871]
	* Makefile.am: reformat spellcheck rule shell scriptlet
	* NEWS.adoc: highlight that PR #3233 also fixes fallout of #3008

=== 2026-03-22  Jim Klimov <jimklimov+nut@gmail.com>

	* server/upsd.c: mainloop(): revise chunked select - first try with
	  zero timeout (pick already waiting connections), only then try
	  time-waited select [#3302]
	* tests/NIT/nit.sh, NEWS.adoc: introduce `UPSLOG_SWARM_COUNT` for
	  clients [#3302]
	* common/common.c: vupslog(): Ensure line buffering for sane logs on
	  Windows console
	* clients/nutclient.h: drop commented-away undefine of NSS/OPENSSL
	  when building without SSL_CXX [#1599]
	* clients/nutclient.cpp: fix includes for non-NSS builds [#1599]
	* configure.ac: extend detection of LIBSSL_CXXFLAGS on MSYS2 [#1599]
	* clients/Makefile.am, clients/nutclient.cpp, clients/nutclient.h,
	  configure.ac, tests/Makefile.am, tests/cpputest-client.cpp:
	  configure.ac, clients/nutclient.{cpp,h}, tests/cpputest-client.cpp,
	  clients/Makefile.am, tests/Makefile.am: introduce separate automake
	  condition and macro WITH_SSL_CXX [#1599, #1711]
	* configure.ac, m4/nut_compiler_family.m4: configure.ac: generalize
	  fix for LIBSSL_CXXFLAGS when -isystem is involved [#1599, #1711]
	* configure.ac, clients/Makefile.am, tests/Makefile.am: refactor with
	  LIBSSL_CXXFLAGS [#1711, #1599]
	* conf/ups.conf.sample: clarify run-time group nuances [#3356]

=== 2026-03-21  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/nit.sh: adjust testcase expectations to possibility of
	  DUMMY_UPS_SWARM_COUNT>0 [#3302]
	* tests/NIT/nit.sh: bump MAXCONN in upsd.conf with non-trivial
	  DUMMY_UPS_SWARM_COUNT [#3302]
	* server/upsd.c: fix looping over more than MAXSYSCONN FDs [#3302]
	* tests/NIT/nit.sh: customize a short maxstartdelay=1 for upsdrvctl
	  [#3302]
	* drivers/upsdrvctl.c: more logging around forkexec() and
	  sleeps/waits involved [#3302]
	* tests/NIT/nit.sh, NEWS.adoc: add optional DUMMY_UPS_SWARM_COUNT
	  support to start hundreds of drivers to see what happens [#3302]
	* NEWS.adoc: fix typo
	* NEWS.adoc, docs/nut.dict: NEWS.adoc: Adjusted C\+\+ header search
	  path on Termux [#3353]
	* clients/nutclient.cpp, tests/cpputest-client.cpp: per CodeQL, "new"
	  may be toxic in this context [#1599, #3353]  Warning Incorrect
	  allocation-error handling This allocation cannot return null. This
	  check is unnecessary.  cpp/incorrect-allocation-error-handling:
	  Different overloads of the new operator handle allocation failures
	  in different ways. If new T fails for some type T, it throws a
	  std::bad_alloc exception, but new(std::nothrow) T returns a null
	  pointer. If the programmer does not use the corresponding method of
	  error handling, allocation failure may go unhandled and could cause
	  the program to behave in unexpected ways.
	* clients/nutclient.h: use a simpler way to construct SSLConfig* from
	  char* (even if nullptr) [#1599]
	* tests/cpputest-client.cpp: setupClientSSL(): avoid mixing char* and
	  std::string& [#1599, #1711]

=== 2026-03-20  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/cpputest-client.cpp: fix use of new SSLConfig_NSS() [#1599,
	  #1711]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: fix destructor for concrete SSLConfig
	  class [#1599]
	* clients/nutclient.cpp, clients/nutclient.h,
	  tests/cpputest-client.cpp: clients/nutclient.h,
	  tests/cpputest-client.cpp: hide
	  setSSLConfig_NSS()/setSSLConfig_OpenSSL() backend-specific methods
	  (APIs may evolve, SSLConfig classes should be more flexible)
	  [#1599, #1711]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: introduce the SSLConfig helper class
	  family to future-proof passing OpenSSL or NSS (or other backend)
	  options to TcpClient::setSSLConfig() and constructor [#1599]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: drop TcpClient constructors with a list
	  of options for (Open)SSL [#1599]
	* clients/nutclient.cpp, clients/nutclient.h, docs/man/Makefile.am,
	  docs/man/libnutclient_tcp.txt, tests/NIT/nit.sh,
	  tests/cpputest-client.cpp: clients/nutclient.{cpp,h}, docs, tests:
	  there is no separate CERTIDENT_PASS in NSS; there is a database
	  prefix however [#1599, #1711]
	* tests/Makefile.am: add LIBSSL_LIBS to consumers of libnutclient
	  [#1599, #1711]

=== 2026-03-19  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/Makefile.am: refactor with $(LIBNUTCLIENT_TCP_DEPS_SUB)
	  [#1599]
	* clients/nutclient.cpp: fix some NULL=>nullptr cases [#1599]
	* configure.ac: fix C\+\+ builds in Termux environment [#1599, #1711]
	  Inspired by https://github.com/termux/termux-packages/issues/23578
	  and https://github.com/termux/termux-packages/pulls/23579
	* docs/config-prereqs.txt: add openssl and nss tools as footprint for
	  Fedora 43 setup [#1711]
	* tests/NIT/nit.sh: abort if WITH_SSL_TESTS=required-conditional (and
	  NUT was built with SSL support) but needed third-party tooling was
	  not found for SSL setup [#1711]
	* tests/NIT/nit.sh, tests/NIT/Makefile.am: add support for
	  WITH_SSL_TESTS=required (to abort if NUT was built without SSL
	  support) [#1711]
	* tests/NIT/nit.sh: add localhost IP addresses as DNS.* aliases, for
	  older Python libs [#1711, #1600]
	* tests/NIT/nit.sh: use "openssl req -config" instead of "-extfile"
	  for self-signed CA cert [#1711]
	* tests/NIT/nit.sh, tests/NIT/Makefile.am: when generating test
	  certificates, exit() upon errors; invert
	  WITHOUT_SSL_TESTS=>WITH_SSL_TESTS with more options [#1711]
	  Support now `make check-NIT WITH_SSL_TESTS=required-conditional` to
	  fail fast if crypto material setup failed (ignored if built without
	  SSL).

=== 2026-03-18  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/Makefile.am: fix LIBNUTCLIENT_TCP_DEPS which can get
	  generated empty [#1599]
	* configure.ac, docs/configure.txt: configure.ac: support
	  --with-ssl=(nss\|openssl) as used in GitHub actions for a while but
	  in vain [#1711]
	* tests/NIT/nit.sh: setenv_ssl_python(): fix typos in message [#1600,
	  #1711]
	* tests/NIT/nit.sh: remove TESTCERT_PATHs before setting them up
	  [#1711]
	* tests/NIT/nit.sh: extend rootca.pem generation with common
	  extensions required nowadays by many crypto implementations [#1711]
	* scripts/python/module/test_nutclient.py.in: fix NUT_FORCESSL and
	  NUT_CERTVERIFY to accept numbers [#1711, #1600]
	* scripts/python/module/PyNUT.py.in,
	  scripts/python/module/test_nutclient.py.in:
	  scripts/python/module/*: introduce support for NUT_KEYPASS (envvar
	  and python OpenSSL handling) [#1600, #1711]
	* tests/NIT/nit.sh: setenv_ssl_python(): fix NUT_FORCESSL and
	  NUT_CERTVERIFY to be numbers [#1711, #1600]

=== 2026-03-17  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/nutclient.cpp, clients/nutclient.h, docs/man/Makefile.am,
	  docs/man/libnutclient_tcp.txt, tests/cpputest-client.cpp:
	  libnutclient (C\+\+): introduce key_pass and its OpenSSL handling;
	  separate config/autocall methods for OpenSSL and NSS [#1599, #1711]
	* tests/cpputest-client.cpp: ingest envvars for setSSLConfig_NSS()
	  [#1599, #1711]
	* tests/cpputest-client.cpp: refactor with setupClientSSL(); support
	  KEY_PASS [#1599, #1711]
	* tests/NIT/nit.sh: separate setenv_ssl_cppnit() from
	  setenv_ssl_python() [#1599, #1600, #1711]
	* clients/nutclient.cpp, clients/nutclient.h, docs/man/Makefile.am,
	  docs/man/libnutclient_tcp.txt: libnutclient (C\+\+): introduce
	  nutclient_tcp_get_ssl_caps() and TcpClient::getSslCaps() [#1599,
	  #1711]
	* tests/cpputest-client.cpp: report SSL setup before connection
	  attempt (which can throw exceptions) [#1599, #1711]
	* docs/man/Makefile.am, docs/man/libnutclient_tcp.txt, docs/nut.dict:
	  docs/man/Makefile.am, docs/man/libnutclient_tcp.txt: add basic
	  mention of new SSL-related methods [#1599]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: TcpClient: internally handle SSL-related
	  file fields as std::string, not char* [#1599]
	* clients/Makefile.am, clients/nutclient.cpp, clients/nutclient.h,
	  tests/Makefile.am: clients/nutclient.cpp: complete (more of) NSS
	  support [#1599]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: TcpClient: add individual setters for
	  SSL options [#1599]
	* tests/cpputest-client.cpp: update tests to match recent library
	  changes [#1599, #1711]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: add a TCPClient::connect() variant with
	  explicit try_ssl option [#1599]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: revise TCPClient constructor with
	  auto-connect, variant with SSL options, to include them all [#1599]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: rename use_ssl => try_ssl as sounds more
	  relevant [#1599]
	* clients/nutclient.cpp, clients/nutclient.h,
	  tests/cpputest-client.cpp: clients/nutclient.{cpp,h},
	  tests/cpputest-client.cpp: do not reset ssl options in
	  TcpClient::connect() [#1599, #1711]
	* clients/nutclient.cpp, clients/nutclient.h,
	  tests/cpputest-client.cpp: clients/nutclient.{cpp,h},
	  tests/cpputest-client.cpp: pass force_ssl as part of setSSLConfig()
	  [#1599, #1711]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: introduce SSLException* family for
	  startTLS() specific troubles [#1599]
	* clients/Makefile.am: bump libnutclient ABI version [#1599]
	* clients/nutclient.cpp: Socket::startTLS(): SSL args are only unused
	  in builds without SSL [#1599]
	* clients/nutclient.cpp: clients/nutclient.{cpp,h}: handle certverify
	  with NSS callbacks [#1599, #1711]
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{cpp,h}: add certverify to constructor and
	  connect() calls [#1599, #1711]
	* clients/nutclient.cpp, clients/nutclient.h,
	  tests/cpputest-client.cpp: clients/nutclient.{cpp,h},
	  tests/cpputest-client.cpp: add getters for SSL configuration,
	  report it in tests [#1711, #1599]
	* tests/NIT/nit.sh: use setenv_ssl_python() also for cppnit [#1711,
	  #1599]
	* tests/NIT/nit.sh: get_group_id(): always return a number (even if
	  -1)

=== 2026-03-16  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, clients/Makefile.am, clients/nutclient.cpp,
	  clients/nutclient.h, tests/cpputest-client.cpp: Introduce
	  libnutclient C\+\+ support for SSL (NUT STARTTLS) and tests [#1599,
	  #1711]
	* NEWS.adoc: document PyNUTClient extension to use STARTTLS and added
	  NIT tests [#1711, #3329, #1600]
	* tests/NIT/nit.sh: add SSL support into tests for PyNUTClient
	  [#1711, #1600]
	* scripts/python/module/PyNUT.py.in,
	  scripts/python/module/README.adoc,
	  scripts/python/module/test_nutclient.py.in:
	  scripts/python/module/*: add STARTTLS configurability (force,
	  verify, key/cert file locations) [#1711, #3329, #1600]
	* docs/nut.dict, scripts/python/module/PyNUT.py.in,
	  scripts/python/module/README.adoc,
	  scripts/python/module/test_nutclient.py.in:
	  scripts/python/module/*: add basic support for STARTTLS [#1711,
	  #3329, #1600]
	* tests/NIT/nit.sh: when providing rootca.pem as CERTHASH(.0)
	  file(s), fall back from symlink to hardlink to copy [#1711]
	* clients/upsclient.c, server/netssl.c: ssl_error(): return 0 for
	  retriable SSL_ERROR_WANT_{WRITE,READ}, log less loudly [#3331]
	* server/netssl.c, clients/upsclient.c: fix SSL read/write on
	  non-blocking sockets [#3331]  Apply same retry detection and loop
	  logic as for handshake; standardize on `SSL_IO_MAX_RETRIES`
	  constant name for these operations.
	* server/netssl.c: debug-log progress through ssl_init() and
	  ssl_cleanup(), and reasons to abort net_starttls()
	* drivers/libwinhid.c: fix use of usb_ctrl_char{,buf} instead of
	  unsigned char *, to match libusb{0,1} built alongside [#3335]

=== 2026-03-14  Jim Klimov <jimklimov+nut@gmail.com>

	* Jenkinsfile-dynamatrix: leave a commented-away toggle for
	  dynamatrixGlobalState.enableDebugTraceResolver

=== 2026-03-12  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/security.txt: refer to NIT script for practical setup of
	  OpenSSL/NSS CA and server/client certs [#3330]
	* NEWS.adoc: clarify that winhid backend is currently for read-only
	  operations [#3335]

=== 2026-03-10  Yifeng Li <tomli@tomli.me>

	* drivers/huawei-ups2000.c: huawei-ups2000: promote driver to
	  DRV_BETA.  huawei-ups2000 has served many users for 4 years,
	  multiple problems have been identified and fixed. It's now
	  appropriate to promote the driver's status to DRV_BETA.  Bump the
	  version number too although there's no code change to avoid
	  confusions, since development build with the DRV_EXPERIMENTAL flag
	  exists.

=== 2026-03-10  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/arduino-hid.c, drivers/belkin-hid.c,
	  drivers/powervar-hid.c: add debug-log about imposing non-default
	  USB endpoint/index settings [#2821]
	* drivers/belkin-hid.c, tests/getexponenttest-belkin-hid.c,
	  NEWS.adoc: default USB ID 10af:0002 to usb_hid_rep_index=1 [#3345]

=== 2026-03-09  Yifeng Li <tomli@tomli.me>

	* docs/man/huawei-ups2000.txt: huawei-ups2000.txt: document drivers
	  and fixed bugs.  This commit adds more information for
	  USB-to-serial driver installation, including Windows driver
	  requirements and URLs. All fixed historical bugs of huawei-ups2000
	  have also been recorded, which should help users to troubleshoot
	  their problems found in old versions of NUT.

=== 2026-03-09  Owen Li <admin@iloli.ch>

	* NEWS.adoc: Small change for news

=== 2026-03-08  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/Makefile.am: Revert "tests/NIT/Makefile.am: OpenSSL
	  remains flaky on many platforms, work on actual code may be needed
	  to rectify it after all [#3331, #1711]"  This reverts commit
	  af5da88033992f8c0d23e39c86bacf39c5cd7cae due to added support for
	  WANT_READ/WANT_WRITE in OpenSSL handshake.
	* NEWS.adoc, clients/upsclient.c, server/netssl.c: server/netssl.c,
	  clients/upsclient.c: fix SSL handshake on non-blocking sockets
	  [#3331]  The TLS handshake functions `SSL_accept()` (server) and
	  `SSL_connect()` (client) require a retry loop when the underlying
	  socket is in non-blocking mode.  When either function returns '-1'
	  with an error code of `SSL_ERROR_WANT_READ` or
	  `SSL_ERROR_WANT_WRITE`, it is signalling a non-fatal "not done yet"
	  condition: the handshake needs more I/O turns to complete.  The
	  correct response is to wait for the socket fd to become ready in
	  the indicated direction and then call the same function again with
	  the same SSL object (this is explicitly documented in OpenSSL for
	  every version since 0.9.x and the API contract has never changed).
	  Previously both call sites used a single-shot switch/case pattern
	  that treated these non-fatal WANT_READ/WANT_WRITE returns as fatal
	  errors, tearing down the connection immediately.  On Linux the
	  loopback socket is fast enough that the handshake *nearly always*
	  completes in the first call, masking the bug.  On BSD (FreeBSD,
	  OpenBSD, NetBSD), macOS, and illumos-based systems (OmniOS,
	  OpenIndiana) the loopback socket behaves differently and
	  WANT_READ/WANT_WRITE are returned regularly, causing CI failures on
	  all of those platforms regardless of compiler, C standard dialect,
	  or OpenSSL version used.  The fix is identical for all supported
	  OpenSSL versions (0.9.x / 1.0.x / 1.1.x / 3.x): the
	  `SSL_ERROR_WANT_*` codes and the required retry semantics have been
	  stable since the library's inception.  No NSS changes are needed:
	  NSS uses `SSL_ForceHandshake()` which is already blocking-by-design
	  through NSPR.  Fixes issues (re-)discovered and/or confirmed by
	  work on PR #3330 for issue
	  https://github.com/networkupstools/nut/issues/1711  Tested-on:
	  Linux (passes), macOS 12, FreeBSD 12, NetBSD 11, OpenBSD 6.5,
	  OmniOS (amd64\+i386), OpenIndiana (amd64+i386) - all compilers
	  and C standard dialects in the CI matrix. Co-authored-by: Claude
	  Sonnet 4.6

=== 2026-03-07  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsmon.c: track when previous loop cycle started [#1833]
	* docs/man/usbhid-ups.txt, docs/nut.dict, drivers/usbhid-ups.c:
	  drivers/usbhid-ups.c, docs: rename "experimentalhid" to "winhid"
	  [#3335]
	* NEWS.adoc, docs/nut.dict: add a news entry about WinHID backend
	  support for usbhid-ups [#3335]
	* clients/upsmon.c: report delta-time also in fallback logging
	  [#1833]
	* clients/upsmon.c: report time elapsed since previous loop cycle
	  start when we are processing OS wake-up after sleep [#1833]
	* clients/upsmon.c: log more visibly if we had a time-jump [#1833]
	* drivers/mge-hid.c: style typo fix
	* drivers/mge-hid.c: add outlet.3.* readings for devices that serve
	  them
	* Makefile.am: refactor generation of headers and their touchfiles
	  into a reusable goal; apply for faster `make check(-recursive)` and
	  `install(-recursive)` [#3039]
	* drivers/mge-hid.c: update comments about outlets/groups, fix an
	  apparent typo

=== 2026-03-06  Jim Klimov <jimklimov+nut@gmail.com>

	* common/Makefile.am: fix typo about common-nut_version.c hack
	  [#3330]

=== 2026-03-05  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/Makefile.am: fix dependency between upsclient.c and
	  nut_version.h [#3328]
	* clients/Makefile.am: libupsclient-version.h: sanity-check that
	  input file libupsclient.la exists and is not empty [#3330]

=== 2026-03-04  Owen Li <admin@iloli.ch>

	* docs/nut.dict: dict fix
	* docs/man/usbhid-ups.txt, drivers/libwinhid.c, drivers/libwinhid.h,
	  drivers/usbhid-ups.c: Code Refactor
	* drivers/libwinhid.c, drivers/libwinhid.h, drivers/usbhid-ups.c:
	  typo and indent fix, major enhancement on string descriptor reading

=== 2026-03-04  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, UPGRADING.adoc: update document intro paragraphs
	* Makefile.am: apply generated header touchfiles also to default
	  sequential `make all` [#3039]
	* Makefile.am: refactor generated header touchfiles into reusable
	  goals [#3039]
	* Makefile.am: libupsclient-version.h: fix typo for working subdir
	* include/Makefile.am: nut_version.h: do not skip if
	  NUT_VERSION_H_GENERATED==false even if touch-file exists [#3039]

=== 2026-03-03  Owen Li <admin@iloli.ch>

	* drivers/libwinhid.c, drivers/usbhid-ups.c: Add HidD_GetFeature Data
	  Processing, Padding under certain conditions, reorder HID parsing
	  index

=== 2026-03-03  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/snmp-ups.c: quiesce "Warning: type error exception ..." in
	  nut_snmp_get()=>nut_snmp_walk() when we fall back to using the
	  numeric value from last OID section [#1358]
	* drivers/snmp-ups.c: nut_snmp_walk(): log status and
	  response->errstat also (especially) when snmp_synch_response()
	  failed [#1358]
	* NEWS.adoc, docs/nut.dict, drivers/snmp-ups.c: drivers/snmp-ups.c,
	  NEWS.adoc: quiesce "unhandled ASN 0x80 received from ..." when we
	  fall back to using the numeric value from last OID section [#1358]
	* drivers/snmp-ups.h: rephrase comment for SU_FLAG_MAPPING_HANDLED
	  [#3095]
	* Makefile.am, clients/.gitignore, clients/Makefile.am:
	  clients/Makefile.am: do not regenerate libupsclient-version.h each
	  time we evaluate libupsclient.la rule [#3039, #3223, #1484]
	* Makefile.am, include/.gitignore, include/Makefile.am: Makefile.am,
	  include/Makefile.am: introduce
	  include/.all.nut_version-generated.timestamp touch-file to quickly
	  skip nut_version.h regeneration even if we configure
	  --enable-force-nut-version (default) [#3039, #3223]
	* Makefile.am: rearrange *CLEANFILES to be initialized on top of file
	  and added to along the way

=== 2026-03-02  Owen Li <admin@iloli.ch>

	* drivers/Makefile.am, drivers/libwinhid.c, drivers/libwinhid.h,
	  drivers/usbhid-ups.c: init version of POC

=== 2026-03-02  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/Makefile.am: OpenSSL remains flaky on many platforms,
	  work on actual code may be needed to rectify it after all [#3331,
	  #1711]
	* server/netssl.c: revise comments/indentations of #ifdef et al, and
	  coding style [#3328]
	* conf/upsstats-modern-single.html.sample.in, docs/nut.dict: complete
	  the CSS/JS graph auto-adjustment to voltage/temperature scales
	  [#3318]
	* clients/upsstats.c, docs/man/upsstats.html.txt: add support for
	  @IFEQ upsstats.use_celsius (0\|1)@ [#3318]

=== 2026-03-01  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/Makefile.am: re-allow running OpenSSL tests by default
	  [#1711]
	* tests/NIT/nit.sh: fix use of CERTPATH with OpenSSL tests [#1711]
	* clients/upsclient.c: report in log if Certificate verification (by
	  client) succeeded [#1711]
	* tests/NIT/nit.sh: disable NUT_QUIET_INIT_SSL when we actually test
	  SSL [#1711]
	* appveyor.yml: pass NUT_SSL_VARIANTS=nss to the builds, so we have
	  some known-functional SSL support in the NUT for Windows pre-built
	  tarballs [#3328, #1711]
	* ci_build.sh, scripts/Windows/build-mingw-nut.sh, NEWS.adoc:
	  introduce more generally useful support for NUT_SSL_VARIANTS
	  [#1711]
	* common/common-nut_version.c: add comments to clarify
	  LIBNUTPRIVATE_UPS_VERSION vs UPS_VERSION [#2800]
	* m4/ax_c_pragmas.m4, drivers/main.c: handle "-Wmissing-braces" for
	  upsdrv_callback_t init [#2800]

=== 2026-02-28  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/security.txt, docs/nut.dict: add a note on checking SSL
	  support in run-time build of NUT [#3328]
	* tests/NIT/Makefile.am: default to run WITHOUT_SSL_TESTS for OpenSSL
	  builds [#1711, #3331]
	* tests/NIT/nit.sh: add a way to run WITHOUT_SSL_TESTS on platforms
	  known to currently fail them [#1711]
	* tests/NIT/nit.sh: fix running OpenSSL tests on Windows [#1711]
	  Avoid MSYS2 mangling of cert request subject separated by slashes
	  as if it were a Unix-style path, before it even gets to `openssl`.
	* clients/upsc.c, clients/upscmd.c, clients/upsimage.c,
	  clients/upslog.c, clients/upsrw.c, clients/upsset.c,
	  clients/upsstats.c, drivers/dummy-ups.c,
	  tools/nut-scanner/scan_nut.c: clients/*.c, drivers/dummy-ups.c,
	  tools/nut-scanner/scan_nut.c: fix libupsclient consumers to use
	  upscli_set_debug_level() where available [#1711, #2800, #3330]
	* clients/upsmon.c: use `upscli_set_debug_level(nut_debug_level)`
	  wherever we change nut_debug_level [#1711, #2800, #3330]
	* NEWS.adoc, UPGRADING.adoc, clients/Makefile.am,
	  clients/upsclient.c, clients/upsclient.h, docs/man/Makefile.am,
	  docs/man/upscli_set_debug_level.txt, docs/nut.dict:
	  clients/upsclient.{c,h}, docs: introduce upscli_set_debug_level()
	  and a getter to fix shared-private-library builds [#2800, #1711]
	  Surprise (not really, had similar with libnutscanner, but solved
	  differently) - at least WIN32 builds require that all symbols are
	  inside a library we build, so tend to include the binary code
	  regardless of sort-of-shared linking. As the result, we end up
	  linking upsmon etc. with two DLL libraries each carrying its
	  nut_debug_level (and methods that work with it).
	* appveyor.yml: enable possibility of NSS builds (and confirm
	  OpenSSL) for Windows with Appveyor CI [#1711]
	* Makefile.am, clients/Makefile.am, drivers/Makefile.am,
	  tools/nut-scanner/Makefile.am, tools/nutconf/Makefile.am:
	  */Makefile.am: revise libupsclient* dependencies to honour
	  ENABLE_SHARED_PRIVATE_LIBS [#2800, #3328]  In some builds,
	  nut_debug_level of the client program and the library was different
	  because it was not dynamically linked to private properly.
	  drivers/Makefile.am: rectify dependencies using libcommonclient.la
	* include/common.h: indent #ifdef contents
	* docs/config-prereqs.txt: add a reason for "fightwarn" branch
	  mention

=== 2026-02-27  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/nit.sh: adjust TESTCERT_PATH_* to WIN32 runs if needed
	  [#1711]
	* clients/upsclient.c: upscli_strerror(): revise failure logging with
	  NSS [#1711, #3329]  The NSS library can return error codes with
	  empty strings attached, log some reasonable info then.
	* clients/upsc.c: revise failure logging [#1711]
	* server/netssl.c: net_starttls(): reject clients without any cert if
	  WITH_CLIENT_CERTIFICATE_VALIDATION earlier and more visibly [#3329]
	* server/upsd.c: mainloop(POSIX): log in more detail why we
	  disconnect a socket [#1711]
	* docs/config-prereqs.txt: add packages for `openssl` and `certutil`
	  where currently missing, to NIT-test SSL support on as many
	  platforms as we can [#1711]

=== 2026-02-26  Owen Li <admin@iloli.ch>

	* drivers/apcsmart.c: quick change to make codescan happy

=== 2026-02-26  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, conf/upsd.conf.sample, docs/man/upsd.conf.txt,
	  docs/security.txt, server/conf.c, server/netssl.c: server/conf.c
	  and docs: Extended processing of `CERTREQUEST` setting to handle
	  numeric or specific string values, to match both ways of reading
	  ambiguous documentation [#3330]
	* NEWS.adoc, conf/upsd.conf.sample, configure.ac, docs/configure.txt,
	  docs/man/upsd.conf.txt, docs/security.txt: configure.ac and docs:
	  introduce --with-ssl-client-validation option [#3330, #3329]
	* tests/NIT/nit.sh: leave a commented stub for OpenSSL SSL_CERT_DIR
	  hackery [#1711]
	* tests/NIT/nit.sh: fix running as a script from root or tests
	  directory [#3294]
	* tests/NIT/nit.sh: add server/client-side SSL configs for tests with
	  upsd-client interaction [#3328, #1711]
	* tests/NIT/nit.sh: populate OpenSSL and/or Mozilla NSS keystores if
	  we can test those [#3328, #1711]
	* tests/NIT/nit.sh: generatecfg_upsd_add_SSL(),
	  generatecfg_upsmon_add_SSL(): cross-link server/client capabilities
	  to set expectations in configs [#3328, #1711]
	* tests/NIT/nit.sh: SSL tests: check for presence of third-party
	  tooling to manipulate the crypto credential stores [#3328, #1711]
	* drivers/main.h: upsdrv_callbacks: document the macros [#2800]
	* drivers/main.h: upsdrv_callbacks: move magic to start of struct
	  [#2800]
	* drivers/main.h: upsdrv_callbacks: we now have in fact 16 not 9
	  pointers passed [#2800]
	* conf/upsd.conf.sample, docs/security.txt: fix typos
	* data/driver.list.in: Moved new Accurat entry aplhanumerically,
	  fenced by blank lines [#3323]

=== 2026-02-25  Owen Li <admin@iloli.ch>

	* drivers/apcsmart.c, drivers/apcsmart_tabs.c,
	  drivers/apcsmart_tabs.h: Update for versioning and author info
	* drivers/apcsmart.c, drivers/apcsmart_tabs.c,
	  drivers/apcsmart_tabs.h: Add support for dual-byte command

=== 2026-02-25  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/nit.sh, NEWS.adoc: introduce generation of upsmon/upsd
	  configs for SSL test cases [#3328, #1711]
	* tests/NIT/nit.sh: detect run-time behavior of WITH_SSL* in built
	  clients and server programs [#3328, #1711]
	* clients/upsclient.c, conf/upsmon.conf.sample.in,
	  docs/man/upsmon.conf.txt: debug-log methods called which are no-op
	  in current build and document keywords which would be no-op in some
	  cases [#3328]
	* clients/upsclient.c: upscli_sslinit(): condense WITH_SSL/!WITH_SSL
	  into one method body code [#3328]
	* clients/upsclient.c: also report NUT source version the library was
	  built from [#3328]
	* clients/upsclient.c: revise comments/indentations of #ifdef et al
	  [#3328]
	* clients/upsstats.c: introduce
	  DEFAULT_TEMPLATE_SINGLE\+DEFAULT_TEMPLATE_LIST macros for a single
	  point of config [#3316]
	* docs/download.txt: NUT for Windows builds: note about compressing
	  the unpacked location
	* docs/download.txt: NUT for Windows builds: note about the unpacked
	  location (any)

=== 2026-02-21  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, UPGRADING.adoc, clients/upsc.c, clients/upsclient.c,
	  clients/upsclient.h, clients/upscmd.c, clients/upslog.c,
	  clients/upsmon.c, clients/upsrw.c, docs/man/Makefile.am,
	  docs/man/upscli_add_host_cert.txt, docs/man/upscli_init.txt,
	  docs/man/upscli_report_build_details.txt, docs/man/upscli_ssl.txt,
	  docs/man/upscli_ssl_caps.txt, docs/nut.dict, drivers/dummy-ups.c,
	  server/netssl.c, server/netssl.h, server/upsd.c,
	  tools/nut-scanner/scan_nut.c: Introduce and use methods to query
	  and report SSL support in libupsclient, its consumers, and upsd
	  [#3328]

=== 2026-02-14  lvl47 <43710193+lvl47@users.noreply.github.com>

	* data/driver.list.in: Update data/driver.list.in: add Accurat Flux
	  {empty}850 (Richcomm V2.0)  Add Accurat Flux 850 (850VA/510W) to the
	  Hardware Compatibility List.  This Line-Interactive UPS uses the
	  Richcomm V2.0 chipset (USB ID 0925:1234)  and works with nutdrv_qx
	  using the armac subdriver and megatec protocol. Requires NUT >=
	  {empty}2.8.2 (armac subdriver incomplete in 2.8.0).  Accurat is a brand of
	  batterium GmbH (Germany), sold primarily via Amazon EU. The chipset
	  is identical to Vultech UPS2000VA-PRO discussed in #2738.  Tested
	  on Debian Bookworm (OMV 7.x) with NUT v2.8.5-rc4 from git master.

=== 2026-02-14  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/images/nut-squared.svg: add a margin-less version of NUT logo

=== 2026-02-13  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/nut.txt: old asciidoc variable "unset" only works with
	  trailing exclamation mark

=== 2026-02-12  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, common/common.c, drivers/adelsystem_cbi.c,
	  drivers/generic_modbus.c, include/common.h: common/common.c,
	  include/common.h, drivers/adelsystem_cbi.c,
	  drivers/generic_modbus.c: generalize elapsed_since_timeval()
	  [#1938]  Closes: #1938  Co-authored-by: Dimitris Economou
	  <dimitris.s.economou@gmail.com>
	* clients/upsstats.c: display_tree(): drop spurious <br> at end of
	  table data cell [#3316]

=== 2026-02-11  Jim Klimov <jimklimov+nut@gmail.com>

	* conf/upsstats-modern-single.html.sample.in: use spaces for
	  separators between STATUS values (if many) [#3316]
	* conf/upsstats-modern-list.html.sample.in,
	  conf/upsstats-modern-single.html.sample.in:
	  conf/upsstats-modern-*.in: reconcile styles between two templates
	  [#3316]
	* conf/upsstats-modern-list.html.sample.in,
	  conf/upsstats-modern-single.html.sample.in, docs/nut.dict:
	  conf/upsstats-modern-*.in: align with legacy templates [#3316]
	  Notably variations about three-phase inputs/outputs.
	* conf/upsstats-modern-list.html.sample.in,
	  conf/upsstats-modern-single.html.sample.in:
	  conf/upsstats-modern-*.in: reduce kilobytage by dropping most of
	  indentation [#3316]  Should also help comparing with legacy
	  templates and between these two.
	* NEWS.adoc, clients/upsstats.c, docs/man/upsstats.html.txt:
	  clients/upsstats.c, docs/man/upsstats.html.txt: extend @STATUS@ to
	  inject any separators, not only <br/> [#3316]  Keep <br/> as legacy
	  default, to work with older upsstats*.html templates.  Closes:
	  #2525
	* conf/upsstats.html.sample.in: drop duplicate @REFRESH@ directive
	  [#3316]

=== 2026-02-11  Author: jawz101 <jawz101@users.noreply.github.com>

	* NEWS.adoc, conf/.gitignore, conf/Makefile.am,
	  conf/hosts.conf.sample, conf/upsstats-modern-list.html.sample.in,
	  conf/upsstats-modern-single.html.sample.in, configure.ac,
	  data/htmlcgi/header.html.in, docs/nut.dict: Introduce
	  upsstats-modern-list.html.sample.in
	  upsstats-modern-single.html.sample.in [#3316]

=== 2026-02-10  Jim Klimov <jimklimov+nut@gmail.com>

	* configure.ac: when falling back to can_install_doc_man=yes do also
	  try to touch the artifacts as when we do upon deliberate choice
	  [#3314]
	* configure.ac: note more visibly that we can fall back to
	  dist-tarball pre-built pages when we have only them and want
	  something installed [#3314]  NOTE: want_disted_doc_man=yes is set
	  lower in code, hopefully we do reach that part; else have inputs
	  for troubleshooting the recipes.
	* configure.ac: comment the trouble with automating Solaris man
	  section layout when we only use dist-tarball pre-built pages
	  [#3314]
	* configure.ac: refer to docs with Solaris man section layout [#3314]

=== 2026-02-09  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/Windows/wininit.c, NEWS.adoc, docs/man/nut.exe.txt: support
	  exiting from "nut.exe -N" with Ctrl\+C [#3312]
	* clients/upsstats.c: display_template(): if rejecting a file, or
	  after other errors, use HTML <BR/> tags in the printout (especially
	  if debug is on) [#2524]
	* NEWS.adoc, clients/upsstats.c, conf/hosts.conf.sample,
	  docs/man/hosts.conf.txt, docs/man/upsstats.cgi.txt: Introduce
	  CUSTOM_TEMPLATE_LIST and CUSTOM_TEMPLATE_SINGLE settings in NUT CGI
	  hosts.conf to constrain the permitted custom HTML template file
	  names to a set that admins intend to use [#2524]
	* clients/upsstats.c: do_*link*() methods: err on the safe side and
	  NULL-check the template_list/single vars before comparing strings
	  [#2524]
	* clients/cgilib.c: extractcgiargs(): fix processing of query strings
	  with flag tokens (no assignment) in the middle, not at end [#2524]
	* clients/upsset.c: use "Pragma: no-cache" HTTP header as in
	  upsstats.cgi [#2524]
	* clients/upsimage.c, clients/upsset.c, clients/upsstats.c:
	  clients/ups{image,set,stats}.c: introduce support for
	  browser-friendly logging in NUT CGI programs (in developer build
	  and/or command-line runs) [#2524]
	* common/common.c, include/common.h: introduce UPSLOG_STDOUT bit and
	  support in vupslog(), and cgilogbit_set() for browser-friendly
	  logging in NUT CGI programs [#2524]
	* clients/upsclient.c: fix void* casting for a NSS build [#3311]
	* docs/download.txt: link to "Finding recent development iteration
	  artifacts" wiki page
	* clients/cgilib.c: debug-trace also extractcgiargs() with what
	  query-string text we pass into caller parsearg() implementations
	  [#2524, #3219]

=== 2026-02-08  darkglade <35511291+darkglade@users.noreply.github.com>

	* scripts/subdriver/gen-snmp-subdriver.sh: Fix hang in
	  gen-snmp-subdriver.sh  Fix an issue introduced in commit 8b038f4
	  whereby grep-snmp-subdriver.sh hangs indefinitely.  Issue
	  https://github.com/networkupstools/nut/issues/3308

=== 2026-02-08  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, tools/nut-scanner/scan_avahi.c,
	  tools/nut-scanner/scan_ipmi.c, tools/nut-scanner/scan_nut.c,
	  tools/nut-scanner/scan_snmp.c, tools/nut-scanner/scan_upower.c,
	  tools/nut-scanner/scan_usb.c, tools/nut-scanner/scan_xml_http.c:
	  tools/nut-scanner/scan_*.c, NEWS.adoc: track seeked symbols to know
	  where import failed [#3310]
	* tests/generic_gpio_liblocal.c: gpiod_line_request_get_values(): do
	  not assign plain number to enum variables [#3297]
	* drivers/nutdrv_qx_voltronic-axpert.c: fix more casting from
	  xcalloc() et al [#3297]
	* drivers/generic_gpio_common.c, drivers/generic_gpio_libgpiod.c,
	  tests/generic_gpio_utest.c: fix more casting from xcalloc() et al
	  [#3297]
	* docs/config-prereqs.txt, docs/nut.dict: update for Fedora 43
	  [#3311]
	* scripts/python/module/setup.py.in: try to actually catch warnings
	  (e.g. DeprecationWarning) to use correct form of open() [#3256]
	* scripts/augeas/gen-nutupsconf-aug.py.in: fix ResourceWarnings about
	  unclosed file descriptors [#3256]
	* scripts/augeas/gen-nutupsconf-aug.py.in: try to actually catch
	  warnings (e.g. DeprecationWarning) to use correct form of open()
	  [#3256]
	* tools/nut-scanner/scan_upower.c: drop unused import of
	  "g_variant_get()" [#3293]
	* server/upsd.c, NEWS.adoc, docs/nut.dict: update_sysmaxconn():
	  support NUT_SYSMAXCONN_LIMIT envvar to tweak [#3302]
	* server/upsd.c: mainloop(): only log warnings if nfds_wanted >
	  maxconn (equality should be ok) [#3302]
	* server/upsd.c: mainloop(): debug-log chunking details [#3302]
	* server/upsd.c: refactor with one update_sysmaxconn() implementation
	  [#3302]
	* common/common.c: vupslog(): use a larger initial buffer
	* drivers/upsdrvctl.c: forkexec(): double-quote the WIN32 argv[0] in
	  commandline [#3294, #3305]  Closes: #3305
	* drivers/upsdrvctl.c: forkexec(): double-quote the WIN32 argv[0] in
	  commandline [#3294, #3305]  Closes: #3305

=== 2026-02-06  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsstats.c, docs/man/upsstats.cgi.txt, NEWS.adoc: support
	  providing CGI options for alternate template file names (co-located
	  with original ones) [#2524, #3304]
	* server/upsd.c, docs/man/upsd.conf.txt, conf/upsd.conf.sample,
	  NEWS.adoc: track "sysmaxconn" not as a reason to fail data server
	  configuration, but to chunk the MAXCONN-sized array processing into
	  several smaller polls as needed [#3302]
	* clients/upsstats.c: parameterize template_single and template_list
	  filenames with legacy defaults [#2524]
	* clients/upsimage.c, clients/upsset.c, clients/upsstats.c: fix
	  indentation for recent fixes and update (C) heading [#3219]
	* .github/workflows/08-PyNUTClient.yml: do not let @dotMAKE@ get in
	  our way here [#3300]  NOTE: We were running Makefile.am previously
	  directly as a makefile for PyPI publishing; now a slightly
	  transformed version of it.
	* configure.ac: avoid AM_COND_IF absent in older aclocal builds
	  [#3300]
	* tools/nut-scanner/scan_nut.c: debug-trace what in upscli failed
	  [#3300]
	* tools/gitlog2version.sh: fix for git describe versions before
	  --exclude option [#3300]
	* tools/nut-scanner/scan_usb.c: do not call libusb_exit() after a
	  failed libusb_init() on libusb older than 1.0.24 [#3300]
	* common/common.c: fix freeing of dynamically detected search_paths
	  after fixing use of realpath() to use our buffer [#3300]
	* configure.ac: avoid reporting "Whether to enable support for
	  parallelization of some tools" twice [#3300]
	* configure.ac: better detect HAVE_SEMAPHORE_LIBS (even if we do not
	  need to link anything additional) [#3300]
	* tools/nut-scanner/scan_nut_simulation.c: use "#ifdef HAVE_PTHREAD"
	  consistently with other code [#3300]

=== 2026-02-05  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c: refine deliberate logging without PRIuSIZE in
	  nut_prepare_search_paths() [#3300]
	* docs/nut.dict: update the dictionary [#3300]
	* common/common.c: vupslog(): be conservative about growing our
	  buffer, most logs are short
	* common/common.c: get_libname_in_*(): use NUT_STRARG() when logging
	  strings
	* common/common.c: nut_prepare_search_paths(): some systems require
	  non-NULL args to realpath(), provide the buffer and handle errors
	  better
	* common/common.c: nut_prepare_search_paths(): separate logging from
	  index increment
	* common/common.c: nut_prepare_search_paths(): debug more about
	  progressing through the arrays
	* configure.ac, include/nut_stdint.h, NEWS.adoc: actually detect
	  support for (C99\+) printf("%zu") et al  It seems Solaris 8
	  struggles with the lack of it, so formatting strings get skewed
	* drivers/ydn23.h: fix printing of "%zu" with PRIuSIZE
	* NEWS.adoc, UPGRADING.adoc, configure.ac, docs/configure.txt,
	  tools/nut-scanner/Makefile.am, tools/nut-scanner/nut-scan.h,
	  tools/nut-scanner/nut-scanner.c,
	  tools/nut-scanner/scan_eaton_serial.c: configure.ac,
	  tools/nut-scanner/nut-scan.h, tools/nut-scanner/Makefile.am,
	  docs/configure.txt, NEWS.adoc, UPGRADING.adoc: Added an option to
	  (primarily) `--disable-threading` [#3300]  Can be useful for
	  systems with broken libraries, as well as for CI testing of
	  sequential implementation on build systems WITH threading support
	  available (and until now unavoidable then).  This commit also fixes
	  problems found when trying such a build.
	* scripts/Windows/Installer/NUT-Installer.xml.in: ensure a newline at
	  end of file (some SEDs complain)
	* configure.ac: rectify handling of nut_with_confdir [#3131]
	* drivers/vertiv-mib.c: refine code markup after another round of AI
	  changes [#3299]

=== 2026-02-04  jawz101 <jawz101@users.noreply.github.com>

	* drivers/vertiv-mib.c: vertiv-mib: fix ID strings and implement
	  high-precision OIDs for PSI5

=== 2026-02-04  Jim Klimov <jimklimov+nut@gmail.com>

	* .gitignore: GitIgnore "tags" files left over by (probably) bmake
	* Makefile.am, NEWS.adoc, clients/Makefile.am, common/Makefile.am,
	  conf/Makefile.am, configure.ac, data/Makefile.am,
	  data/htmlcgi/Makefile.am, docs/Makefile.am, docs/man/Makefile.am,
	  drivers/Makefile.am, scripts/Makefile.am,
	  scripts/Solaris/Makefile.am, scripts/Windows/Makefile.am,
	  scripts/devd/Makefile.am, scripts/external_apis/Makefile.am,
	  scripts/hotplug/Makefile.am, scripts/installer/Makefile.am,
	  scripts/obs/Makefile.am, scripts/python/Makefile.am,
	  scripts/python/module/Makefile.am, scripts/systemd/Makefile.am,
	  scripts/udev/Makefile.am, scripts/upsdrvsvcctl/Makefile.am,
	  server/Makefile.am, tests/Makefile.am, tests/NIT/Makefile.am,
	  tools/nut-scanner/Makefile.am, tools/nutconf/Makefile.am:
	  configure.ac, Makefile.am, NEWS.adoc: mark goals which expand
	  SUBDIR_TGT_RULE with explicit .MAKE pseudo-target [#3300]  The BSD
	  make as of NetBSD 11 (Beta) updates gets confused about sub-calls
	  to $(MAKE) with respective $(MAKEFLAGS) passed to it with our
	  parallel build scripting, despite the standard "\+" prefix to
	  commands in the caller. An explicit pseudo-target seems to help
	  quiesce the warnings (and hopefully rectify the practical
	  handling).  Co-authored-by: Greg Troxel <gdt@lexort.com>
	* scripts/python/module/Makefile.am: better indent multi-line rules
	* Makefile.am: package: should not depend on "dist" to package up
	  "all" the already-built artefacts  Thanks to Lee Damon for the
	  heads-up
	* Makefile.am: SET_PARMAKES_OPT snippet should not have started with
	  "\+@" (was a goal body before)
	* scripts/augeas/gen-nutupsconf-aug.py.in,
	  scripts/python/module/setup.py.in: fix codecs.open() deprecation
	  warning (3.14\+) [#3256]  Co-Authored-by: Paul Donald
	  <newtwen\+github@gmail.com>
	* drivers/upsdrvctl.c: forkexec() WIN32: refine ability to
	  CreateProcess() for the driver in build workspace, not only in
	  final installation [#3294]
	* tests/NIT/nit.sh: use windows-style backslashes if the rest of
	  driverpath uses them [#3294]
	* configure.ac: refine reporting of GPIO_VERSION when there is none
	* docs/config-prereqs.txt: update instructions for NetBSD 11.0 (Beta)
	* drivers/upsdrvctl.c: use windows-style backslashes if the rest of
	  driverpath uses them [#3294]
	* drivers/vertiv-mib.c: refine ups.status [#3299]
	* drivers/vertiv-mib.c: refine beeper status vs. cmd [#3299]
	* NEWS.adoc, data/driver.list.in: update regarding Vertiv/Liebert MIB
	  [#3299]
	* drivers/Makefile.am, drivers/snmp-ups.c, drivers/{vertiv-psi5-mib.c
	  => vertiv-mib.c}, drivers/{vertiv-psi5-mib.h => vertiv-mib.h}:
	  drivers/vertiv-*: generalize to "vertiv" MIB, this is not PSI5
	  specific [#3299]
	* drivers/vertiv-psi5-mib.c: reconcile new round of changes with
	  older iteration (SU_FLAG* values, IETF identification) [#3299]

=== 2026-02-03  jawz101 <jawz101@users.noreply.github.com>

	* drivers/vertiv-psi5-mib.c: Update Vertiv PSI5 MIB version and OIDs
	  Updated the version number and modified SNMP OIDs for device
	  monitoring and alarms.

=== 2026-02-03  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, docs/nut.dict, drivers/vertiv-psi5-mib.c,
	  drivers/vertiv-psi5-mib.h: drivers/vertiv-psi5-mib.{c,h},
	  NEWS.adoc: fix to actually compile [#3299]
	* m4/ax_realpath_lib.m4, NEWS.adoc, docs/nut.dict: retry by calling
	  linker or compiler with the library paths and link name, to derive
	  the path from error messages [#2431]
	* m4/ax_realpath_lib.m4: refactor with LIBRARY_PATH; clean up after
	  ourselves [#2431]
	* drivers/vertiv-psi5-mib.c, drivers/vertiv-psi5-mib.h:
	  drivers/vertiv-psi5-mib.{c,h}: fix markup and (C) headers, include
	  "main.h" missed before [#3299]
	* configure.ac: simplify checks for UPower driver and nut-scanner
	  support [#3293]

=== 2026-02-02  jawz101 <jawz101@users.noreply.github.com>

	* drivers/vertiv-psi5-mib.c: Enhance Vertiv PSI5 MIB with control
	  features  Added shutdown and start delay control for UPS.
	* drivers/snmp-ups.c: Bump driver version to 1.39
	* drivers/Makefile.am, drivers/vertiv-psi5-mib.c,
	  drivers/vertiv-psi5-mib.h: squash vertiv commits  * add c & h
	  driver files  * Add files via upload  * Add vertiv-psi5-mib.c to
	  Makefile.am  * Add vertiv-psi5-mib.h to Makefile.am
	* drivers/snmp-ups.c: Add support for Vertiv PSI5 MIB

=== 2026-02-02  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/obs/debian.cdbs-autotools.mk, scripts/obs/debian.rules:
	  scripts/obs/debian.rules: stash a copy of CDBS autotools.mk to
	  include if the real thing is not available [#1209]
	* scripts/obs/debian.rules: make "autotools.mk" inclusion optional
	  (Debian Testing in Jan/Feb 2026 seems to lack it) [#1209]
	* tools/nut-scanner/scan_upower.c: apply simpler indentation [#3293]
	* tools/nut-scanner/scan_upower.c: apply fixes about use of
	  `(lt_dlhandle)1` instead of `(void *)1` [#3293]
	* tools/nut-scanner/nutscan-init.c: comment the situation about many
	  libs related to UPower where we only load one for scanning [#3293]
	* NEWS.adoc: move nut-scanner UPower support notice into the
	  `nut-scanner` tool section [#3293]
	* tools/nut-scanner/scan_upower.c: tools/nut-scanner/*.c: be stricter
	  about "ifdef WITH_SOME_NUT_FEATURE" (we may have some defined but
	  zeroed, so not active for a build) [#3293]
	* clients/upsimagearg.h, drivers/apcsmart-old.h, drivers/metasys.c,
	  drivers/usb-common.h: *.{c,h}: rectify more indentations and
	  line-wrapping in block comments
	* tools/nut-scanner/scan_ipmi.c, tools/nut-scanner/scan_nut.c,
	  tools/nut-scanner/scan_snmp.c, tools/nut-scanner/scan_usb.c,
	  tools/nut-scanner/scan_xml_http.c: tools/nut-scanner/scan_*.c: fix
	  more inconsistent indentations
	* tools/nut-scanner/scan_ipmi.c: uncomment code block that detects
	  "No IPMI on this host" to report the message
	* tools/nut-scanner/nutscan-init.c, tools/nut-scanner/scan_avahi.c,
	  tools/nut-scanner/scan_ipmi.c, tools/nut-scanner/scan_nut.c,
	  tools/nut-scanner/scan_snmp.c, tools/nut-scanner/scan_usb.c,
	  tools/nut-scanner/scan_xml_http.c: tools/nut-scanner/*.c: use
	  `(lt_dlhandle)1` casting instead of `(void *)1` also in comparisons
	* drivers/mge-hid.c: add a note about using enum value in sentinel
	  for mge_model_names[] [#3293]
	* server/upsd.c: add a comment to FTS_T *fds [#3293]  Bonus question:
	  what could Gemini mean by "FTS"?..
	* drivers/nutdrv_qx.c: revert bogus change to qx_process() error
	  handling of xmalloc() [#3293]
	* drivers/libshut.c, drivers/netxml-ups.c: standardize on "try_num"
	  as the iteration variable name
	* clients/upsmon.c: there is little point checking configfile for
	  non-NULLness at the beginning of main() [#3293]
	* clients/upsmon.c: indent back a block of code changed by the PR
	  [#3293]
	* clients/cgilib.c, clients/upsc.c, clients/upsclient.c,
	  clients/upscmd.c, clients/upslog.c, clients/upsmon.c,
	  clients/upsrw.c, clients/upsset.c, common/common.c,
	  common/strptime.c, common/wincompat.c, drivers/adelsystem_cbi.c,
	  drivers/adelsystem_cbi.h, drivers/al175.c, drivers/apc-hid.c,
	  drivers/apcsmart-old.c, drivers/apcsmart.c, drivers/bcmxcp.c,
	  drivers/bcmxcp_usb.c, drivers/belkinunv.c, drivers/bestfortress.c,
	  drivers/bicker_ser.c, drivers/clone-outlet.c, drivers/dstate.c,
	  drivers/eaton-pdu-marlin-mib.c, drivers/everups.c,
	  drivers/generic_gpio_libgpiod.c, drivers/generic_modbus.c,
	  drivers/genericups.c, drivers/hpe-pdu-mib.c,
	  drivers/huawei-ups2000.c, drivers/libshut.c, drivers/macosx-ups.c,
	  drivers/mge-utalk.c, drivers/microdowell.c, drivers/microsol-apc.h,
	  drivers/nut-ipmipsu.c, drivers/nut-libfreeipmi.c,
	  drivers/nut-upower.c, drivers/nutdrv_hashx.c, drivers/nutdrv_qx.c,
	  drivers/optiups.c, drivers/pijuice.c, drivers/powercom.c,
	  drivers/richcomm_usb.c, drivers/riello_ser.c, drivers/skel.c,
	  drivers/snmp-ups.c, drivers/snmp-ups.h, drivers/socomec_jbus.c,
	  drivers/solis.c, drivers/tripplite-hid.c, drivers/tripplite_usb.c,
	  drivers/tripplitesu.c, drivers/upsdrvctl.c, drivers/upshandler.h,
	  drivers/usb-common.c, drivers/usb-common.h, drivers/ydn23.h,
	  include/common.h, server/conf.c, server/netlist.c, server/upsd.c,
	  tests/generic_gpio_liblocal.c, tools/nut-scanner/nut-scanner.c,
	  tools/nut-scanner/nutscan-ip.c, tools/nut-scanner/scan_avahi.c,
	  tools/nut-scanner/scan_ipmi.c, tools/nut-scanner/scan_snmp.c,
	  tools/nut-scanner/scan_usb.c, tools/nut-scanner/scan_xml_http.c:
	  *.{c,h}: rectify indentations and line-wrapping in general code
	  structure and method arguments
	* drivers/apc_modbus.c: bump DRIVER_VERSION due to refined setting of
	  mapping table entry types etc. via enum values [#3293]
	* NEWS.adoc: note the pointer-casting refinement [#3293]  Kudos to
	  Tim Niemueller, Gemini, and clang-21 extended warnings.
	* NEWS.adoc: fix the entry for tripplitesu [#3273]
	* drivers/apcsmart-old.c: fix git merging typo
	* tools/nut-scanner/nut-scan.h, tools/nut-scanner/nutscan-init.c,
	  tools/nut-scanner/scan_avahi.c, tools/nut-scanner/scan_ipmi.c,
	  tools/nut-scanner/scan_snmp.c, tools/nut-scanner/scan_usb.c,
	  tools/nut-scanner/scan_xml_http.c: tools/nut-scanner/*.c: be
	  stricter about "ifdef WITH_SOME_NUT_FEATURE" (we may have some
	  defined but zeroed, so not active for a build) [#3293]
	* tools/nut-scanner/nutscan-device.h: comment the added meaning of
	  TYPE_END in nutscan_device_type_t as the array size definition
	* scripts/obs/_config: Debian Next builders can not choose between
	  libselinux1-dev (which provides libselinux-dev) and requested
	  libselinux-dev (as dependency of libgio/libmount) so need a nudge
	  [#3293]
	* .github/pull_request_template.md: update notes about ci_build.sh,
	  add NEWS/UPGRADING adoc bumps
	* .github/pull_request_template.md: add a note to disclose AI and
	  other coding aid usage, and that a human is ultimately responsible
	  for the contributions
	* drivers/apcsmart.c: neuter upsdrv_help(): it brings no new value
	  now that all NUT programs print references to on-line and man page
	  docs
	* clients/upsclient.c, clients/upslog.c, common/common.c,
	  common/strptime.c, drivers/al175.c, drivers/apcsmart.c,
	  drivers/dstate.c, drivers/generic_modbus.c,
	  drivers/huawei-ups2000.c, drivers/liebert-esp2.c,
	  drivers/nutdrv_hashx.c, drivers/pijuice.c, drivers/powercom.c,
	  drivers/powerp-bin.c, drivers/snmp-ups.c, drivers/tripplite_usb.c,
	  drivers/tripplitesu.c, drivers/usb-common.c, server/upsd.c:
	  *.{c,h}: rectify indentations and line-wrapping in if/for/while
	  constructs
	* drivers/huawei-ups2000.c: use sizeof not fixed number for
	  snprintf()
	* clients/upscmd.c, clients/upsimage.c, clients/upsmon.c,
	  clients/upssched.c, clients/upsset.c, common/common-nut_version.c,
	  common/common.c, common/wincompat.c, drivers/al175.c,
	  drivers/apc-hid.c, drivers/apcsmart-old.c, drivers/apcsmart_tabs.c,
	  drivers/arduino-hid.c, drivers/asem.c, drivers/bcmxcp.c,
	  drivers/belkinunv.c, drivers/bestfcom.c, drivers/bestfortress.c,
	  drivers/bestuferrups.c, drivers/clone-outlet.c, drivers/etapro.c,
	  drivers/genericups.c, drivers/hidparser.c, drivers/libusb0.c,
	  drivers/libusb1.c, drivers/macosx-ups.c, drivers/metasys.c,
	  drivers/mge-xml.c, drivers/microdowell.c, drivers/netxml-ups.c,
	  drivers/nutdrv_atcl_usb.c, drivers/optiups.c,
	  drivers/richcomm_usb.c, drivers/riello_usb.c, drivers/skel.c,
	  drivers/snmp-ups-helpers.c, drivers/tripplite-hid.c,
	  drivers/tripplitesu.c, drivers/upscode2.c, drivers/usbhid-ups.c,
	  tools/nut-scanner/nut-scanner.c, tools/nut-scanner/nutscan-ip.c,
	  tools/nut-scanner/scan_avahi.c: *.{c,h}: rectify indentations and
	  line-wrapping in block comments

=== 2026-02-01  Tim Niemueller <tim@niemueller.de>

	* m4/nut_check_libglib.m4: Add `-isystem` fix for glib
	* clients/cgilib.c, clients/upslog.c, clients/upsset.c,
	  tools/nut-scanner/scan_avahi.c: Add nullptr checks and wrong enum
	  cast
	* clients/cgilib.c, clients/nutclientmem.cpp, clients/upsc.c,
	  clients/upscmd.c, clients/upslog.c, clients/upsmon.c,
	  clients/upsrw.c, clients/upssched.c, clients/upsset.c,
	  clients/upsstats.c, common/common.c, common/parseconf.c,
	  common/state.c, drivers/adelsystem_cbi.c, drivers/adelsystem_cbi.h,
	  drivers/al175.c, drivers/apc_modbus.c, drivers/apcsmart.c,
	  drivers/bcmxcp.c, drivers/bcmxcp_usb.c,
	  drivers/common_voltronic-crc.c, drivers/dummy-ups.c,
	  drivers/ecoflow-hid.c, drivers/failover.c,
	  drivers/generic_modbus.c, drivers/hidparser.c, drivers/libhid.c,
	  drivers/libshut.c, drivers/main.c, drivers/mge-hid.c,
	  drivers/microdowell.c, drivers/nhs_ser.c, drivers/nutdrv_qx.c,
	  drivers/nutdrv_qx_masterguard.c, drivers/rhino.c, drivers/serial.c,
	  drivers/snmp-ups.c, drivers/tripplite_usb.c, drivers/upsdrvctl.c,
	  drivers/usb-common.c, drivers/usbhid-ups.c, server/conf.c,
	  server/desc.c, server/upsd.c, server/user.c,
	  tools/nut-scanner/nutscan-device.c,
	  tools/nut-scanner/nutscan-display.c,
	  tools/nut-scanner/nutscan-ip.c, tools/nut-scanner/nutscan-serial.c,
	  tools/nut-scanner/scan_avahi.c,
	  tools/nut-scanner/scan_eaton_serial.c,
	  tools/nut-scanner/scan_ipmi.c, tools/nut-scanner/scan_nut.c,
	  tools/nut-scanner/scan_snmp.c, tools/nut-scanner/scan_usb.c,
	  tools/nut-scanner/scan_xml_http.c: Fix unrelated compiler warnings
	  to be able to complete distcheck  On the used clang version
	  implicit conversion triggers a warning, the `-Werror` makes those
	  errors.  I have used Gemini for some of these, but quota ran out
	  after half an hour and \~120 invocations so I completed the rest
	  manually.

=== 2026-02-01  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/Makefile.am, tests/NIT/nit.sh: use platform-specific
	  ABS_TOP_BUILDDIR separately from makefile abs_top_builddir [#3294]
	  The original hack broke the PATH parsing (added colons in WIN32
	  tests)
	* tests/NIT/nit.sh: if we pass driverpath in WIN32 spelling, we want
	  it not only quoted but also with escaped backslashes [#3292]
	* configure.ac, tests/NIT/Makefile.am: propagate possibly
	  platform-adjusted spelling of ABS_TOP_SRCDIR and ABS_TOP_BUILDDIR
	  so it ends up in "driverpath" correctly for WIN32 builds [#3292]
	* m4/nut_check_libglib.m4: generalize the -isystem fix to hack
	  depCFLAGS first [#3293]
	* m4/nut_check_libglib.m4: Mostly revert
	  {empty}7f0ed5d29fc2035686cf5be820ec48db91ba19c8 [#3293]  Earlier commits
	  separated LIBGIO* from LIBGLIB* variables, but a parallel-developed
	  fix happened to conflate them back.
	* tools/nut-scanner/Makefile.am: bump libnutscan version info [#3293]
	  \+1 for "current" (added interfaces) and "+1" for age (only added,
	  not removed)
	* configure.ac, docs/man/Makefile.am, drivers/Makefile.am,
	  m4/nut_check_libglib.m4, tools/nut-scanner/Makefile.am,
	  tools/nut-scanner/nutscan-init.c: configure.ac,
	  m4/nut_check_libglib.m4, Makefiles: clearer name and user (and
	  hack) the variables for libglib and for libgio [#3293]
	* configure.ac: when testing PYTHON* capabilities, check not only for
	  a known PYTHON*_VERSION_INFO_REPORT but also for non-trivial
	  PYTHON* itself - we could forget that due to auto-prio [#1792]

=== 2026-01-31  Tim Niemueller <tim@niemueller.de>

	* tools/nut-scanner/scan_upower.c: Variable ordering fix  Pretend
	  it's 1999 and put declaration of the variable further up.
	* NEWS.adoc: Add entry to NEWS.adoc for nut-scanner upower support
	* common/common.c, common/nutconf.cpp: Fix compiler warnings about
	  copy ellision  This fixes the build fail triggered on CI farm, and
	  some more that trigger on the more recent version 21 of clang.

=== 2026-01-31  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/nit.sh, NEWS.adoc: flip the switch to test upsdrvctl too
	  [#2800]
	* tools/nut-scanner/nutscan-init.c: comment on do_upsconf_args()
	  placeholder vs. ENABLE_SHARED_PRIVATE_LIBS [#2800]
	* drivers/upsdrvctl.c: register callback_upsconf_args if we
	  ENABLE_SHARED_PRIVATE_LIBS [#2800]

=== 2026-01-30  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/packager-guide.txt, scripts/obs/Makefile.am,
	  scripts/obs/debian.control, scripts/obs/debian.nut-gpio.install,
	  scripts/obs/debian.nut-gpio.manpages,
	  scripts/obs/debian.nut-upower.install,
	  scripts/obs/debian.nut-upower.manpages, scripts/obs/nut.dsc:
	  scripts/obs/*, docs/packager-guide.txt: introduce new sub-packages
	  for GPIO and UPower drivers [#1209]

=== 2026-01-29  TomZanna <git@tomzanna.com>

	* NEWS.adoc, docs/man/tripplitesu.txt, drivers/tripplitesu.c:
	  drivers/tripplitesu.c: add configurable command delay to prevent
	  read timeouts
	* data/driver.list.in, drivers/tripplitesu.c: drivers/tripplitesu.c:
	  add 1s delay in command_send  Intermittent communication timeouts
	  were observed when multiple commands were sent in rapid succession.
	  Adding a 1-second delay at the beginning of command_send() ensures
	  the hardware buffer is ready and prevents the "read timeout"
	  errors.

=== 2026-01-29  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/08-PyNUTClient.yml, appveyor.yml,
	  scripts/Windows/build-mingw-nut.sh, scripts/obs/debian.changelog,
	  scripts/obs/nut.dsc, scripts/obs/nut.spec, tools/gitlog2version.sh:
	  Update versions for release of NUT v2.8.5
	* docs/docinfo.xml.in: add docs increment summary for NUT v2.8.5
	  release
	* NEWS.adoc: remove "PLANNED" from section title before NUT v2.8.5
	  release
	* NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text
	  before NUT v2.8.5 release
	* NEWS.adoc: drop "planned porting of reference packaging from 42ITy
	  project" as achieved [#1209]
	* .obs/workflows.yml: Revert ".obs/workflows.yml: separate project
	  builds with what looks like RC tags to use a separate OBS template
	  (tweaked to change the dash into tilde for packaging versions)
	  [#1209]"  This reverts commit
	  cced83a58d8d980cbeaad019522ab0f0c25d77e7: the currently deployed
	  OBS service does not filter by "tags"... sadly.
	* docs/maintainer-guide.txt: GHA file for PyNUTClient was renamed
	* scripts/Windows/build-mingw-nut.sh: add license header
	* docs/maintainer-guide.txt: add OBS reference recipes to watch for
	  version bump when releasing
	* docs/maintainer-guide.txt: move VERSION_FORCED* file preparation
	  (involves git tagging) to after changing committed files
	* docs/maintainer-guide.txt: update a comment

=== 2026-01-28  Vladdrako <vladdrako007@gmail.com>

	* drivers/powercom-hid.c: drivers: powercom-hid: use offdelay/ondelay
	  config options for  shutdown commands  The powercom_shutdown_nuf(),
	  powercom_stayoff_nuf(), and powercom_startup_nuf() functions were
	  reading delay values from dstate_getinfo("ups.delay.shutdown") and
	  dstate_getinfo("ups.delay.start"), which return the UPS's CURRENT
	  delay values read via HID.  However, users configure their desired
	  delays via the "offdelay" and "ondelay" driver options in ups.conf.
	  These were being ignored.  This patch changes the functions to: 1.
	  First try the value passed directly to the instant command 2. Then
	  try getval("offdelay")/getval("ondelay") from driver config 3. Then
	  try dstate_getinfo() for current UPS values 4. Finally fall back to
	  sensible defaults (60s shutdown, 120s startup)  This ensures that
	  user configuration is respected.  Tested on Powercom RPT-800AP
	  (VendorID: 0x0d9f, ProductID: 0x0004).

=== 2026-01-28  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/nut-driver-enumerator-test.sh: quiesce shell-check concerns
	  about "==" comparator [#3055]  Co-authored-by: Greg Troxel
	  <gdt@lexort.com>
	* tools/semver-compare.sh, docs/nut-versioning.adoc: revise help for
	  "Shellish syntax to compare two semvers" [#3055]
	* drivers/powercom-hid.c: bump POWERCOM_HID_VERSION and revise
	  comments [#3288]
	* NEWS.adoc: update about powercom-hid fix for
	  shutdown/stayoff/startup INSTCMDs [#3288]
	* clients/Makefile.am, tests/Makefile.am: revise libnutclient*
	  dependencies to honour ENABLE_SHARED_PRIVATE_LIBS [#2800]
	* scripts/obs/_service: stash recent template project changes from
	  OBS setup [#1209]
	* .obs/workflows.yml: separate project builds with what looks like RC
	  tags to use a separate OBS template (tweaked to change the dash
	  into tilde for packaging versions) [#1209]
	* docs/developers.txt: update recommendation about hiding IDE dirs
	  from a careless `git clean -fdX`
	* NEWS.adoc, docs/nut.dict, drivers/nutdrv_qx.c,
	  drivers/nutdrv_qx_voltronic.c: drivers/nutdrv_qx.c,
	  nutdrv_qx_voltronic.c, NEWS.adoc, docs/nut.dict:
	  qx_process_answer(): set errno=ETIMEDOUT (not EINVAL) if raised by
	  caller or we had a zero-length read; use this in voltronic_claim()
	  [#3276, #3283]
	* common/Makefile.am, tests/Makefile.am: revise libnutconf dependency
	  to honour ENABLE_SHARED_PRIVATE_LIBS and match
	  tools/nutconf/Makefile.am [#2800]
	* clients/Makefile.am, common/Makefile.am, tests/Makefile.am:
	  tests/Makefile.am: revise dependency for libdummy_mockdrv.la to
	  honour ENABLE_SHARED_PRIVATE_LIBS setting [#2800]

=== 2026-01-27  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/nutdrv_qx_voltronic.c: voltronic_claim(): do not limit
	  second query retry to errno==EINVAL for now [#3276]
	* drivers/nutdrv_qx_voltronic.c: voltronic_claim(): log failed query
	  codes and their errnos [#3276]
	* drivers/usb-common.c: add debug tracing [#2270]
	* NEWS.adoc, UPGRADING.adoc: update nut-upower entry with link to the
	  PR [#3279]
	* configure.ac: move nut-upower up to be near macosx equivalent, and
	  hotfix GLIB_CFLAGS with -isystem options to reduce CLANG (mostly)
	  compiler warnings [#3279]
	* drivers/Makefile.am: cosmetic fixes [#3279]
	* drivers/nutdrv_qx_voltronic.c: voltronic_claim(): retry if the
	  first query was OK and second was invalid [#3282]
	* drivers/nutdrv_qx.c: upsdrv_initups(): log that we got as far as
	  matching the device claimer (and which media type while at it)
	  [#3282]
	* drivers/nutdrv_qx.c: subdriver_matcher(): more debug-tracing
	  [#3282]
	* data/driver.list.in: clean up the markup a bit [#3285]

=== 2026-01-26  air5551 <Air@example.org>

	* data/driver.list.in: Trying to make CI happy :3
	* data/driver.list.in: Added Liebert PSI5-800RT120

=== 2026-01-26  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/nutdrv_qx.c: try a longer sleep after serial dtr/rts
	  setting [#3282]  Some devices are slow to respond to a first query
	  and fail detection. Maybe delaying by a bit over 1 second would
	  help?
	* drivers/nutdrv_qx.c: improve debug tracing for main loop skeleton
	  [#3282]
	* drivers/arduino-hid.c, NEWS.adoc, docs/nut.dict: add `ups.load`,
	  `input.voltage`, `output.voltage` for e.g. Ugreen US3000 [#3281]

=== 2026-01-24  Tim Niemueller <tim@niemueller.de>

	* configure.ac, docs/acknowledgements.txt, docs/man/nut-scanner.txt,
	  docs/nut.dict, m4/nut_check_libglib.m4,
	  tools/nut-scanner/Makefile.am, tools/nut-scanner/nut-scan.h,
	  tools/nut-scanner/nut-scanner.c,
	  tools/nut-scanner/nutscan-device.c,
	  tools/nut-scanner/nutscan-device.h,
	  tools/nut-scanner/nutscan-init.c, tools/nut-scanner/nutscan-init.h,
	  tools/nut-scanner/scan_upower.c: Add UPower support to nut-scanner
	  - Added support for scanning UPower devices via GDBus/libgio. -
	  Implemented dynamic loading of libgio/libglib to avoid hard
	  dependencies. - Added --upower_scan (-J) option to nut-scanner. -
	  Added m4/nut_check_libglib.m4 to detect GLib/GIO. - Updated
	  configure.ac to check for UPower support requirements. - Updated
	  nut-scanner build system and initialization. - Updated nut-scanner
	  man page
	* docs/nut.dict: Update doc/nut.dict from make spellcheck-interactive
	  Add missing terms.
	* NEWS.adoc, UPGRADING.adoc, docs/configure.txt,
	  docs/man/Makefile.am, docs/man/{upower_dbus.txt => nut-upower.txt},
	  drivers/Makefile.am, drivers/{upower_dbus.c => nut-upower.c}:
	  Rename upower_dbus driver to nut-upower
	* NEWS.adoc, UPGRADING.adoc, docs/config-prereqs.txt,
	  docs/configure.txt, drivers/upower_dbus.c: Address upower driver
	  immediate review comments
	* .github/workflows/01-make-dist.yml: Add libglib2.0-dev to github
	  action builder  Required to also test upower_dbus driver.

=== 2026-01-24  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/nut.dict: add gio [#3279]
	* drivers/upsdrvctl.c: stop_driver(): try shorter PING first, so a
	  closed socket is detected earlier [#3277]
	* drivers/upsdrvctl.c: stop_driver(): if
	  upsdrvquery_connect_drvname_upsname() failed, try another in case
	  the driver is still starting and we were called too soon [#3277]
	* drivers/upsdrvctl.c, drivers/upsdrvquery.c: drivers/upsdrvquery.c:
	  upsdrvquery_ping(): revise intense reading loop and timeout
	  accounting when the read size remains 0 [#3277]
	* drivers/upsdrvctl.c: stop_driver(): handle not-hearing from the
	  last PONG a bit cleaner [#3277]
	* NEWS.adoc, UPGRADING.adoc, docs/nut.dict, drivers/upsdrvquery.c,
	  drivers/upsdrvquery.h: drivers/upsdrvquery.{c,h}, UPGRADING.adoc,
	  NEWS.adoc: introduced upsdrvquery_NOSIGPIPE toggle for consumers
	  who might want to handle SIGPIPE themselves [#3277]
	* drivers/upsdrvquery.c: upsdrvquery_close(): refactor work with
	  setsockopt(), prefer it over the blanket signal change for the
	  process; handle EPIPE specially [#3277]
	* drivers/upsdrvquery.c: upsdrvquery_write() use MSG_NOSIGNAL where
	  available [#3277]  Proper NUT daemons intercept SIGPIPE and survive
	  closed connections, but consumers of upsdrvquery might not, and
	  would crash. If we can, just return the error (and errno=EPIPE) for
	  the specific call.
	* scripts/obs/_service: survive git tags with a dash [#1209]  Avoid
	  RPM build error like: line 121: Illegal char '-' (0x2d) in:
	  Version:        2.8.5-rc1.12\+g3501cd37
	* .github/workflows/01-make-dist.yml,
	  .github/workflows/05-codeql.yml: add libglib2.0-dev [#3279]
	* NEWS.adoc, docs/man/nut-ipmipsu.txt, drivers/nut-ipmipsu.c,
	  drivers/nut-libfreeipmi.c, tools/nut-scanner/scan_ipmi.c:
	  tools/nut-scanner/scan_ipmi.c, drivers/nut-ipmipsu.c: fixed an
	  issue where multiple calls to clean-up crashed the program [#3193]
	  Special thanks to maintainer of libfreeipmi for helping catch it!
	  Co-authored-by: Albert Chu <chu11@llnl.gov>

=== 2026-01-23  Tim Niemueller <tim@niemueller.de>

	* configure.ac, docs/man/Makefile.am, docs/man/upower_dbus.txt,
	  docs/nut.dict, drivers/Makefile.am, drivers/upower_dbus.c: Add
	  UPower driver  Enables to read UPS data from UPower. This is useful
	  if a UPS connected to a desktop system should be exposed over the
	  network. It can also be used to expose laptop batteries.

=== 2026-01-23  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/upsdrvctl.c: upsdrvquery_ping() after telling the driver to
	  stop, so upsdrvctl exits when the driver is gone [#3277]
	* drivers/upsdrvquery.c, drivers/upsdrvquery.h:
	  drivers/upsdrvquery.{c,h}: separate upsdrvquery_ping() from
	  upsdrvquery_prepare() [#3277]
	* drivers/upsdrvquery.c: protect upsdrvquery_close() from SIGPIPE
	  crash if the other side exited [#3277]
	* NEWS.adoc, drivers/upsdrvctl.c: drivers/upsdrvctl.c: if we fail to
	  stop a driver by signal, retry to "exit" it by protocol [#3277]
	* NEWS.adoc, conf/ups.conf.sample, docs/man/ups.conf.txt,
	  docs/man/upsdrvctl.txt, drivers/upsdrvctl.c: drivers/upsdrvctl.c,
	  NEWS.adoc, conf/ups.conf.sample, docs: apply global debug_min from
	  ups.conf also to upsdrvctl tool itself [#3276]
	* docs/man/nut-ipmipsu.txt: add errata note about possible troubles
	  when changing OS user accounts [#3193]
	* tools/nut-scanner/README.adoc: fix typo
	* .circleci/config.yml: line-break elements added for DMF code base,
	  so master-branch text lines match exactly

=== 2026-01-20  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/nut-scanner/Makefile.am: restore wording of
	  -export-symbols-regex for libnutscan [#2800]

=== 2026-01-18  sginestrini <s.ginestrini@gmail.com>

	* data/driver.list.in: Fix formatting for Tecnoware UPS ERA PLUS 2000
	  entry in driver list

=== 2026-01-18  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/Makefile.am, drivers/libusb0.c, drivers/libusb1.c: fix
	  linking of suggest_NDE_conflict() when we
	  ENABLE_SHARED_PRIVATE_LIBS [#2800]
	* drivers/Makefile.am: drivers/Makefile.am, NEWS.adoc: optimise
	  driver build/link with libdummy_usb.la [#2800]
	* drivers/Makefile.am, NEWS.adoc: optimise driver build/link with
	  libdummy_usb.la [#2800]
	* configure.ac, docs/configure.txt: stress that --without-serial does
	  not currently mean disabling modbus drivers nor libnutscan ability
	  to talk serial
	* drivers/Makefile.am, NEWS.adoc: avoid building libdummy_serial.la
	  when we configure --without-serial
	* NEWS.adoc: wrap recently indented lines
	* docs/nut.dict: fix sort order

=== 2026-01-17  sginestrini <s.ginestrini@gmail.com>

	* data/driver.list.in: Add UPS model 'UPS ERA PLUS 2000' to driver
	  list

=== 2026-01-17  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/Makefile.am: fix linking of libdummy_serial.la with
	  ENABLE_SHARED_PRIVATE_LIBS more conservatively [#2800]
	* drivers/Makefile.am: fix linking of libdummy_serial.la with
	  ENABLE_SHARED_PRIVATE_LIBS [#2800]
	* tools/nutconf/Makefile.am: revise dependency trail involving
	  libcommonclient.la [#2800]
	* NEWS.adoc, docs/nut.dict, drivers/powercom-hid.c:
	  drivers/powercom-hid.c, NEWS.adoc: introduce
	  powercom_hack_voltage_lkp to report battery.voltage [#2766]
	  Authored-By: Vladyslav Andreichykov <vladdrako007@gmail.com>
	* drivers/cps-hid.c, NEWS.adoc: added Replace Battery information
	  [#3268]  Contributed via mailing list at
	  https://alioth-lists.debian.net/pipermail/nut-upsdev/2026-January/008184.html
	  Authored-by: John.Chang <John.Chang@cyberpower.com>
	* scripts/upower/95-upower-hid.hwdb: update comment for iDowell (and
	  newly Goldenmate) devices on USB ID v075Dp0300 [#3265]

=== 2026-01-16  Jim Klimov <jimklimov@gmail.com>

	* ci_build.sh: Revert "ci_build.sh: do not auto-test both
	  NUT_LIBNUTPRIVATE_VARIANTS on MacOS for now, stick with default
	  (no) [#2800]"  This reverts commit
	  {empty}520539ecaf11a4a7cc2f6feef5030ae579bad10b : issue was fixed by
	  passing version data/methods into drivers using the callback
	  mechanism made for upsdrv_*() implementations.

=== 2026-01-16  Jim Klimov <jimklimov+nut@gmail.com>

	* ci_build.sh, scripts/Windows/build-mingw-nut.sh: revise
	  passing/defaulting of WITH_LIBNUTPRIVATE envvar toggle for WIN32
	  (cross-)builds [#2800]
	* common/common-nut_version.c, drivers/main.c, drivers/main.h:
	  drivers/main.{c,h}, common/common-nut_version.c: pass nut_version
	  stuff via upsdrv_callback_t too [#2800]
	* clients/Makefile.am: link libcommonversion.la BEFORE the dynamic
	  libnutprivate-*common*.la [#2800]
	* tools/nut-scanner/Makefile.am: with ENABLE_SHARED_PRIVATE_LIBS and
	  binaries keeping their version info inside, libnutscan is also such
	  a binary as far as third-party consumers are concerned [#2800]
	* drivers/Makefile.am, tests/Makefile.am: fix libnutprivate linking
	  with libdummy_mockdrv and libcommonversion [#2800]
	* configure.ac: fix use of cygpath (WIN32) where available, to
	  determine ABS_TOP_{BUILD,SRC}DIR values
	* tools/nutconf/Makefile.am: fix dependency between libnutconf.la and
	  libcommonclient.la for ENABLE_SHARED_PRIVATE_LIBS mode [#2800]
	* .obs/workflows.yml: "event" is a value, not list [#1209]
	* scripts/obs/debian.rules: no SED for dropped
	  nut-common-tmpfiles.conf
	* scripts/obs/Makefile.am, scripts/obs/debian.nut-common.tmpfiles.in,
	  scripts/obs/debian.rules: scripts/obs/*: drop misleading
	  debian.nut-common.tmpfiles.in, deliver built one
	* scripts/obs/debian.rules: modernize naming of
	  nut-common-tmpfiles.conf
	* scripts/obs/nut.spec, scripts/obs/debian.rules: honour new
	  nut-common-sysusers.conf [#3262]
	* drivers/snmp-ups.c: avoid strncat() altogether by using snprintf()
	  [#3253]
	* drivers/snmp-ups.c: fix remaining strcat=>strncat [#3255]
	* tools/driver-list-format.sh: update the error message to stress
	  expected format [#3265]
	* data/driver.list.in: TAB-separate all the fields of GoldenMate
	  entry [#3265]

=== 2026-01-15  Jim Klimov <jimklimov@gmail.com>

	* ci_build.sh: do not auto-test both NUT_LIBNUTPRIVATE_VARIANTS on
	  MacOS for now, stick with default (no) [#2800]
	* appveyor.yml: build CI tarballs WITH_LIBNUTPRIVATE=true [#2800]

=== 2026-01-15  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am, clients/Makefile.am, common/Makefile.am,
	  common/common-nut_version.c, drivers/Makefile.am,
	  scripts/Windows/Makefile.am, server/Makefile.am, tests/Makefile.am,
	  tools/nut-scanner/Makefile.am, tools/nutconf/Makefile.am:
	  common/common-nut_version.c, */Makefile.am: Introduce
	  libcommonversion-private.la for builds where we
	  ENABLE_SHARED_PRIVATE_LIBS so programs have their versions built in
	  and can consult what the library thinks about itself [#2800]  Costs
	  about 30Kb (Linux with debug) per binary (upsc) for the now
	  re-embedded version data and a few methods to show it. But still
	  saves 200K compared to a build without libnutprivate.
	* docs/nut.dict: add LiFePO [#3265]
	* docs/nut.dict: update spelling of GoldenMate [#3265]
	* data/driver.list.in: fix spelling of GoldenMate [#3265]
	* NEWS.adoc: update about GoldenMate LiFePo4 support in usbhid-ups
	  [#3265]
	* drivers/idowell-hid.c: switch to double-digit version [#3265]
	  Instead of bumping 0.2 to 0.3, bump to 0.20 - better future-proof

=== 2026-01-15  DeadEnd <45110141+DeadEnded@users.noreply.github.com>

	* data/driver.list.in, docs/nut.dict, drivers/idowell-hid.c: Add
	  missing values for Goldenmate to iDowell subdriver  This PR will
	  add additional values to the iDowell subdriver for support of
	  Goldenmate brand UPS using LiFePO4.

=== 2026-01-14  Luca Boccassi <luca.boccassi@gmail.com>

	* Makefile.am, autogen.sh, configure.ac, docs/configure.txt,
	  docs/nut.dict, scripts/systemd/.gitignore,
	  scripts/systemd/Makefile.am: Install sysusers.d config for
	  user/group  Ubuntu, debian and other distro create the nut
	  user/group pair by default in their packages.  Add a sysusers.d
	  config file and install it. This configuration file will create the
	  configured user/group pair on first boot/factory reset/package
	  installation, without requiring manual scripts or actions. This is
	  very important for image-based OSes, but it is useful in other
	  cases too, to allow using declarative configuration instead of
	  scripts.
	  https://www.freedesktop.org/software/systemd/man/latest/sysusers.d.html
	  This is especially useful in combination with the existing
	  tmpfiles.d config that is already installed, and makes use of the
	  configured user/group. With the sysusers.d addition, it works out
	  of the box without manual scripting.

=== 2026-01-14  Jordan Rodgers <com6056@gmail.com>

	* drivers/usbhid-ups.c: fix format specifier warning

=== 2026-01-14  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/Makefile.am: revise dependencies with libcommonversion.la
	  [#2800]
	* appveyor.yml: after_test: separate installation from follow-up
	  commands into a separate shell call
	* NEWS.adoc: document --with-systemdsysusersdir=PATH addition [#3262]

=== 2026-01-13  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/main.h: debug-print "cbsz" as an unambiguously sized
	  uintmax_t [#2800]
	* drivers/main.h, drivers/main.c, drivers/main-stub.c,
	  tests/generic_gpio_utest.c, tests/driver_methods_utest.c: wrap
	  calls to register/validate callbacks with ignorance of "address"
	  and "unreachable code" warnings [#2800]  Some compilers detect that
	  a persistent structure's address would never be NULL so some
	  conditions are always FALSE and some code never runs. The downside
	  of using macros vs. methods...
	* m4/ax_c_pragmas.m4, drivers/main.c, drivers/apc_modbus.c: introduce
	  HAVE_PRAGMA_GCC_DIAGNOSTIC_IGNORED_MISSING_FIELD_INITIALIZERS{,_BESIDEFUNC}
	  to quiesce stuff={0} initializations (warnings with ancient
	  compilers) [#2800]
	* docs/man/Makefile.am: update LINKMAN_EXCLUDE_NONDRIVER preemptively
	  based on source inspection [#3255]
	* docs/man/Makefile.am: do not list index.txt twice in SRC_ALL_PAGES
	* docs/man/Makefile.am: linkman-driver-names.txt: do not refer to
	  blazer-common and nut_usb_addvars as if they were standalone driver
	  man pages [#3255]

=== 2026-01-12  Paul Donald <newtwen+github@gmail.com>

	* drivers/blazer_usb.c, drivers/nutdrv_qx.c, drivers/usbhid-ups.c:
	  drivers/*: align subdriver output  instead of  Acceptable
	  values...: blah, blah  print:  Acceptable values...: blah1 blah2
	  ...
	* drivers/main.c: drivers/main: clean up help output  print the self
	  describing parameter name first, then the descriptive text.
	  Otherwise it's a wall of text where one has to search for the
	  parameter, because it's unaligned.

=== 2026-01-12  Jordan Rodgers <com6056@gmail.com>

	* NEWS.adoc, drivers/usbhid-ups.c: usbhid-ups: improve handling of
	  transient LIBUSB_ERROR_IO failures  Some devices (e.g., CyberPower
	  CP1500PFCLCD) have firmware bugs that cause random I/O errors on
	  specific HID reports during normal polling. Rather than triggering
	  expensive reconnection attempts that can fail in daemon mode, skip
	  the failing report and continue with remaining polls.  Add safety
	  check to detect true device disconnection: if all polls fail during
	  an update cycle (items_succeeded == 0), trigger reconnect as
	  before.  This improves stability especially in daemon mode while
	  still detecting real disconnections via other error codes or
	  complete poll failure.  Fixes #3116

=== 2026-01-12  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/nut-scanner/Makefile.am: revise nut_scanner_LDADD to use
	  bigger common lib just in case so far [#2800]
	* Makefile.am, clients/Makefile.am, drivers/Makefile.am,
	  scripts/Windows/Makefile.am, server/Makefile.am, tests/Makefile.am,
	  tools/nut-scanner/Makefile.am: */Makefile.am: for parallel builds
	  not in souce root, refine libnutprivate* dependency definitions
	  (also wants libcommonversion) [#2800]
	* ci_build.sh: add NUT_LIBNUTPRIVATE_VARIANTS to (randomized) build
	  matrix with BUILD_TYPE=default-all-errors and explicit requests via
	  WITH_LIBNUTPRIVATE envvar [#2800]
	* drivers/main.h: validate_upsdrv_callbacks(): do not fail when
	  validating a newly made structure (with expected NULL references)
	  [#2800]
	* tests/driver_methods_utest.c, tests/generic_gpio_utest.c: take note
	  of NUT_DEBUG_LEVEL envvar [#2800]
	* drivers/main.h: validate_upsdrv_callbacks(): debug-log the values
	  seen in upsdrv_callback_t structure as we go through it [#2800]
	* tests/generic_gpio_utest.c: do not segfault if aborting early
	  [#2800]
	* drivers/main.h: fix init_upsdrv_callbacks() naming, assert correct
	  inputs [#2800]
	* drivers/main.h: upsdrv_callback_t: separate sentinel from padding
	  [#2800]
	* drivers/main.c, drivers/main.h: drivers/main.{c,h}:
	  register_upsdrv_callbacks(): validate also struct size overall
	  [#2800]
	* clients/Makefile.am, common/Makefile.am, configure.ac,
	  drivers/Makefile.am, scripts/Windows/Makefile.am,
	  server/Makefile.am, tests/Makefile.am,
	  tools/nut-scanner/Makefile.am: Revise libnutprivate* file naming
	  and libtool versioning [#2800]  Once again, libtool versions are
	  not plain SEMVERs!
	* ci_build.sh, scripts/Windows/build-mingw-nut.sh: default to
	  --enable-shared-private-libs for Windows builds [#2800]
	* drivers/main.c, drivers/main.h: drivers/main.{c,h}:
	  register_upsdrv_callbacks(): pass the callbacks as struct ptr, not
	  raw big struct [#2800]
	* UPGRADING.adoc, common/Makefile.am, configure.ac,
	  drivers/Makefile.am: configure.ac, common/Makefile.am,
	  drivers/Makefile.am: version the libnutprivate* libraries, if made
	  (avoid deployment surprises later on) [#2800]
	* drivers/main.c, drivers/main.h: drivers/main.{c,h}: add some
	  portability checks that we load an expected structure with
	  upsdrv_callbacks [#2800]
	* drivers/main.c, drivers/main.h: drivers/main.{c,h}: treat
	  upsdrv_callback_t::upsdrv_info also as a pointer, not directly a
	  structure [#2800]

=== 2026-01-11  rtm516 <ryantmilner@hotmail.co.uk>

	* test-ups.conf: Remove testing config
	* NEWS.adoc, test-ups.conf: Update news.adoc
	* drivers/nutdrv_qx.c, drivers/nutdrv_qx_hunnox.c: Add battery.charge
	  to hunnox driver

=== 2026-01-11  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/Makefile.am, drivers/main-stub.c, drivers/main.c,
	  drivers/main.h, tests/driver_methods_utest.c,
	  tests/generic_gpio_utest.c: drivers/main-stub.c: separate from
	  main.c and register_upsdrv_callbacks() to allow dynamic linking
	  [#2800]
	* drivers/Makefile.am: libnutprivate-drivers-serial.la uses symbols
	  from libnutprivate-drivers-common.la so link with it [#2800]
	* clients/Makefile.am, drivers/Makefile.am,
	  scripts/Windows/Makefile.am, server/Makefile.am, tests/Makefile.am:
	  */Makefile.am: wherever we define our own AM_C{,XX}FLAGS, be sure
	  to refer to $(top_builddir)/include so partial builds also know
	  about config.h [#2825 etc]

=== 2026-01-10  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/nut-scanner/Makefile.am: fix to use actual
	  libnutprivate-common-client.la if building with
	  ENABLE_SHARED_PRIVATE_LIBS [#2800]
	* common/Makefile.am, drivers/Makefile.am: fixup LDFLAGS for WIN32
	  builds of libnutprivate*.dll [#2800]  ...just in case -
	  semi-natively under, MSYS2 the DLL files were built already
	* drivers/Makefile.am: fix nutdrv_qx_LDADD to use
	  libnutprivate-drivers-serial.la when suitable [#2800]
	* clients/Makefile.am: fix upssched recipe to honour
	  ENABLE_SHARED_PRIVATE_LIBS toggle [#2800]
	* clients/Makefile.am, scripts/Windows/Makefile.am,
	  server/Makefile.am, tests/Makefile.am: */Makefile.am: fix other
	  consumers of libcommon*.la to honour ENABLE_SHARED_PRIVATE_LIBS
	  toggle [#2800]
	* drivers/adelsystem_cbi.c, drivers/bcmxcp_usb.c, drivers/libshut.c,
	  drivers/libusb0.c, drivers/libusb1.c, drivers/nutdrv_atcl_usb.c,
	  drivers/nutdrv_qx_voltronic.c, drivers/powervar_cx.c,
	  drivers/richcomm_usb.c, drivers/sms_ser.c, drivers/snmp-ups.c,
	  drivers/tripplite_usb.c: drivers/*.c: refactor to not use unbounded
	  sprintf()
	* drivers/mge-utalk.c: setvar(): refactor to not use unbounded
	  sprintf(), and also not print into potentially NULL strchr()
	* tools/nut-scanner/scan_ipmi.c, tools/nut-scanner/scan_usb.c,
	  tools/nut-scanner/scan_xml_http.c: tools/nut-scanner/scan_*.c:
	  refactor to not use unbounded sprintf()
	* NEWS.adoc, clients/upsmon.c, docs/nut.dict: clients/upsmon.c:
	  wall(): refactor WIN32 case to not use unbounded sprintf()
	* NEWS.adoc: further removal of unbounded `strcpy()` usage [#3253]
	* tests/generic_gpio_liblocal.c: use snprintf() rather than strncpy()
	  to avoid both truncation warnings and unterminated string practice
	* drivers/solis.c: use snprintf() rather than strncpy() to avoid both
	  truncation warnings and unterminated string practice
	* drivers/nutdrv_qx_voltronic-axpert.c,
	  drivers/nutdrv_qx_voltronic.c: drivers/nutdrv_qx_voltronic*.c: bump
	  bitwarns[] to be same size as warns[] to avoid truncation
	* clients/upsstats.c: avoid unbounded strcpy(), especially for data
	  coming from callers
	* tests/generic_gpio_liblocal.c: avoid unbounded strcpy()
	* drivers/adelsystem_cbi.c, drivers/belkinunv.c,
	  drivers/generic_gpio_libgpiod.c, drivers/generic_modbus.c,
	  drivers/masterguard.c, drivers/nutdrv_qx_masterguard.c,
	  drivers/nutdrv_qx_voltronic-axpert.c,
	  drivers/nutdrv_qx_voltronic.c, drivers/solis.c, drivers/upscode2.c:
	  drivers/*: avoid unbounded strcpy()
	* common/setenv.c: avoid unbounded strcpy() just in case
	* docs/man/upsset.conf.txt: revise recommendations for CGI engine
	  timeouts [#3219]
	* NEWS.adoc, UPGRADING.adoc, clients/upsstats.c,
	  conf/upsstats-single.html.sample.in, conf/upsstats.html.sample.in,
	  docs/man/upsstats.html.txt: clients/upsstats.c,
	  docs/man/upsstats.html.txt, conf/upsstats*.html.sample.in,
	  NEWS.adoc, UPGRADING.adoc: introduced `@NUT_UPSSTATS_TEMPLATE@`
	  magic token that HTML templates must start with [#3249, #3252]
	* clients/upsstats.c: display_template(): open HTML template in
	  binary mode, so ftell()/fseek() work predictably [#3219]  Fix
	  rewinding FOREACHUPS command to the correct byte location on WIN32
	  (or other platforms with CR vs CRLF issues).
	* clients/upsstats.c: add call-stack tracing [#3249]

=== 2026-01-09  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am, clients/Makefile.am, common/Makefile.am,
	  drivers/Makefile.am, scripts/Windows/Makefile.am,
	  server/Makefile.am, tests/Makefile.am,
	  tools/nut-scanner/Makefile.am: Refactor and tune back the
	  ENABLE_SHARED_PRIVATE_LIBS implementation, so third-party code
	  (clients, drivers) can build with minimal/no changes if using the
	  NUT public shared libraries [#2800]
	* UPGRADING.adoc, clients/Makefile.am, clients/upsc.c,
	  clients/upscmd.c, clients/upslog.c, clients/upsrw.c,
	  common/upsconf.c, drivers/main.c, include/upsconf.h, server/upsd.c,
	  tools/nut-scanner/Makefile.am: Implement callbacks for upsconf and
	  parseconf methods that can be used with static and dynamic linked
	  NUT programs [#2800]
	* NEWS.adoc, clients/upslog.c: clients/upslog.c: update help() text
	  with a "*@host" example [#3083, #2756]

=== 2026-01-08  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, UPGRADING.adoc, common/Makefile.am, configure.ac,
	  docs/configure.txt: configure.ac, common/Makefile.am,
	  docs/configure.txt: introduce an option to
	  --enable-shared-private-libs [#2800]
	* NEWS.adoc, clients/upsstats.c, conf/upsstats-single.html.sample.in,
	  conf/upsstats.html.sample.in, docs/man/upsstats.html.txt,
	  docs/nut.dict: NUT CGI upsstats (prog, doc, template): add links to
	  expose device/all data as JSON docs [#3171]
	* docs/man/upsset.conf.txt, docs/nut.dict: docs/man/upsset.conf.txt:
	  document recommendations about CGI timeout [#3219]
	* clients/cgilib.c: extractpostargs(): simplify the loop to avoid
	  potential final parsearg() of leftovers [#3219]
	* clients/upsset.c, clients/cgilib.c: in cgilib, see if server tells
	  us CONTENT_LENGTH, and on IIS truncate it by a byte; in upsset add
	  a sacrificial sentinel into each HTML FORM [#3219]
	* clients/cgilib.c: extractpostargs(): revise debug logging [#3249]
	* drivers/openups-hid.c, drivers/usbhid-ups.c, NEWS.adoc,
	  docs/nut.dict: fix "nobattery" alarm on OpenUPS devices [#3246]

=== 2026-01-07  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/cgilib.c: extractpostargs(): on WIN32, select() is a SOCKET
	  concept and does not apply to STDIN [#3219]
	* clients/upsimage.c, clients/upsset.c, clients/upsstats.c:
	  clients/ups{set,stats,image}.c: on WIN32 initialize socket layer
	  for select() to work [#3219]
	* clients/cgilib.c: extractpostargs(): troubleshoot incoming bytes
	  [#3219]
	* clients/upsset.c, clients/cgilib.c: move the time-constrained read
	  of POST data from STDIN from client code into common code [#3219]
	* clients/upsimage.c, clients/upsset.c, clients/upsstats.c:
	  clients/ups{set,stats,image}.c: setmode() actually seems to not be
	  wide-spread; is available in WIN32 builds though, so constrain it
	  to them [#3249]
	* clients/upsset.c: on WIN32 always extractpostargs() [#3207]  ...not
	  sure if select() works as expected here, but NUT CGI under IIS
	  keeps asking for login...
	* clients/upsimage.c, clients/upsset.c, clients/upsstats.c:
	  clients/ups{set,stats,image}.c: treat stdout as a binary stream for
	  CGI on all platforms [#3207]
	* data/htmlcgi/index.html, data/htmlcgi/Makefile.am, NEWS.adoc: use a
	  NUT favicon with CGI HTML pages
	* data/htmlcgi/bottom.html: populate with a bit of text so browser
	  users know loading is completed and not stalled
	* docs/man/upsstats.html.txt: mention sibling upsstats-single.html
	  early in the doc too
	* docs/man/upsset.conf.txt: suggest more ways of hiding/securing NUT
	  CGI on a web server
	* docs/man/upsimage.cgi.txt, docs/man/upsset.cgi.txt,
	  docs/man/upsset.conf.txt, docs/man/upsstats.cgi.txt,
	  docs/man/upsstats.html.txt: docs/man/ups*.{cgi,html}.txt: refer to
	  upsset.conf page about web server preparation for NUT CGI [#3207]
	* conf/.gitignore, conf/Makefile.am, ....html.sample =>
	  upsstats-single.html.sample.in}, ...psstats.html.sample =>
	  upsstats.html.sample.in}, configure.ac: Convert
	  conf/upsstats*.html.sample files into .in templates to consider
	  EXEEXT where applicable (e.g. WIN32) [#3207]
	* NEWS.adoc, docs/nut.dict: update and restructure news for 2.8.5
	  cycle
	* common/common.c, scripts/Windows/wininit.c:
	  scripts/Windows/wininit.c: err on the safe side and allocate
	  buffers sized NUT_PATH_MAX \+ 1 (for the NUL byte)
	* common/common.c, common/parseconf.c: generalize the WIN32 UNC
	  localhost prefix chop-off [#3207]
	* clients/upsset.c, clients/upsstats.c: debug-trace which config file
	  we try to use [#3207]
	* common/parseconf.c: pconf_file_begin(): extend limited UNC path
	  support on WIN32 builds [#3207]  Let CGI work under IIS with
	  `\\?\c:\...` paths to config files. TOTHINK: Maybe move this closer
	  to GetModuleName() calls?

=== 2026-01-06  Yifeng Li <tomli@tomli.me>

	* drivers/huawei-ups2000.c: call ser_close() before modbus_connect(),
	  fix #3244.  In drivers/huawei-ups2000.c, the serial port is opened
	  twice. Once by ser_open() to manually perform device
	  identification, once by modbus_connect() for communicating with the
	  UPS after identification succeeds.  However, holding two file
	  descriptors of the same serial port is problematic on Windows, even
	  if they're not actually used at the same time. A serial port is
	  usually opened on Windows via CreateFileA() with dwShareMode = 0,
	  which is done by libmodbus. According to the Win32 API
	  documentation:  > If this parameter is zero and CreateFile
	  succeeds, the file or device > cannot be shared and cannot be
	  opened again until the handle to the > file or device is closed.
	  This is responsible for the following error on Windows:
	  modbus_connect: unable to connect: No error Driver failed to start
	  (exit status=1)  This commit leaves only the raw ser_open() call in
	  upsdrv_initups(), the modbus_connect() call is deleted to avoid
	  opening the same serial port again. After device identification
	  succeeds later in ups2000_device_identification() - called by
	  upsdrv_initinfo(), the raw serial port is closed. Once at this
	  point, modbus_connect() is called, just before upsdrv_initinfo()
	  returns.

=== 2026-01-06  Jim Klimov <jimklimov+nut@gmail.com>

	* configure.ac, data/htmlcgi/header.html.in, docs/configure.txt,
	  docs/man/upsset.conf.txt, NEWS.adoc, docs/nut.dict: introduce
	  --with-cgi-uri [#3207]
	* clients/upsimage.c, clients/upsset.c, clients/upsstats.c:
	  clients/ups{set,stats,image}.c: support NUT_DEBUG_LEVEL envvar in
	  CGI clients [#3207]
	* docs/man/upsset.conf.txt: note also the "html" directory for pretty
	  UI [#3207]
	* tools/nut-scanner/scan_nut_simulation.c, NEWS.adoc: use the more
	  dynamic confpath() rather than built-in CONFPATH
	* drivers/snmp-ups.c, docs/man/snmp-ups.txt: use the more dynamic
	  confpath() rather than built-in CONFPATH, and document the
	  (incomplete) *mib.conf support
	* clients/upsstats.c: use the more dynamic confpath() rather than
	  built-in CONFPATH [#3207]  Already done for other files, only
	  hosts.conf was seeked wrongly.
	* docs/man/upsset.conf.txt: revise MS IIS setup for NUT CGI
	  experimentally [#3207]
	* appveyor.yml: comment about "mingwXX" in archived N4W builds
	  [#3207]
	* docs/man/upsset.conf.txt, docs/nut.dict, NEWS.adoc: documented
	  setup of Microsoft IIS to host the NUT CGI programs [#3207]
	* clients/upsset.c, clients/upsstats.c, conf/upsset.conf.sample,
	  conf/upsstats.html.sample, configure.ac,
	  data/htmlcgi/header.html.in, docs/man/upsstats.cgi.txt,
	  docs/man/upsstats.html.txt: Consider EXEEXT in CGI programs,
	  templates and docs [#3207]

=== 2026-01-04  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am: fix typos in "make distcheck-completeness" goal
	  [#2829]
	* docs/Makefile.am: fix typo with paths [#1209]

=== 2026-01-03  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/Makefile.am: EXTRA_DIST the OBS logos [#1209]
	* docs/images/ci/obs-logo.png: actually attach the logo file [#1209]

=== 2026-01-02  Jim Klimov <jimklimov+nut@gmail.com>

	* README.adoc: updated entry about Gandi.Net
	* README.adoc: downsize obs-logo.png to match others [#1209]
	* README.adoc: README.adoc, docs/images/ci/obs-logo.png: use another
	  better visible OBS logo [#1209]  Fetched from
	  https://upload.wikimedia.org/wikipedia/commons/3/35/Obs-logo.png
	* README.adoc, docs/images/ci/obs-logo.svg: use a better visible OBS
	  logo [#1209]  Copied from
	  https://github.com/openSUSE/open-build-service/blob/master/docs/obs-logo.svg
	  as of their commit 43c17f6
	* README.adoc, docs/nut.dict,
	  docs/images/ci/openSUSEBuildService.png: reference openSUSE Build
	  Service as a part of NUT CI farm [#1209]  Use logo copied from
	  https://build.opensuse.org/rails/active_storage/blobs/redirect/eyJfcmFpbHMiOnsibWVzc2FnZSI6IkJBaHBCZz09IiwiZXhwIjpudWxsLCJwdXIiOiJibG9iX2lkIn19--043a458c5587aea3e3a61e9727a75569eab11948/openSUSEBuildService.png
	* README.adoc: reshuffle acknowledgements, so DigitalOcean is more
	  prominently the NUT CI farm hosting provider (and Fosshost, like
	  Travis CI, is history) [#2192]
	* scripts/systemd/nut-driver-enumerator-daemon-activator.service.in,
	  scripts/systemd/nut-driver-enumerator-daemon.service.in,
	  scripts/systemd/nut-driver-enumerator.service.in,
	  scripts/systemd/nut-driver@.service.in,
	  scripts/systemd/nut-monitor.service.in,
	  scripts/systemd/nut-server.service.in,
	  scripts/systemd/nut-udev-settle.service.in:
	  scripts/systemd/nut-*.service.in: fix use of MODE in ExecCondition
	  to also consider "none" [#3233]  Also fix nut-monitor.service
	  (upsmon) to still start for a "netserver": it is a full setup like
	  "standalone", just with not only `localhost` clients expected.
	* configure.ac, scripts/systemd/.gitignore,
	  scripts/systemd/Makefile.am, .../systemd/{nut-udev-settle.service
	  => nut-udev-settle.service.in}: configure.ac,
	  scripts/systemd/.gitignore, scripts/systemd/Makefile.am: rename
	  nut-udev-settle.service into a .in template, handle ExecCondition
	  here too [#3233]
	* NEWS.adoc, configure.ac,
	  .../nut-driver-enumerator-daemon-activator.path.in,
	  ...t-driver-enumerator-daemon-activator.service.in,
	  .../nut-driver-enumerator-daemon.service.in,
	  scripts/systemd/nut-driver-enumerator.path.in,
	  scripts/systemd/nut-driver-enumerator.service.in,
	  scripts/systemd/nut-driver.target.in,
	  scripts/systemd/nut-driver@.service.in,
	  scripts/systemd/nut-logger.service.in,
	  scripts/systemd/nut-monitor.service.in,
	  scripts/systemd/nut-server.service.in,
	  scripts/systemd/nut-sleep.service,
	  scripts/systemd/nut-systemd.preset,
	  scripts/systemd/nut-udev-settle.service,
	  scripts/systemd/nut.target.in: scripts/systemd/*, configure.ac,
	  NEWS.adoc: introduce @SYSTEMD_AVAILABLE_EXEC_CONDITION@ and put
	  ExecCondition for MODE values into more units; depend from NDE path
	  units also on nut.conf changes; bump systemd integration copyrights
	  [#3233]

=== 2025-12-30  Jim Klimov <jimklimov+nut@gmail.com>

	* server/upsd.c: fix WIN32 logging of server->Event and ups->sock_fd
	  as HANDLE (pointer) [#3207]
	* server/upsd.c: fix botched indentations [#3237]
	* tests/NIT/Makefile.am, tests/NIT/nit.sh: consider EXEEXT (e.g. with
	  NUT for Windows builds)  ...and refactor part of runcmd() into
	  dual-use execcmd()
	* tests/NIT/Makefile.am, tests/NIT/nit.sh: pass/guess
	  {,TOP_}{BUILD,SRC}DIR values more reliably

=== 2025-12-29  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/NIT/nit.sh: add tests for `upsc -j` JSON outputs [#3178]
	* scripts/Windows/wininit.c, docs/man/nut.exe.txt, NEWS.adoc: try to
	  stop the service before unregistering it [#3207]
	* NEWS.adoc, scripts/Windows/wininit.c: scripts/Windows/wininit.c:
	  SvcInstall(): try to set a nice service description [#3207]
	* scripts/Windows/wininit.c: track also upsdrvctl_pid and all daemon
	  handles; restart dead/killed daemons [#3207]
	* scripts/Windows/wininit.c: debug fault of WaitForMultipleObjects()
	  and do not overflow maxhandle [#3207]
	* server/upsd.c: mainloop(): log DRIVER entries as such (not UPS) for
	  consistency with later processing messages [#3207]
	* server/upsd.c: mainloop(): poll newly connected UPS right away, not
	  in next cycle [#3207]
	* include/common.h: fix fallback WIN32 definition of INVALID_SOCKET
	  to be certain [#3207]
	* server/upsd.c: mainloop(): track also nfds_considered (e.g.
	  discarded as invalid), and check that WIN32 event loop handle is
	  valid [#3207]
	* NEWS.adoc, clients/nutclient.cpp, clients/upsclient.c,
	  docs/nut.dict, drivers/apcupsd-ups.c, server/upsd.c,
	  tools/nut-scanner/nutscan-init.c: upsd, nut-scanner, libs,
	  NEWS.adoc: only process WSAStartup() once [#3237]
	* server/upsd.c, NEWS.adoc: setuptcp(): copy over server->Event
	  (WIN32) when handling "LISTEN *" [#3237]
	* server/upsd.c: setuptcp(): debug-log the FD occupied by new
	  listener [#3207]  ...and WIN32 event, if applicable
	* server/upsd.c: setuptcp(): error-check WIN32 event creation and
	  select subscription [#3207]
	* server/upsd.c: main(), poll_reload(): revise WIN32
	  MAXIMUM_WAIT_OBJECTS vs. maxconn (array size) and maxalloc (check)
	  [#3207]
	* server/upsd.c: server_load(): log ANY address binding like we do
	  for localhost [#3207]
	* server/upsd.c: server_load(): revise tried/succeeded logging
	  [#3207]
	* server/upsd.c: mainloop(): revise honouring maxconn (and log about
	  it) [#3207]
	* server/upsd.c, include/common.h: mainloop(): fix WIN32 debug
	  printouts for SOCKET type [#3207]

=== 2025-12-28  Jim Klimov <jimklimov+nut@gmail.com>

	* UPGRADING.adoc, clients/nutclient.cpp, clients/nutclient.h,
	  clients/upsclient.c, configure.ac, scripts/obs/nut.spec,
	  server/conf.c, server/upsd.c, tests/cpputest-client.cpp,
	  tools/nut-scanner/scan_avahi.c, tools/nut-scanner/scan_nut.c:
	  Rename autoconf variable PORT to NUT_PORT [#3238]  ...and test
	  variables from NUT_* to env_NUT_*
	* clients/nutclient.cpp, clients/nutclient.h:
	  clients/nutclient.{h,cpp}: use NUT-defined default PORT value if
	  possible [#3238]
	* server/upsd.c: mainloop(): log also FDs we are polling [#3207]
	* server/upsd.c: listen_add(): be sure a new (invalid) server->Event
	  is properly initialized [#3207]
	* include/common.h: use safer definitions of TYPE_FD* related macros
	  for various platforms [#3207]

=== 2025-12-26  Jim Klimov <jimklimov+nut@gmail.com>

	* server/upsd.c: setuptcp() WIN32: associate with event loop only if
	  sock_fd is valid [#3207]
	* server/upsd.c: mainloop(): throttle-sleep if failed a cycle in
	  WIN32 and POSIX builds [#3207]
	* server/upsd.c: mainloop(): log FDs watched in WIN32 and POSIX
	  builds [#3207]
	* docs/man/nut.exe.txt: add hints about NUT daemon startup
	  troubleshooting [#3207]
	* scripts/Windows/wininit.c, NEWS.adoc, docs/man/nut.exe.txt: add
	  "nut.exe restart" action [#3207]
	* scripts/Windows/wininit.c, NEWS.adoc: pepper with debug messages,
	  especially for errors and status changes [#3207]
	* common/common.c: refactor getfullpath() and getprocname() WIN32
	  error reporting [#3207]
	* Makefile.am: install-win-bundle-thirdparty: do not install
	  already-present and same DLLs into bindir (re-runs without clean)

=== 2025-12-25  David Marzal <2069735+Marzal@users.noreply.github.com>

	* scripts/systemd/nut-server.service.in: Don't assume sh to be on
	  SBINDIR  Not sure if there is a better way to call `sh` without
	  assuming a static dir.  Something like `command -v sh`

=== 2025-12-24  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, docs/man/nut.exe.txt, docs/nut.dict,
	  scripts/Windows/wininit.c: scripts/Windows/wininit.c: add "nut.exe
	  status" and debug-ability of the start/stop/status actions [#3207]
	* NEWS.adoc, clients/upsclient.c, common/common.c,
	  drivers/apcupsd-ups.c, include/common.h, server/upsd.c:
	  clients/upsclient.c, common/common.c, etc: fix inet_ntopAI() and
	  inet_ntopSS() helper thread unsafety [#3234]
	* common/common.c: getfullpath(): fix infinite loop [#3207]
	* common/common.c: getfullpath(): rephrase debug log entries [#3207]

=== 2025-12-24  David Marzal <2069735+Marzal@users.noreply.github.com>

	* scripts/systemd/nut-server.service.in: Just launch nut-server
	  systemd servide if we are not on netclient mode  Tested with
	  ExecCondition=/bin/sh -c '[ "$MODE" != "netclient" ]' an

=== 2025-12-23  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am: install-win-bundle-thirdparty: typo fix (broken DLL
	  delivery) [fallout of PR #3222, issue #3219]
	* docs/man/must_ep2000pro.txt: carry over a comment from PR
	  description [#3228]

=== 2025-12-22  Jim Klimov <jimklimov@gmail.com>

	* docs/man/must_ep2000pro.txt: rephrase for better English [#3228]

=== 2025-12-22  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: update for must_ep2000pro driver [#3228]
	* scripts/obs/Makefile.am: refactor DEB part of _preinstallimage
	  recipe [#1209]
	* scripts/obs/Makefile.am, scripts/obs/.gitignore,
	  scripts/obs/README.adoc, docs/nut.dict: add helper goal to generate
	  a _preinstallimage file [#1209]
	* configure.ac, docs/configure.txt, NEWS.adoc: do not automatically
	  --enable-extapi-enphase wherever possible just because we can;
	  document the option [#2813]  This is a niche feature for users who
	  have Enphase solar devices and portal subscription.

=== 2025-12-21  Mikhail Mironov <mike@darkmike.ru>

	* docs/man/must_ep2000pro.txt: Correct documentation formating
	* drivers/must_ep2000pro.c: Correct format for signed datatypes

=== 2025-12-20  Mikhail Mironov <mike@darkmike.ru>

	* drivers/must_ep2000pro.c: Fixed error handling when calling
	  shutdown.return
	* docs/nut.dict: Add words to nut.dict for pass spellcheck
	* data/driver.list.in, docs/man/Makefile.am,
	  docs/man/must_ep2000pro.txt, drivers/Makefile.am,
	  drivers/must_ep2000pro.c: Driver for UPS MUST EP2000Pro

=== 2025-12-18  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: avoid using
	  alternation in SED [#3099]

=== 2025-12-17  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c, include/common.h, scripts/Windows/wininit.c,
	  server/upsd.c, drivers/upsdrvctl.c: refactor with a getfullpath2()
	  to mix configure script options and hard-coded fallbacks [#3207]
	* NEWS.adoc: document fixes for WIN32 path resolution [#3207, #3063,
	  #3065, #3219]
	* common/common.c: confpath(): first try getfullpath(CONFPATH), only
	  then fall back to getfullpath(PATH_ETC) [#3207]
	* common/common.c: WIN32 getfullpath(): fix some off-by-one errors
	  and add debug tracing [#3207]
	* drivers/upsdrvquery.c: fix logging of failed WaitNamedPipe
	* tests/NIT/nit.sh: report if GID/UID was not found to offset "if
	  test..." not-a-number errors [#1209]
	* scripts/Windows/build-mingw-nut.sh: fix back the location for NUT
	  config files in reference WIN32 builds [broken by #3049]
	* scripts/Windows/wininit.c: also use PATH_SBIN to upsdrvctl stop
	  [#3207, #3065]
	* drivers/upsdrvctl.c: look for drivers in DRVPATH in WIN32 too
	  [#3207, #3065]
	* common/common.c: getfullpath(): allow passing "relative_path" with
	  absolute-ish values from NUT build and convert them to be relative
	  to the installed binary [#3207]
	* common/common.c: getfullpath(): avoid "DIRNAME../etc" kind of bugs
	  - should be "DIRNAME/../etc" [#3219]
	* common/common.c: refactor getfullpath() style and comments [#3207]
	* Makefile.am: all-fanout-maybe: report when optimized build is
	  finished and we hand off to "make all" default implementation (may
	  regenerate headers again) [#3039]
	* Makefile.am: do not default NUT_VERSION_H_GENERATED=true (at the
	  cost that we would retry it once in "make all" default
	  implementation) [#3039]
	* common/Makefile.am, include/Makefile.am,
	  tools/nut-scanner/Makefile.am: do not skip rebuilding of
	  nut_version.h if it is currently missing [#3039]  May have been
	  removed since, e.g. in `make check-parallel-builds`.
	* tools/nut-scanner/Makefile.am, include/Makefile.am,
	  common/Makefile.am: streamline debugging of
	  MAINTAINER_GENERATE_HEADER_DEBUG [#3039]
	* common/Makefile.am, tools/nut-scanner/Makefile.am: consider
	  NUT_VERSION_H_GENERATED in transitive dependency definition [#3039]
	* docs/nut-versioning.adoc: do not group non-C usages under "Use in C
	  code" title
	* tools/semver-compare.sh: for "test" action, quietly ignore trailing
	  "]" or "]]" and warn if any other trailing args exists and would be
	  ignored [#3055]
	* tools/semver-compare.sh: wrap help text so it fits in 80 cols
	  (mostly) [#3055]
	* docs/nut-versioning.adoc, docs/nut.dict: document semver-compare.sh
	  [#3055]
	* scripts/Solaris/reset-ups-usb-solaris.sh.sample: use
	  configure-script or otherwise detected functional GREP/EGREP if
	  possible [#3099]
	* scripts/Windows/dllldd.sh, scripts/Windows/build-mingw-prereqs.sh,
	  Makefile.am: use configure-detected GREP and EGREP if possible
	  [#3099]
	* scripts/installer/common/ipp-status,
	  scripts/installer/common/shutdown, scripts/installer/install.sh:
	  scripts/installer/*: recognize primary/secondary upsmon roles
	  [#2288, #840]
	* scripts/installer/common/ipp-os-shutdown,
	  scripts/installer/common/ipp-status, scripts/installer/install.sh,
	  scripts/installer/make_package.sh: scripts/installer/*: use
	  configure-script or otherwise detected functional GREP/EGREP if
	  possible [#3099]
	* scripts/installer/aix/aix_init, scripts/installer/common/aix_init,
	  scripts/installer/common/init,
	  scripts/installer/common/ipp-event.sh,
	  scripts/installer/common/ipp-host-shutdown.sample,
	  scripts/installer/common/ipp-notifier.sh,
	  scripts/installer/common/ipp-os-shutdown,
	  scripts/installer/common/ipp-shutdown-daemon.sh,
	  scripts/installer/common/ipp-status,
	  scripts/installer/common/ipp-wrapper,
	  scripts/installer/common/shutdown,
	  scripts/installer/common/solaris_init,
	  scripts/installer/install.sh, scripts/installer/make_package.sh,
	  scripts/installer/solcmn/solaris_init,
	  scripts/installer/uninstall-ipp: scripts/installer/*: bump
	  copyrights for NUT community maintained version [#2288, #2621]

=== 2025-12-16  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/semver-compare.sh: with fixed-width strings instead of
	  numbers, we can forgo the "sort -n", it is confusing on some
	  systems [#3055]  NetBSD, looking at you: ( echo '0001 0030' ; echo
	  '0001 0003' ) \| sort inverses order with sort -n
	* tools/semver-compare.sh: rectify printf vs octal numbers (if there
	  are leading zeroes) [#3055]
	* tools/gitlog2version.sh, tools/semver-compare.sh: fix numeric
	  envvar/CLI arg evaluation for ksh [#3055]  ...where `[ '' -ge 0 ] ;
	  echo $?` does not report a non-numeric error, but succeeds instead.
	* tools/gitlog2version.sh: make SCRIPT_DIR always known (so we can
	  find semver-compare.sh helper) [#3055]
	* tests/nut-driver-enumerator-test.sh: add testcase_semver_compare()
	  [#3055]
	* tools/semver-compare.sh: add "[[" alias to test action, and
	  non-equality checks [#3055]
	* tools/semver-compare.sh: add dashless aliases to expand and strip
	  actions [#3055]
	* tests/nut-driver-enumerator-test.sh: update comments for
	  testcase_gitlog2version() [#3055]
	* tests/nut-driver-enumerator-test.sh: update head comment [#3055]
	* tools/semver-compare.sh: add an option to reverse-sort the versions
	  [#3055]
	* NEWS.adoc, tools/Makefile.am, tools/gitlog2version.sh,
	  tools/semver-compare.sh: tools/semver-compare.sh,
	  tools/gitlog2version.sh: refactor expand/strip logic out of
	  gitlog2version.sh; add more abilities to it [#3055]

=== 2025-12-15  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/FAQ.txt, docs/nut.dict: write down ideas from discussions
	  about power race avoidance and killing UPS power when handling an
	  outage [#1950, #2836]  Mentored-by: Joshua M. Clulow
	  <josh@sysmgr.org> Mentored-by: Lennart Poettering
	  <lennart@poettering.net>
	* NEWS.adoc, docs/nut-versioning.adoc,
	  tests/nut-driver-enumerator-test.sh, tools/gitlog2version.sh:
	  tools/gitlog2version.sh, tests/nut-driver-enumerator-test.sh,
	  docs/nut-versioning.adoc: introduce
	  NUT_VERSION_STRIP_LEADING_ZEROES [#3055]
	* docs/nut-versioning.adoc: document more about the
	  NUT_VERSION_QUERY=VER5X etc modes [#3055]
	* tools/gitlog2version.sh: move filter_extra_width() up and rename to
	  filter_add_extra_width() [#3055]
	* docs/nut-versioning.adoc: rebalance examples for VER5X and DESC5X
	  to consume about the same column width [#3055]

=== 2025-12-11  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/gitlog2version.sh: simplify use of printf (variable width
	  support is not ubiquitous) [#3055]
	* docs/nut-versioning.adoc: more fix to asciidoc markup
	* tools/gitlog2version.sh: filter_extra_width(): fix formatting
	  string for printf() [#3055]  busybox sh printf is strict enough to
	  care about the dot
	* tests/nut-driver-enumerator-test.sh: fix running the test suite
	  itself by ksh [#3055]  By default, `VAR=VAL cmd` sets `VAR=VAL` in
	  the current shell and does not inherit it into `cmd` (nor reset it
	  after the call).
	* tools/gitlog2version.sh: avoid substituting backslash-N via SED
	  [#3055, #3099]
	* tools/gitlog2version.sh: avoid using alternation in SED [#3055,
	  #3099]
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: substitute @SED@
	  to hopefully have the version with alternation support [#3099]
	* docs/nut-versioning.adoc: list example values in tables always as
	  bullet-points so monospace is honoured by asciidoc
	* docs/nut-versioning.adoc: revise asciidoc markup (broken in the
	  table context)
	* docs/nut-versioning.adoc: note that we MAY sometime return to the
	  more idiomatic adherence to SEMVER standard and/or even/odd
	  numbering to maintain release and development branches
	* NEWS.adoc: document changes of gitlog2version.sh and tests for it
	  [#3055]
	* tools/gitlog2version.sh, tests/nut-driver-enumerator-test.sh: add a
	  fallback mode for NUT_VERSION_DEFAULT=X.Y.Z(.W)\+gHASH (missing the
	  commit count) [#3055]
	* tools/gitlog2version.sh: fix escaping of doublequote missed earlier
	  [#3196]
	* docs/nut-versioning.adoc, docs/nut.dict, tools/gitlog2version.sh:
	  tools/gitlog2version.sh: getver_default(): parse non-RC
	  NUT_VERSION_FORCED values in legacy mode [#3055]
	* tests/nut-driver-enumerator-test.sh: extend with some tests for
	  tools/gitlog2version.sh [#3055]  Overall, we want to make sure the
	  script works across different shell interpreters and toolkits, and
	  that a NUT_VERSION_FORCED saved for a dist tarball would be
	  consistently treated by the non-git mode as well.
	* tests/nut-driver-enumerator-test.sh: add a FAILFAST=true mode
	  support [#3055]
	* tools/gitlog2version.sh: fix RC version comparison in legacy mode
	* tools/gitlog2version.sh, docs/nut-versioning.adoc: introduce
	  NUT_VERSION_QUERY=VER5x etc. to simplify alphanumeric comparisons
	  of different NUT releases [#3055]
	* tools/gitlog2version.sh: only read VERSION_FORCED(_SEMVER) file(s)
	  if respective envvars were not passed in env [#3055]
	* tools/gitlog2version.sh: update comments

=== 2025-12-09  Tormod Volden <debian.tormod@gmail.com>

	* drivers/usb-common.c: usb-common.c: Fix truncation in
	  nut_usb_get_string()  References #3201

=== 2025-12-09  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/usb-common.c: nut_usb_get_string(): combine the fix for
	  "buflen vs ret/2" with log warning from issue discussion [#3201,
	  #3211]  Proposed-by: Tormod Volden <debian.tormod@gmail.com>
	* NEWS.adoc: document the fix for nut_usb_get_string() [#3211]

=== 2025-12-07  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am, include/Makefile.am: introduce NUT_VERSION_H_GENERATED
	  to pass run-time skip of active include/nut_version.h regeneration
	  [#3039]
	* NEWS.adoc, drivers/libhid.c, drivers/usb-common.c: NEWS.adoc,
	  drivers/libhid.c::HIDGetIndexString(),
	  drivers/usb-common.c::nut_usb_get_string(): trace the bytes going
	  around [#3201, #2604]
	* drivers/libhid.c: improve debugability of HIDDumpTree()  Make it
	  easier to see in debug log where processing of an entry starts

=== 2025-12-02  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/01-make-dist.yml: fix dist/doc tarballs of PRs
	  being made for target branch in fact
	* docs/man/meanwell_ntu.txt: minor style and phrasing changes [#3206]
	* drivers/meanwell_ntu.c: adjust indentations etc. with NUT style
	  guide [#3206]
	* docs/man/meanwell_ntu.txt: link to vendor doc file, it is very good
	  [#3206]
	* docs/man/meanwell_ntu.txt, drivers/meanwell_ntu.c: suggest and
	  disregard similarity with Megatec Qx protocol [#3206]
	* docs/man/meanwell_ntu.txt: fix dangling white-space chars [#3206]
	* docs/man/meanwell_ntu.txt: fix UTF char in ASCII text [#3206]

=== 2025-11-30  jhite1234 <jhite@bebuggin.com>

	* docs/man/meanwell_ntu.txt: spelling
	* docs/man/meanwell_ntu.txt: NUT style formatting and linkman useage
	* drivers/meanwell_ntu.c: more CI fixes for OmniOS and OpenIndiana
	* drivers/meanwell_ntu.c: small updates for CI fixes

=== 2025-11-30  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/meanwell_ntu.c: make DRIVER_VERSION double-digit [#3206]
	* NEWS.adoc: introduced meanwell_ntu driver [#3206]

=== 2025-11-29  jhite1234 <jhite@bebuggin.com>

	* docs/nut.dict: dictionary update
	* drivers/meanwell_ntu.c: fixes for CI build checks
	* drivers/meanwell_ntu.c: meanwell_ntu: drop termios.h include
	* data/driver.list.in: Add Mean Well NTU Series entry to
	  driver.list.in
	* drivers/meanwell_ntu.c: meanwell_ntu: use experimental.* vars and
	  standard ups.mode
	* docs/man/Makefile.am, drivers/Makefile.am: Add Mean Well NTU
	  inverter/UPS driver
	* docs/man/meanwell_ntu.txt, drivers/meanwell_ntu.c: Add Mean Well
	  NTU inverter/UPS driver

=== 2025-11-29  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/config-prereqs.txt: refer also to "Building NUT for in-place
	  upgrades or non-disruptive tests" from "Prerequisites for building
	  NUT on different OSes" as the two chapters are closely coupled
	* docs/config-prereqs.txt: revise instructions for (now older) Debian
	  {empty}12

=== 2025-11-24  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: update about fixed back/double quoted shell scripting
	  nuances [#3196]
	* Makefile.am, docs/Makefile.am, docs/man/Makefile.am,
	  scripts/python/Makefile.am, scripts/python/module/Makefile.am,
	  tests/Makefile.am, tools/Makefile.am: */Makefile.am: revise shell
	  script syntax with backticks and double-quotes; single-quote Make
	  variable expansions into shell [#3196]
	* docs/docinfo.xml.sh.in: revise shell script syntax with backticks
	  and double-quotes [#3196]
	* docs/ci-farm-lxc-setup.txt: revise shell script syntax with
	  backticks and double-quotes [#3196]
	* tools/nut-ddl-dump.sh: revise shell script syntax with backticks
	  and double-quotes [#3196]
	* tools/nut-dumpdiff.sh: revise shell script syntax with backticks
	  and double-quotes [#3196]
	* tools/gitlog2version.sh: revise shell script syntax with backticks
	  and double-quotes [#3196]
	* tools/driver-list-format.sh: revise shell script syntax with
	  backticks and double-quotes [#3196]
	* scripts/valgrind/valgrind.sh.in: revise shell script syntax with
	  backticks and double-quotes [#3196]
	* scripts/upsdrvsvcctl/upsdrvsvcctl.in: revise shell script syntax
	  with backticks and double-quotes [#3196]
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: revise shell
	  script syntax with backticks and double-quotes [#3196]
	* scripts/subdriver/gen-usbhid-subdriver.sh: revise shell script
	  syntax with backticks and double-quotes [#3196]
	* scripts/subdriver/gen-snmp-subdriver.sh: revise shell script syntax
	  with backticks and double-quotes [#3196]
	* scripts/python/app/NUT-Monitor: revise shell script syntax with
	  backticks and double-quotes [#3196]
	* scripts/obs/nut.spec: revise packaging and init shell script syntax
	  with backticks and double-quotes [#3196]
	* scripts/installer/aix/aix_init, scripts/installer/common/init,
	  scripts/installer/common/ipp-event.sh,
	  scripts/installer/common/ipp-host-shutdown.sample,
	  scripts/installer/common/ipp-os-shutdown,
	  scripts/installer/common/ipp-shutdown-daemon.sh,
	  scripts/installer/common/ipp-status,
	  scripts/installer/common/ipp-wrapper,
	  scripts/installer/common/shutdown, scripts/installer/install.sh,
	  scripts/installer/uninstall-ipp: scripts/installer/*: revise
	  packaging and init shell script syntax with backticks and
	  double-quotes [#3196]
	* scripts/Aix/nut.init.in, scripts/Solaris/postinstall.in,
	  scripts/Solaris/preinstall.in, scripts/Solaris/preremove.in,
	  scripts/Solaris/reset-ups-usb-solaris.sh.sample:
	  scripts/{Aix,Solaris}: revise packaging and init shell script
	  syntax with backticks and double-quotes [#3196]
	* scripts/fuse/execfuse-nut/getattr,
	  scripts/fuse/execfuse-nut/read_file,
	  scripts/fuse/execfuse-nut/readdir: scripts/fuse/*: revise shell
	  script syntax with backticks and double-quotes [#3196]
	* scripts/Windows/build-mingw-nut.sh,
	  scripts/Windows/build-mingw-prereqs.sh, scripts/Windows/dllldd.sh:
	  scripts/Windows/*.sh: revise shell script syntax with backticks and
	  double-quotes [#3196]
	* configure.ac, m4/ax_realpath.m4, m4/ax_realpath_lib.m4,
	  m4/nut_check_aspell.m4, m4/nut_check_libavahi.m4,
	  m4/nut_check_libfreeipmi.m4, m4/nut_check_libgd.m4,
	  m4/nut_check_libltdl.m4, m4/nut_check_libmodbus.m4,
	  m4/nut_check_libneon.m4, m4/nut_check_libnetsnmp.m4,
	  m4/nut_check_libnss.m4, m4/nut_check_libopenssl.m4,
	  m4/nut_check_libregex.m4, m4/nut_check_libusb.m4,
	  m4/nut_check_libwrap.m4, m4/nut_check_python.m4,
	  m4/nut_compiler_family.m4: configure.ac, m4/*.m4: revise shell
	  script syntax with backticks and double-quotes [#3196]
	* ci_build.sh: revise shell script syntax with backticks and
	  double-quotes [#3196]
	* autogen.sh: revise shell script syntax with backticks and
	  double-quotes [#3196]
	* tests/NIT/nit.sh: revise shell script syntax with backticks and
	  double-quotes [#3196]
	* tests/nut-driver-enumerator-test.sh: revise shell script syntax
	  with backticks and double-quotes [#3196]
	* tests/nut-driver-enumerator-test.sh: double-quote $0 name
	  inspection, safely for shell script syntax with backticks and
	  double-quotes [#3196]
	* tests/nut-driver-enumerator-test.sh: support passing-or-failing
	  tests (for syntax not supported by all of ksh implementations)
	  [#3196]
	* tests/nut-driver-enumerator-test.sh: report if the failure could be
	  due to unsupported or not-found shell interpreter [#3196]

=== 2025-11-23  Jim Klimov <jimklimov+nut@gmail.com>

	* tests/nut-driver-enumerator-test.sh: see now backticks and
	  doublequotes play together in different shells [#3196]

=== 2025-11-23  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* NEWS.adoc: Update the PR number.
	* NEWS.adoc, drivers/nutdrv_qx.c: nutdrv_qx: Hides QX_FLAG_NONUT
	  variables from syslog.  One can see them by raising the debug
	  level.  Tested on A1000

=== 2025-11-22  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am: shellcheck-nde: be sure to test freshly generated
	  script text
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in, NEWS.adoc: revise
	  message logging in the script [#3194]

=== 2025-11-21  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/nut.txt: update sentence markup; expand on built-in vs
	  configurable use of user/group accounts at run-time
	* docs/common.xsl, docs/man/asciidoc.conf.in: inherit style of
	  anchorjs permalinks from the (heading) element they are in [#3185]
	* drivers/tripplite_usb.c, NEWS.adoc: bump the version and add news
	  entry for PR #3192

=== 2025-11-20  rewsssiestedbo <48805403+rewsssiestedbo@users.noreply.github.com>

	* drivers/tripplite_usb.c: Update tripplite_usb.c to fix issue 3191
	  Use correct value (DEFAULT_UPSID) for the actual unit_id default
	  value instead of a 32-bit -1 value.   DEFAULT_UPSID is 65535, or a
	  {empty}16-bit -1 value.

=== 2025-11-20  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/nutdrv_qx_masterguard.c: driver/nutdrv_qx_masterguard.c:
	  bump version [#3181]

=== 2025-11-19  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/Makefile.am, Makefile.am, NEWS.adoc: introduce
	  SPELLCHECK_QUICK=true toggle for interactive mode to not re-check
	  documents that passed with older nut.dict  Follow-up to #2871
	* docs/common.xsl, docs/man/asciidoc.conf.in, COPYING, NEWS.adoc,
	  docs/nut.dict: stash a copy of "AnchorJS - v5.0.0 - 2023-01-18" to
	  add permalinks to HTML sections [#3185]  One for docbook => large
	  HTML (single and chunked docs, technically also PDF but it will
	  likely ignore the JavaScript or not see the tags where it goes),
	  another for manpages via xhtml.  Closes: #3185

=== 2025-11-17  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/nut.dict: add British "ageing" for the keyword on the progress
	  in getting old [#3181]
	* docs/new-drivers.txt, docs/nut.dict: docs/new-drivers.txt: document
	  addvar, getval and testvar, and nut_usb_addvars (and planned
	  ser/modbus siblings) [#2419, #2748]  Documentation addition
	  triggered by discussion in #3181

=== 2025-11-12  atanas-vladimirov <34871743+atanas-vladimirov@users.noreply.github.com>

	* NEWS.adoc: Update the PR number.

=== 2025-11-12  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: formatting and typo fixes for masterguard QX updates
	  [#3181]
	* UPGRADING.adoc: new *.html.sample templates to consider [#3180]
	* clients/upsclient.c: upscli_splitaddr(): highlight that currently a
	  "port" must be numeric
	* clients/upsc.c: return valid JSON documents also in case of error
	  [#3178]
	* clients/Makefile.am, common/Makefile.am, include/Makefile.am,
	  {common => include}/strjson.h: includes/strjson.h: keep common
	  headers in one place [#3178]
	* clients/Makefile.am: limit use of libcommonstrjson.la to upsc and
	  upsstats.cgi [#3178]
	* .github/workflows/01-make-dist.yml: shorten workflow name, move
	  details into job name [#1400]  The workflow name is a shared prefix
	  now for the job itself and for final "URL" entry that poses as a
	  GHA check result. A prefix too long hides valuable data, especially
	  in the latter case.

=== 2025-11-12  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* NEWS.adoc, data/cmdvartab, docs/man/nutdrv_qx.txt,
	  docs/nut-names.txt, docs/nut.dict, drivers/nutdrv_qx_masterguard.c:
	  nutdrv_qx_masterguard: Adds a clear.fault.record instant command
	  Also adds two experimental variables:  - battery.ageing.factor
	  ("Battery ageing factor in promille) and -
	  battery.calibration.factor (Battery calibration factor in percent).
	  Tested on A1000 and A2000 units
	* NEWS.adoc: Update the PR number.
	* NEWS.adoc, conf/upsstats-single.html.sample,
	  conf/upsstats.html.sample: upsstats*.html.sample: Enhance model
	  detection in upsstats HTML templates.  Some devices lack
	  `ups.model`, causing the CGI to incorrectly report "Not supported".
	* clients/Makefile.am: Make sure libcommonstrjson.la dependencies
	  exist

=== 2025-11-11  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/01-make-dist.yml: Create new GH Check report via
	  shell/cURL [#1400]
	* .github/workflows/01-make-dist.yml, NEWS.adoc, docs/download.txt:
	  drop experiments with updates of GH Check reports, and noise with
	  PR/commit comments - leave just a new GH Check entry with text of
	  the URL (and link to details page with clickable URL) [#1400]
	* clients/upsmon.c, scripts/systemd/nutshutdown.in: comments to
	  clarify that POWERDOWNFLAG can happen on both NUT servers and pure
	  client machines
	* configure.ac, NEWS.adoc: align British vs Americanish English
	  spelling [#1400]
	* clients/upsstats.c: json_escape(): reduce the char value
	  range-check [#3171]  Avoid `comparison is always true due to
	  limited range of data type` warning.

=== 2025-11-11  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* common/strjson.c, common/strjson.h: strjson.c, strjson.h: Add
	  newline at end of files
	* NEWS.adoc: Update the PR number.
	* Makefile.am, NEWS.adoc, clients/Makefile.am, clients/upsc.c,
	  clients/upsstats.c, common/Makefile.am, common/strjson.c,
	  common/strjson.h, docs/man/upsc.txt: upsc: Add -j option for JSON
	  output  This commit introduces a new `-j` command-line flag to
	  `upsc` to provide machine-readable JSON output for all operating
	  modes.  To support this and share logic with `upsstats`, the JSON
	  string escaping logic has been refactored into a new, reusable
	  module:  - A new helper function `json_print_esc()` now lives in
	  `common/strjson.c` - `common/Makefile.am` builds this as a new
	  `libcommonstrjson.la` library. - `clients/Makefile.am` links both
	  `upsc` and `upsstats` against this new library and adds the
	  `common/` include path. - `upsstats.c` is updated to use the shared
	  `json_print_esc()` function.

=== 2025-11-11  Andrew J. Kroll <xxxajk@gmail.com>

	* scripts/python/app/NUT-Monitor-py2gtk2.in,
	  scripts/python/app/NUT-Monitor-py3qt5.in: fix notification spamming

=== 2025-11-10  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/01-make-dist.yml: PoC with
	  LouisBrunner/checks-action to change the action/check entry itself
	  (as alternative to PR/commit comments) [#1400]
	* clients/upsstats.c: printf("%x") requires an UNSIGNED int argument
	  [#3171]
	* UPGRADING.adoc: `configure` script would now probe the OS for more
	  user and group account names [#3173]
	* configure.ac, NEWS.adoc: warn if `nobody` or `nogroup` end up being
	  used for a build [#3173]
	* configure.ac, NEWS.adoc, docs/configure.txt: support more default
	  user/group account names that may be defined in the OS [#3173]
	* NEWS.adoc: rephrase the upsstats\+JSON entry [#3171]

=== 2025-11-10  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* docs/man/upsstats.cgi.txt: Use `devices` instead of upses.

=== 2025-11-09  Jim Klimov <jimklimov+nut@gmail.com>

	* server/sstate.c, NEWS.adoc: wait a second before declaring UPS data
	  stale [#661]
	* docs/download.txt: align British vs Americanish English spelling
	  [#1400]
	* .github/workflows/01-make-dist.yml: drop MAKE_DIST_TOKEN [#1400]
	* .github/workflows/01-make-dist.yml: drop commented-away permissions
	  [#1400]
	* docs/download.txt: revise notes on snapshots (not only GitHub now)
	  and build types (git/dist) [#1400]

=== 2025-11-09  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* NEWS.adoc, clients/upsstats.c, docs/man/upsstats.cgi.txt: upsstats:
	  Add JSON output mode via ?json parameter  When the ?json (or &json)
	  parameter is added to the URL, upsstats.cgi will now bypass all
	  HTML template processing.  Instead, it returns a "Content-Type:
	  application/json" response containing the full data for the
	  requested UPS(es), including all variables, raw status, and parsed
	  status.  This provides a modern API for external monitoring tools
	  without affecting the existing HTML template functionality.

=== 2025-11-08  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/download.txt: move notes about building from source upwards
	  [#1400]
	* docs/download.txt: add intro for development sources chapter
	  [#1400]
	* NEWS.adoc: update about links to automatic dist tarballs [#1400]
	* .github/workflows/01-make-dist.yml: drop superfluous
	  comment-posting action [#1400]
	* .github/workflows/01-make-dist.yml: update comments [#1400]
	* .github/workflows/01-make-dist.yml: extend to contents:write
	  permission for commit comments [#1400]
	* .github/workflows/01-make-dist.yml: add links for running a custom
	  container inside GHA worker [#1400]
	* .github/workflows/01-make-dist.yml: expand criteria for comment
	  posting [#1400]
	* .github/workflows/01-make-dist.yml: debug-print inputs for
	  substitution [#1400]
	* .github/workflows/01-make-dist.yml: try to blend in the
	  github.event.pull_request.number to subst-github-ref-name [#1400]
	* .github/workflows/01-make-dist.yml: do not fail if we can not post
	  the commit comment [#1400]
	* .github/workflows/01-make-dist.yml: rephrase initial sticky note
	  for the PR [#1400]
	* .github/workflows/01-make-dist.yml: attempt to post a comment for
	  commit itself [#1400]
	* .github/workflows/01-make-dist.yml: uncomment attempts to post
	  comments with PR context only [#1400]
	* .github/workflows/01-make-dist.yml: drop the list of wider
	  permissions we experimented with [#1400]
	* .github/workflows/01-make-dist.yml: comment away one of the ways to
	  post a sticky comment; both seem to work well [#1400]
	* .github/workflows/01-make-dist.yml: try to report the more correct
	  Git SHA with the tarball link [#1400]
	* NEWS.adoc: fix asciidoc markup for upsset improvement [#3164]
	* .github/workflows/01-make-dist.yml: subst-github-ref-name prefer
	  github.head_ref (if set) since github.ref_name for
	  pull_request_target reports the target branch [#1400]
	* drivers/nhs_ser.c, NEWS.adoc: limit the use of baud rates by what
	  the OS does declare [#3163]

=== 2025-11-08  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* NEWS.adoc, clients/upsset.c: upsset.c: Recognize RANGE NUMBER and
	  NUMBER types.  Tested on Masterguard A1000 and A2000 units.

=== 2025-11-07  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/qa-guide.adoc: expand chapter on OBS [#1209]
	* .github/workflows/01-make-dist.yml: fix message [#1400]
	* .github/workflows/01-make-dist.yml: introduce "make
	  distcheck-completeness" to verify that our dist archives exactly
	  reproduce themselves [#2829]
	* Makefile.am, NEWS.adoc: introduce "make distcheck-completeness" to
	  verify that our dist archives exactly reproduce themselves [#2829]
	* .github/workflows/01-make-dist.yml: refer to links from GH checks
	  entry title [#1400]  We have hit some snags about changing the
	  artifact history or adding PR comments, at least before initially
	  merging the first PR that adds this workflow (so
	  `pull_request_target` has something to run from the master branch
	  at all). Even if this turns out to be the end of the road, at least
	  this way we can let people know where to find those generated
	  tarballs :)
	* .github/workflows/01-make-dist.yml: try pull_request_target again,
	  to use context of the main repo for actions [#1400]
	* .github/workflows/01-make-dist.yml: Revert
	  ".github/workflows/01-make-dist.yml: add permissions for delete
	  artifact [#1400]"  This reverts commit
	  {empty}621e0e71aed71da21521ecf7784ece4b892720d0.
	* .github/workflows/01-make-dist.yml: try using a custom
	  MAKE_DIST_TOKEN [#1400]
	* .github/workflows/01-make-dist.yml: add permissions for delete
	  artifact [#1400]
	* scripts/obs/debian.control: Revert "scripts/obs/debian.control:
	  dumb down the libmodbus requirement [#1209]"  This reverts commit
	  {empty}21e5d7a79d8e3432c6382252c667eae3fb9e6223. Dropped NUT CI OBS
	  support for platforms it still refuses to build instead.
	* scripts/obs/debian.control: Revert "scripts/obs/debian.control:
	  dumb down the libi2c requirement [#1209]"  This reverts commit
	  {empty}313e13e8fcae4f59d74ed20da7709d286dee14b7. Dropped NUT CI OBS
	  support for platforms it still refuses to build instead.
	* scripts/obs/nut.spec: Revert "scripts/obs/nut.spec: try to
	  constrain udev to non-RHEL [#1209]"  This reverts commit
	  {empty}2b1a596f364ab172d80bacdba17616c942503077. Dropped NUT CI OBS
	  support for platforms it still refuses to build instead.
	* scripts/obs/nut.spec: try to constrain udev to non-RHEL [#1209]
	* scripts/obs/debian.control: dumb down the libi2c requirement
	  [#1209]
	* scripts/obs/debian.control: dumb down the libmodbus requirement
	  [#1209]  Do not constrain the versions so it can build on Debian 9
	  and 10; Note that for USB support we would need our fork anyway
	  (until it gets merged to upstream, which may take years at their
	  pace).
	* scripts/obs/nut.spec: more constraints about what is available in
	  what distro versions [#1209]
	* scripts/obs/nut.spec: libltdl-devel (nut-scanner and consumers) and
	  libgd-devel (cgi) are not ubiquitous [#1209]
	* scripts/obs/nut.spec: fix "distro_version" numbers (some have extra
	  digits for sub-releases) [#1209]
	* scripts/obs/_config: no ccache in RHEL_7 it seems [#1209]
	* scripts/obs/_config: CentOS 10 depends on "either of"
	  util-linux(-core), so we must pick one [#1209]
	* scripts/obs/nut.spec: define NUTPKG_WITH_<DEPNAME> when we requre
	  the deps or not, based on distro/release [#1209]
	* scripts/obs/nut.spec: turn package availability/requirement for
	  NUTPKG_WITH_* upside down [#1209]
	* .github/workflows/01-make-dist.yml: comment about
	  substitute-string-action [#1400]
	* .github/workflows/01-make-dist.yml: try "issues: write" into
	  permissions [#1400]
	* .github/workflows/01-make-dist.yml: try more ways to post a PR
	  comment [#1400]

=== 2025-11-06  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/01-make-dist.yml: try to use GITHUB_TOKEN when
	  posting a PR comment - v2 [#1400]
	* .github/workflows/01-make-dist.yml: define permissions for
	  auto-generated GITHUB_TOKEN differently [#1400]
	* .github/workflows/01-make-dist.yml: no fatal problem if we can not
	  delete an older tarball [#1400]
	* .github/workflows/01-make-dist.yml: try to use GITHUB_TOKEN when
	  posting a PR comment [#1400]
	* .github/workflows/01-make-dist.yml: do not immediately fail the CI
	  job if we can not post actions-comment-pull-request (e.g. in a NUT
	  fork build) [#1400]
	* .github/workflows/01-make-dist.yml: after all use pull_request not
	  pull_request_target so there is an attached PR to comment into
	  [#1400]
	* .github/workflows/01-make-dist.yml: allow to fire on more branches
	  [#1400]
	* .github/workflows/01-make-dist.yml: try to fix permissions for PR
	  commenter [#1400]
	* .github/workflows/01-make-dist.yml: fix step IDs [#1400]
	* .github/workflows/01-make-dist.yml: "Try to get more Git metadata"
	  only if "git describe" is initially useless [#1400]
	* .github/workflows/01-make-dist.yml: tell actions/checkout to fetch
	  more git history right away [#1400]
	* .github/workflows/01-make-dist.yml: "Try to get more Git metadata"
	  earlier so we can debug it better [#1400]
	* .github/workflows/01-make-dist.yml: typo fix (renamed
	  subst-github-ref-name step) [#1400]
	* .github/workflows/01-make-dist.yml: flip TEST_REF for branches and
	  commits (prNNNN/merge) alike [#1400]
	* .github/workflows/01-make-dist.yml: different var for built SHA
	  [#1400]
	* .github/workflows/01-make-dist.yml: more trickery to make
	  git-describe work [#1400]
	* .github/workflows/01-make-dist.yml: debug subst-github-ref-name
	  [#1400]
	* .github/workflows/01-make-dist.yml: try to post a link to tarballs
	  on build page - v2 (message/comment in PRs) [#1400]
	* .github/workflows/01-make-dist.yml: there is no env.GITHUB_HEAD_REF
	  [#1400]
	* .github/workflows/01-make-dist.yml: act on tags too [#1400]
	* .github/workflows/01-make-dist.yml: pull whole repo if `git
	  describe` fails [#1400]
	* .github/workflows/01-make-dist.yml: try to post a link to tarballs
	  on build page [#1400]
	* .github/workflows/01-make-dist.yml: fix GHA scripting syntax;
	  update comments [#1400]
	* .github/workflows/01-make-dist.yml: more debugging of git workspace
	  [#1400]
	* .github/workflows/01-make-dist.yml: do not `make dist-sig` (via
	  `dist-files`) in the CI job [#1400]
	* .github/workflows/01-make-dist.yml, NEWS.adoc: introduce a CI job
	  to maintain `dist` tarballs of recent iterations [#1400, #2829]
	* .github/workflows/{codeql.yml => 05-codeql.yml},
	  .github/workflows/{PyNUTClient.yml => 08-PyNUTClient.yml}:
	  .github/workflows: re-number the jobs to hopefully impact
	  processing order on GHA farm [#1400]
	* Makefile.am, NEWS.adoc, docs/maintainer-guide.txt: introduce `make
	  dist-docs` [#1400]
	* Makefile.am: dist-hook: report if DISTing VERSION_FORCED* files
	* .github/workflows/codeql.yml: fix typo for ccache key name

=== 2025-11-05  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c: do not track
	  upsnotify_reported_extend_timeout_systemd, we do not limit by it
	  anyway [#3003]  ...and in the few cases this systemd notification
	  is used, we do want to see it all
	* common/common.c, NEWS.adoc: do not comment on "watchdog situation
	  logged once" if we do not actually log it before (visibly) [#3157]

=== 2025-11-03  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, drivers/dstate.c, drivers/dstate.h, drivers/main.c,
	  drivers/main.h: drivers/main.{c,h}, drivers/dstate.{c,h},
	  NEWS.adoc: track CHRG/DISCHRG reality in all drivers, verify
	  against what the device/protocol says [#3146]
	* drivers/usbhid-ups.c: only consider current_charge > 0 to rule out
	  a conversion error [#3156]
	* drivers/usbhid-ups.c: fix indentations
	* NEWS.adoc, common/state.c, docs/nut.dict, include/state.h:
	  common/state.c, include/state.h, NEWS.adoc: refactor with
	  difftime_st_tree_timespec() [#3156]
	* NEWS.adoc, drivers/dstate.c, drivers/dstate.h, drivers/main.c,
	  drivers/main.h: drivers/main.{c,h}, drivers/dstate.{c,h},
	  NEWS.adoc: track previous_battery_charge_value and
	  previous_battery_charge_timestamp [#3146]
	* clients/upsmon.c, include/common.h: tone down definition of
	  "infinity" by a notch [#3003]

=== 2025-10-31  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, drivers/usbhid-ups.c, drivers/usbhid-ups.h:
	  drivers/usbhid-ups.{c,h}, NEWS.adoc: consider FULLYCHARGED and
	  NOTFULLYCHARGED separately, because many subdrivers report neither;
	  fall back to checking battery.charge=?100 to set CHRG flag [#3146]

=== 2025-10-30  NOV <149171388+NohanV@users.noreply.github.com>

	* drivers/cyberpower-mib.c: Add SNMP info for ups.realpower

=== 2025-10-30  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/libusb0.c, drivers/libusb1.c: drivers/libusb{0,1}.c:
	  nut_libusb_open(): drop commented-away "goto next_device" now that
	  we have a loop and "continue" to try another rdlen [#3136]
	* drivers/cyberpower-mib.c: bump CYBERPOWER_MIB_VERSION for added
	  ups.realpower [#3154]
	* configure.ac, scripts/systemd/nut-monitor.service.in: introduce
	  SYSTEMD_DAEMON_TIMEOUT_STOP_UPSMON substitution [#3003]
	* clients/upsmon.c: use upsnotify(NOTIFY_STATE_EXTEND_TIMEOUT, ...)
	  to protect from systemd or similar framework killing us by timeout
	  [#3033]
	* common/common.c, include/common.h, NEWS.adoc: Introduced
	  `NOTIFY_STATE_EXTEND_TIMEOUT` option and relevant variables [#3003]
	* common/common.c: upsnotify(): comment since which systemd versions
	  different features are supported

=== 2025-10-29  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* docs/man/nutdrv_qx.txt: Fix the formatting of VOLTRONIC-AXPERT
	  UNITS

=== 2025-10-27  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsmon.c, NEWS.adoc: doshutdown() etc: tickle (systemd)
	  watchdog instead of long quietness when shutting down [#3003]
	* NEWS.adoc, drivers/libusb0.c, drivers/libusb1.c:
	  drivers/libusb{0,1}.c, NEWS.adoc: if the tried "rdlen" did not
	  succeed, fall back to the other value we had in mind [#3136]  In
	  libusb1.c also fix printout of rdlen variables from %d to %PRIi32

=== 2025-10-26  Jim Klimov <jimklimov+nut@gmail.com>

	* .obs/workflows.yml: retarget to "home:networkupstools:*" OBS
	  project for now, and expand workflows for PRs, master iterations
	  and tag releases [#1209]
	* .obs/workflows.yml: extend workflow definition [#1209]  Revised
	  docs at
	  https://openbuildservice.org/help/manuals/obs-user-guide/cha-obs-scm-ci-workflow-integration#sec.obs.obs_scm_ci_workflow_integration.setup.token_authentication.how_to_authenticate_scm_with_obs
	* .obs/workflows.yml: Introduce an OBS workflow [#1209]  Follow
	  https://openbuildservice.org/2021/05/31/scm-integration/
	  instructions

=== 2025-10-25  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/obs/Makefile.am: fix EXTRA_DIST list

=== 2025-10-24  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, docs/nut.dict: NEWS.adoc: announce upstreamed OBS
	  packaging recipes [#1209, #1316, #3144]
	* tests/NIT/nit.sh: detect PYTHON from caller-provided PYTHON_DEFAULT
	  as fallback interpreter [#3130]
	* configure.ac: on MacOS, also pass PYTHON_DEFAULT via /usr/bin/env
	  [#3130]
	* tests/NIT/nit.sh: detect PYTHON from PY_SHEBANG (or use a
	  caller-provided one) as explicit interpreter [#3130]  CircleCI does
	  see the correct shebang and the script as executable, but
	  apparently tries to call it as a shell script and fails. Maybe
	  /Users/distiller/.pyenv/shims/python3.13 is broken though?.. Or we
	  hit https://github.com/NixOS/nixpkgs/issues/65351/ ?
	* .circleci/config.yml: set DEBUG_NIT=true to troubleshoot python
	  test client runs [#3130]
	* tests/NIT/nit.sh: shouldDebug(): extend with a variable that can be
	  set specifically for this script
	* .circleci/config.yml: opt out of blobless checkouts
	* .circleci/config.yml: update from XCode-13.4.1 to XCode-16.4  Older
	  releases are deprecated and to be removed in November: *
	  https://circleci.com/changelog/deprecation-of-eol-xcode-versions/ *
	  https://circleci.com/changelog/images/#filtered
	* tests/NIT/nit.sh: revise isTestablePython() possible outcomes
	  [#3130]
	* .github/workflows/PyNUTClient.yml: update to use PYTHON_DEFAULT
	  varname now expected by scripts/python/module/Makefile.am [#3130]
	* NEWS.adoc, UPGRADING.adoc: warn about renamed data/html{,cgi}
	  source dir [#3049]
	* lib/.gitignore, lib/libupsclient-config.in:
	  lib//libupsclient-config.in, lib/.gitignore: README=>README.adoc
	  renamed a while ago
	* NEWS.adoc, UPGRADING.adoc: warn about renamed data/html{,cgi}
	  source dir [#3049]
	* scripts/obs/debian.nut-cgi.docs: align with renaming of data/html
	  => data/htmlcgi

=== 2025-10-23  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, drivers/apc-hid.c, drivers/apc_modbus.c,
	  drivers/arduino-hid.c, drivers/bcmxcp_usb.c, drivers/blazer_usb.c,
	  drivers/cps-hid.c, drivers/delta_ups-hid.c, drivers/legrand-hid.c,
	  drivers/liebert-hid.c, drivers/mge-hid.c,
	  drivers/nutdrv_atcl_usb.c, drivers/richcomm_usb.c: drivers/*.c,
	  NEWS.adoc: revised use of NUT macros for USB Vendor IDs  [#3139]
	* drivers/usb-common.h: update comment about USB_DEVICE() macro
	* drivers/nutdrv_qx.c: use symbolic names for USB Vendor IDs [#3139]
	* data/driver.list.in: add Ippon Innova TAE 1000 [#3137, #3139]
	* NEWS.adoc, UPGRADING.adoc, drivers/nutdrv_qx.c:
	  drivers/nutdrv_qx.c: add USB ID based detection for innovatae
	  protocol [#3137, #3139]
	* NEWS.adoc, UPGRADING.adoc, docs/nut.dict: list new
	  nutdrv_qx_innovatae protocol support [#issue 3137, PR #3139]

=== 2025-10-22  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/nut.dict: update for NEWS of PR #3141
	* m4/nut_check_libregex.m4, NEWS.adoc: Added configure script options
	  for libregex tuning [#3140, #3049]
	* NEWS.adoc, docs/nut.dict: update about logging the source of
	  CFLAGS/LIBS/LDFLAGS values [#3049, #3140]
	* m4/nut_check_libsystemd.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libpowerman.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libopenssl.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libnss.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libgpiod.m4: fix the var names we "unset" in the end
	  [#3049]
	* m4/nut_check_libneon.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libmodbus.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libnetsnmp.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libltdl.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libgpiod.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libavahi.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libusb.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libgd.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libfreeipmi.m4: track and report
	  depCFLAGS_SOURCE/depLIBS_SOURCE consistently [#3049]
	* m4/nut_check_libfreeipmi.m4: comment a reminder about numerous libs
	  that we can resolve here (with one being correct) [#3049]
	* m4/nut_arg_with.m4: revise brackets to pass arguments with commas
	  in the value correctly [#3049]
	* m4/nut_arg_with.m4: Revert "m4/nut_arg_with.m4: simplify with use
	  of m4_default() [#3049]"  This reverts commit
	  {empty}9eba1eb885e9d29f3d8ecef7637010899661cb54, seems autoconf (or
	  myself) gets lost in the maze of m4_default with or without
	  brackets, especially when arguments with commas are involved.

=== 2025-10-22  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* NEWS.adoc, drivers/nutdrv_qx_masterguard.c: nutdrv_qx_masterguard:
	  Bump MASTERGUARD_VERSION to 0.04  And updates the NEWS.adoc in
	  regards of PR [#3141]  Tested on Masterguard A1000 and A2000 units.
	* drivers/nutdrv_qx_masterguard.c: nutdrv_qx_masterguard: Makes the
	  deep battery test command works  The test.battery.start.deep (TUD)
	  command requires the slave address as a parameter to function.
	  Following the fix to masterguard_add_slaveaddr in the previous
	  commit, this command can now be properly enabled.  Tested on
	  Masterguard A1000 and A2000 units.

=== 2025-10-21  Viktor Drobot <linux776@gmail.com>

	* drivers/nutdrv_qx_innovatae.c: More info about firmware version in
	  bogus  reply

=== 2025-10-21  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: update notes for #3049 and #3140
	* ci_build.sh: check more ARCH and BITS sources for illumos/Solaris
	  pkgconfig path guessing
	* m4/nut_check_libnetsnmp.m4: fix new --with-net-snmp-config=auto
	  mode [#3049]
	* NEWS.adoc: update entry with PR number
	* m4/nut_arg_with.m4: NUT_ARG_WITH_LIBOPTS_CONFIGSCRIPT_IMPLEM: drop
	  extra brackets [#3049]
	* m4/nut_check_libusb.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_libnetsnmp.m4, m4/nut_check_libsystemd.m4:
	  m4/nut_check_libnetsnmp.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_libpowerman.m4: refactor to word the help and
	  determine options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_libopenssl.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_pkgconfig.m4: refactor NUT_ARG_* help and
	  determination of --with-pkg-config [#3049]
	* m4/nut_check_libnss.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_libneon.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_libmodbus.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_check_libltdl.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* configure.ac, NEWS.adoc: there was never a
	  scripts/devd/nut-usbups.rules.in (probably a copy-paste typo in NUT
	  v2.8.0)
	* configure.ac, scripts/devd/README.adoc: revise help and doc
	  regarding FreeBSD devd snippet file installation
	* m4/nut_arg_with.m4: simplify with use of m4_default() [#3049]
	* m4/nut_check_libgpiod.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_arg_with.m4: extend NUT_ARG_WITH_LIBOPTS* with optional
	  alternate spelling of project name for help text [#3049]
	* configure.ac: rephrase help for (alt)pidpath [#3049]
	* m4/nut_check_libgd.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_arg_with.m4: add NUT_ARG_WITH_LIBOPTS_LIBS_AS_LDFLAGS and
	  NUT_ARG_WITH_LIBOPTS_LDFLAGS for cosmetic completeness [#3049]
	* m4/nut_arg_with.m4: rearrange NUT_ARG_WITH_LIBOPTS_INCLUDES and
	  NUT_ARG_WITH_LIBOPTS_LIBS using renamed
	  NUT_ARG_WITH_LIBOPTS_INVALID_YESNO; use simpler
	  NUT_ARG_WITH_LIBOPTS for new NUT_ARG_WITH_LIBOPTS_CONFIGSCRIPT*
	  methods [#3049]
	* m4/nut_check_libfreeipmi.m4: refactor to word the help and
	  determine options via NUT_ARG_WITH_LIBOPTS* [#3049]

=== 2025-10-21  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* drivers/nutdrv_qx_masterguard.c: nutdrv_qx_masterguard: Fix
	  masterguard_add_slaveaddr return value  The
	  masterguard_add_slaveaddr function, defined as a preprocess_command
	  handler, must return the length of the command string it has
	  processed. It was incorrectly returning 0.  This caused the main
	  qx_process function to see a 0-byte command length, resulting in a
	  send: timeout (0) debug log and a failure to send the command to
	  the UPS.  This commit fixes the function to return the correct
	  command length (which was already stored in the local variable l),
	  resolving the bug for all commands that use the ,XX slave address
	  placeholder.  Tested on Masterguard A1000 and A2000 units.

=== 2025-10-20  Viktor Drobot <linux776@gmail.com>

	* docs/nut.dict: Forgot to add to dict
	* docs/man/nutdrv_qx.txt, docs/nutdrv_qx-subdrivers.txt,
	  drivers/Makefile.am, drivers/nutdrv_qx.c,
	  drivers/nutdrv_qx_blazer-common.c,
	  drivers/nutdrv_qx_blazer-common.h, drivers/nutdrv_qx_innovatae.c,
	  drivers/nutdrv_qx_innovatae.h: Basic Ippon Innova TAE support

=== 2025-10-20  Jim Klimov <jimklimov+nut@gmail.com>

	* m4/nut_check_libavahi.m4: refactor to word the help and determine
	  options via NUT_ARG_WITH_LIBOPTS* [#3049]
	* m4/nut_arg_with.m4: introduce NUT_ARG_WITH_LIBOPTS* [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-CCACHE_NAMESPACE [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --enable-extapi-enphase [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-user and --with-group (reword the latter) [#3049, #3120]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-valgrind [#3049]
	* configure.ac: move SYSTEM_AIX and CPU_TYPE determination way up, to
	  where we detect other aspects of the build target
	* configure.ac: refactor NUT_ARG_* help and determination of udev,
	  hotplug, devd, freebsdquirksdir paths [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-augeas-lenses-dir [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --enable-cppunit [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of systemd
	  paths [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  Solaris/illumos packaging options, fix a few logical mismatches
	  [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  PKGCONFIGDIR [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --enable-strip (and actually fix a missed compiler family
	  dependency) [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --enable-force-nut-version-header (and actually fix default report
	  vs. setting) [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-logfacility [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-port [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --enable-check-NIT [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  --with-doc(s) and --with-docs-changelog* tunables [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  DEFAULT_MAN_* tunables [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  CGIDATAPATH [#3049]

=== 2025-10-19  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am, configure.ac, data/Makefile.am, data/{html =>
	  htmlcgi}/.gitignore, data/{html => htmlcgi}/Makefile.am, data/{html
	  => htmlcgi}/README.adoc, data/{html => htmlcgi}/bottom.html,
	  data/{html => htmlcgi}/header.html.in, data/{html =>
	  htmlcgi}/index.html, data/{html => htmlcgi}/nut-banner.png,
	  docs/configure.txt, docs/nut.dict: configure.ac, *.am: rename
	  "htmldir" to "htmlcgidir", "data/html" to "data/htmlcgi", CGIPATH
	  to CGIEXECPATH, and tentatively HTMLPATH to CGIDATAPATH (and
	  actually expose the latter two from configure script) [#3049]
	* data/html/Makefile.am: ensure that HTML files for CGI are in dist
	  tarball
	* configure.ac: add separators between unrelated subjects, revise
	  comments
	* configure.ac: refactor NUT_ARG_* help and determination of CGIPATH
	  [#3049]
	* NEWS.adoc, docs/man/nutdrv_qx.txt: update regarding
	  test.battery.start.low [#3135]

=== 2025-10-18  Atanas Vladimirov <vladimirov.atanas@gmail.com>

	* data/cmdvartab, docs/nut-names.txt,
	  drivers/nutdrv_qx_masterguard.c: nutdrv_qx_masterguard: Adds
	  battery test until battery low.  The difference between the battery
	  test until battery low and deep battery test is that the latter is
	  actually a battery calibration test and needs some preconditions to
	  be met, i.e. the load must be between 30% and 100% and the battery
	  capacity is greater than 99%.  Battery test until battery low can
	  be started anytime.  Tested on Masterguard A1000 and A2000 units.

=== 2025-10-17  Jim Klimov <jimklimov+nut@gmail.com>

	* configure.ac: refactor NUT_ARG_* help and determination of DRVPATH
	  [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  POWERDOWNFLAG [#3049]
	* configure.ac: refactor NUT_ARG_* help and determination of
	  STATEPATH, PIDPATH and ALTPIDPATH [#3049]
	* configure.ac: define "confdir-suffix" via 4-arg syntax of
	  NUT_ARG_WITH; rephrase other confdir options to say =PATH =>
	  =DIRPATH [#3049]
	* m4/nut_arg_with.m4: clarify that parentheses mean "default:" and
	  *_SINGLEQUOTE values are "resolved from" [#3049]
	* m4/nut_arg_with.m4: extend NUT_ARG_ENABLE and NUT_ARG_WITH to
	  optionally accept one more (second) argument for "...=VALUES"
	  [#3049]
	* m4/nut_arg_with.m4: extend NUT_ARG_ENABLE_CUSTOM_DEFAULT_HELP and
	  NUT_ARG_WITH_CUSTOM_DEFAULT_HELP to short-circuit $5==$4 if $5 is
	  not specified [#3049]
	* m4/nut_arg_with.m4: more uniquely name the conftemp variables
	  [#3049]
	* m4/nut_arg_with.m4: update comments [#3049]

=== 2025-10-16  Jim Klimov <jimklimov+nut@gmail.com>

	* configure.ac, m4/nut_arg_with.m4: extend newer
	  NUT_ARG_WITH_CUSTOM_DEFAULT_HELP, NUT_ARG_WITH_EXPAND_DEFAULT_HELP
	  etc. methods to optionally print "--with-VARNAME=VALUES" formatted
	  messages [#3049]
	* m4/nut_arg_with.m4: fix passing of conftemp (non-verbatim per se)
	  [#3049]
	* configure.ac, m4/nut_arg_with.m4: m4/nut_arg_with.m4, configure.ac,
	  NEWS.adoc: refactor with ability to provide custom representation
	  for default value in AS_HELP_STRING message [#3049]
	* configure.ac: fix typo in help message for --with-CCACHE_NAMESPACE
	* Makefile.am: install-as-root: fix typo after replacement of @VAR@
	  to $(VAR) [#3131]
	* Makefile.am, NEWS.adoc, UPGRADING.adoc, ci_build.sh,
	  conf/Makefile.am, configure.ac, docs/configure.txt,
	  docs/man/apc_modbus.txt, docs/nut.dict, docs/packager-guide.txt,
	  lib/libnutclient.pc.in, lib/libnutclientstub.pc.in,
	  lib/libnutconf.pc.in, lib/libnutscan.pc.in,
	  lib/libupsclient-config.in, lib/libupsclient.pc.in,
	  scripts/Aix/nut-aix.spec.in,
	  scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: configure.ac,
	  docs/configure.txt, lib/*.pc.in, *.am et al: introduce
	  --with-confdir*= options, separate delivery of sample configs
	  [#3131]
	* Makefile.am: install-as-root: use make variables for paths and
	  package version [#3131]
	* m4/nut_check_python.m4, scripts/Solaris/Makefile.am,
	  scripts/Solaris/precheck.py.in, scripts/augeas/Makefile.am,
	  scripts/augeas/gen-nutupsconf-aug.py.in,
	  scripts/python/module/Makefile.am,
	  scripts/python/module/PyNUT.py.in,
	  scripts/python/module/test_nutclient.py.in, tools/Makefile.am,
	  tools/gitlog2changelog.py.in, tools/nut-snmpinfo.py.in:
	  m4/nut_check_python.m4, *.am, *.py.in: introduce PYTHON_DEFAULT to
	  track the implementation to substitute into shebangs or use as tool
	  calls [#1792]

=== 2025-10-15  Jim Klimov <jimklimov+nut@gmail.com>

	* m4/nut_check_python.m4: separate NUT_CHECK_PYTHON_DEFAULT_BEST and
	  NUT_CHECK_PYTHON_INTERIM_RESULTS, and implement discarding of
	  "auto-prio" hits if another hit exists (yes, explicit, auto)
	  [#1792]  It seems `AC_REQUIRE()` calls have priority over other
	  code lines in a method, and get executed first - so using extra
	  methods (also for clearer code base).
	* docs/configure.txt: clarify --with-python*=yes; fix markup [#1792]
	* m4/nut_check_python.m4: separate NUT_CHECK_PYTHON*_SITE_PACKAGES
	  into dedicated methods, to honour forgetting of interpreters due to
	  auto-prio [#1792]
	* m4/nut_check_python.m4, NEWS.adoc, UPGRADING.adoc,
	  INSTALL.nut.adoc, docs/configure.txt, docs/nut.dict: change default
	  to auto-prioritize some one available python interpreter [#1792]

=== 2025-10-14  Jim Klimov <jimklimov+nut@gmail.com>

	* ci_build.sh: pkg-rpm\|pkg-spec: fix rpmbuild callout
	* ci_build.sh, scripts/obs/_service, scripts/obs/{debian.nut.changes
	  => nut.changes}: scripts/obs/nut.changes: isn't it a placeholder
	  for RPM changelog?
	* INSTALL.nut.adoc: mention some surprising configure options, like
	  the many --with-python* settings, and a --sysconfdir override
	  [#1792]
	* docs/configure.txt, docs/nut.dict: revise the section on
	  --with-python* settings [#1792]
	* NEWS.adoc, configure.ac: configure.ac: warn if several python
	  versions were AUTO-detected and configured [#1792]

=== 2025-10-13  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/obs/debian.rules: make list-missing optional (absent in new
	  cdbs)
	* scripts/obs/debian.rules: do not mislead about lack of dh_python2
	  due to our own tests
	* scripts/obs/debian.rules: update for bleeding-edge CDBS that lacks
	  many scripts
	* docs/configure.txt: clarify that --with-group is barely used
	  directly by daemons [#3120]
	* Makefile.am: spellcheck-interactive: follow-up with a
	  spellcheck-quick to soak up timestamp changes of the dictionary
	  file
	* drivers/snmp-ups.c: comment about us not parsing the port from
	  device_path
	* configure.ac: when we suggest to "make" after "configure" is done,
	  have a fallback if MAKE was not defined/exported
	* NEWS.adoc: Revert "NEWS.adoc: Fallout of the refactoring of drivers
	  to use `shutdown.*` commands consistently [#1962]"  This reverts
	  commit 15bc72b0ae7952fe30b013b48eebfd7a6c9bf0a7 prepared problem
	  log was not a problem after all.
	* drivers/victronups.c: fix whitespace markup; translate comments
	* drivers/victronups.c, NEWS.adoc: reshuffle code -- upsdrv_initups()
	  is for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/usbhid-ups.c, NEWS.adoc: reshuffle code -- upsdrv_initups()
	  is for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/powervar_cx_ser.c, NEWS.adoc: reshuffle code --
	  upsdrv_initups() is for preparing comms; upsdrv_initinfo() is for
	  first using them [#1962]
	* drivers/powercom.c, NEWS.adoc: reshuffle code -- upsdrv_initups()
	  is for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/pijuice.c, NEWS.adoc: reshuffle code -- upsdrv_initups() is
	  for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/phoenixcontact_modbus.c, NEWS.adoc: reshuffle code --
	  upsdrv_initups() is for preparing comms; upsdrv_initinfo() is for
	  first using them [#1962]
	* drivers/oneac.c, NEWS.adoc: reshuffle code -- upsdrv_initups() is
	  for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/mge-utalk.c, NEWS.adoc: reshuffle code -- upsdrv_initups()
	  is for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/metasys.c, NEWS.adoc: reshuffle code -- upsdrv_initups() is
	  for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/masterguard.c, NEWS.adoc: reshuffle code --
	  upsdrv_initups() is for preparing comms; upsdrv_initinfo() is for
	  first using them [#1962]
	* drivers/gamatronic.c: upsdrv_initups(): update comments [#1962]
	* drivers/everups.c, NEWS.adoc: reshuffle code -- upsdrv_initups() is
	  for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/bicker_ser.c, NEWS.adoc: reshuffle code -- upsdrv_initups()
	  is for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/bestuferrups.c, NEWS.adoc: reshuffle code --
	  upsdrv_initups() is for preparing comms; upsdrv_initinfo() is for
	  first using them [#1962]
	* drivers/bestfortress.c, NEWS.adoc: reshuffle code --
	  upsdrv_initups() is for preparing comms; upsdrv_initinfo() is for
	  first using them [#1962]

=== 2025-10-12  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/asem.c, NEWS.adoc: reshuffle code -- upsdrv_initups() is
	  for preparing comms; upsdrv_initinfo() is for first using them
	  [#1962]
	* drivers/upscode2.c: fix indentation
	* drivers/powervar_cx.c, drivers/powervar_cx.h:
	  drivers/powervar_cx.{c,h}: fix setcmd()->setvar() for consistency
	  [#1962]
	* NEWS.adoc, docs/nut.dict, drivers/powerp-bin.c,
	  drivers/powerp-txt.c: drivers/powerp-{txt,bin}.c: install instcmd
	  and setvar handlers [#1962]
	* drivers/optiups.c: fix indentation broken in white-space
	  refactoring of early NUT v2.8.x evolution [#1962]
	* drivers/oneac.c: fix setcmd()->setvar() for consistency [#1962]
	* drivers/metasys.c: avoid spurious void return at end of
	  upsdrv_initinfo() [#1962]
	* drivers/main.c: better log the progress for killpower via running
	  driver instance
	* drivers/riello_ser.c: relocate methods to match structure of
	  riello_usb.c to ease the comparisons
	* NEWS.adoc, drivers/riello_ser.c, drivers/riello_usb.c:
	  drivers/riello_{ser,usb}.c: refactor parse_ups_status() and do not
	  constrain "shutdown.return" and "load.*" INSTCMD with whether the
	  UPS is known to be on battery or not [#1962]
	* scripts/Solaris/Makefile.am: "target_cpu=sparc" is inconclusive
	  about binary bitness [#3099]
	* NEWS.adoc: Fallout of the refactoring of drivers to use
	  `shutdown.*` commands consistently [#1962]
	* configure.ac: refactor echo of NUT_SOURCE_VERSION_REPORT, and
	  suggest to "make" after "configure" is done  Many projects do this
	  latter convenience for beginner users. Seems nice.

=== 2025-10-11  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, docs/man/apcupsd-ups.txt, docs/nut.dict,
	  drivers/apcupsd-ups.c: drivers/apcupsd-ups.c, docs: migrate from
	  gethostbyname() to getaddrinfo(); become IPv6 capable [#1209]
	* drivers/apcupsd-ups.c: revise comments and markup
	* drivers/apcupsd-ups.c: use strrchr(device_path,:) to look for LAST
	  colon, since bare IPv6 addresses contain colons too [#1209]
	* drivers/apcupsd-ups.c: update comments about default port 3551
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: avoid logging
	  bogus-looking "OK" confirming undeclared activities [#3099]
	* docs/config-notes.txt, docs/configure.txt, docs/man/nut.txt,
	  docs/man/upsmon.conf.txt: clarify /run vs. /var/run [#3099]
	* configure.ac, NEWS.adoc, UPGRADING.adoc: `PIDPATH` is now more
	  strictly `/var/run`, unless `/run` is more preferable for good
	  reason [#3099]

=== 2025-10-10  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/obs/nut.spec: update comment about python locations
	* scripts/obs/nut.spec: hide %dir /var/log (we do not own it),
	  suffice to mkdir it in build area to match our logrotate
	  configuration
	* scripts/obs/nut.spec: nut-monitor requires python-base
	* scripts/obs/_config: track a copy of prjconf data
	* scripts/obs/README.adoc: update notes on OBS prjconf
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: fix svccfg
	  setprop for multiple DEPSVC FMRIs [#3099]  Co-authored-by: Nick
	  Briggs <nicholas.h.briggs@gmail.com>
	* NEWS.adoc, UPGRADING.adoc, docs/nut.dict, m4/nut_check_python.m4:
	  m4/nut_check_python.m4: try harder to report the "purelib" location
	  as PYTHON*_SITE_PACKAGES [#1209]
	* NEWS.adoc, docs/nut.dict, tests/NIT/Makefile.am, tests/NIT/nit.sh:
	  tests/NIT/nit.sh, tests/NIT/Makefile.am, NEWS.adoc: let test runs
	  started as root in under-provisioned environments tweak user/group
	  to what is available [#1209]
	* NEWS.adoc: one more Eaton USB ID supported [#2380]

=== 2025-10-09  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/obs/nut.spec: register other service units (enablement is
	  via presets after all)
	* scripts/obs/nut.spec, scripts/obs/debian.rules: enable storing
	  build configuration and checking the build with NUT Integration
	  Tests suite, and strip binaries of debug symbols
	* scripts/obs/nut.spec: deduplicate man page files with symlinks
	* scripts/obs/nut.spec: reduce layering of HTMLPATH under
	  apache_serverroot_data
	* scripts/obs/nut.spec: reduce layering of CGIPATH under
	  apache_serverroot_cgi
	* scripts/obs/nut.spec: anticipate something like
	  /usr/lib64/python2.7/site-packages/ too
	* scripts/obs/nut.spec: keep excluding from main package stuff that
	  should be in others
	* scripts/obs/nut.spec: revise delivery of CGI artifacts as %dir
	* scripts/obs/nut.spec: address SUSE rpmlint issues with "make check"
	  section
	* scripts/obs/nut.spec: address SUSE rpmlint issues with
	  scripted-only NUT-Monitor package
	* scripts/obs/nut.spec: address SUSE rpmlint issues with logrotate
	* scripts/obs/nut.spec: deliver libs each in its ABI-version-named
	  package
	* scripts/obs/nut.spec: comment away "%dir" and "%exclude" hacks that
	  felt superfluous and probably are
	* scripts/obs/nut.spec: revise pre/port-in/un snippets
	* scripts/obs/nut.spec: do not relocate upssched-cmd to hard-coded
	  /bin
	* scripts/obs/nut.spec: fence delivery of systemd files (check if we
	  could resolve the the paths involved)
	* scripts/obs/nut.spec: fix systemdtmpfilesdir determination
	* scripts/obs/nut.spec: BuildRequires:  libxml2-devel
	* scripts/obs/nut.spec: dep on accounts for pkg self-test does not
	  work like this
	* scripts/obs/nut.spec: dep on chroot does not work like this
	* scripts/obs/nut.spec: do not package directly-named "/bin" objects
	* scripts/obs/nut.spec: require more tools for SUSE platform tests on
	  OBS
	* scripts/obs/nut.spec: require user/group for post-install script
	  context
	* scripts/obs/nut.spec: refactor how we get HTMLPATH and CGIPATH,
	  they may be different in APXS output
	* scripts/obs/nut.spec: let the SPEC version reflect in NUT
	  self-identification
	* ci_build.sh: add failsafes into pkg* build types
	* docs/nut.dict, scripts/obs/README.adoc: scripts/obs/README.adoc:
	  update with Practical setup and Other notes
	* scripts/obs/Makefile.am, scripts/obs/_service:
	  scripts/obs/_service: add a copy of working OBS recipe
	* Makefile.am, ci_build.sh, configure.ac, scripts/Makefile.am, {obs
	  => scripts/obs}/Makefile.am, {obs => scripts/obs}/README.adoc, {obs
	  => scripts/obs}/debian.Makefile.am, {obs =>
	  scripts/obs}/debian.NEWS, {obs => scripts/obs}/debian.changelog,
	  {obs => scripts/obs}/debian.compat, {obs =>
	  scripts/obs}/debian.control, {obs => scripts/obs}/debian.copyright,
	  {obs => scripts/obs}/debian.description.subst, {obs =>
	  scripts/obs}/debian.gbp.conf, {obs => scripts/obs}/debian.hotplug,
	  {obs => scripts/obs}/debian.libnutclient-dev.install, {obs =>
	  scripts/obs}/debian.libnutclient-dev.manpages, {obs =>
	  scripts/obs}/debian.libnutclient1.install, {obs =>
	  scripts/obs}/debian.libnutclient1.lintian-overrides, {obs =>
	  scripts/obs}/debian.libnutclientstub-dev.install, {obs =>
	  scripts/obs}/debian.libnutclientstub1.install, {obs =>
	  scripts/obs}/debian.libnutclientstub1.lintian-overrides, {obs =>
	  scripts/obs}/debian.libnutscan-dev.install, {obs =>
	  scripts/obs}/debian.libnutscan1.install, {obs =>
	  scripts/obs}/debian.libups-nut-perl.install, {obs =>
	  scripts/obs}/debian.libupsclient-dev.install, {obs =>
	  scripts/obs}/debian.libupsclient-dev.manpages, {obs =>
	  scripts/obs}/debian.libupsclient4.install, {obs =>
	  scripts/obs}/debian.nut-cgi.README.Debian, {obs =>
	  scripts/obs}/debian.nut-cgi.docs, {obs =>
	  scripts/obs}/debian.nut-cgi.install, {obs =>
	  scripts/obs}/debian.nut-cgi.manpages, {obs =>
	  scripts/obs}/debian.nut-cgi.postinst, {obs =>
	  scripts/obs}/debian.nut-cgi.postrm, {obs =>
	  scripts/obs}/debian.nut-client.init.in, {obs =>
	  scripts/obs}/debian.nut-client.install, {obs =>
	  scripts/obs}/debian.nut-client.links, {obs =>
	  scripts/obs}/debian.nut-client.lintian-overrides, {obs =>
	  scripts/obs}/debian.nut-client.maintscript, {obs =>
	  scripts/obs}/debian.nut-client.manpages, {obs =>
	  scripts/obs}/debian.nut-client.postinst, {obs =>
	  scripts/obs}/debian.nut-client.preinst, {obs =>
	  scripts/obs}/debian.nut-client.prerm, {obs =>
	  scripts/obs}/debian.nut-common.install, {obs =>
	  scripts/obs}/debian.nut-common.postinst.in, {obs =>
	  scripts/obs}/debian.nut-common.prerm.in, {obs =>
	  scripts/obs}/debian.nut-common.tmpfiles.in, {obs =>
	  scripts/obs}/debian.nut-doc.doc-base.nut-developer-guide, {obs =>
	  scripts/obs}/debian.nut-doc.doc-base.nut-faq, {obs =>
	  scripts/obs}/debian.nut-doc.doc-base.nut-packager-guide, {obs =>
	  scripts/obs}/debian.nut-doc.doc-base.nut-user-manual, {obs =>
	  scripts/obs}/debian.nut-doc.install, {obs =>
	  scripts/obs}/debian.nut-ipmi.install, {obs =>
	  scripts/obs}/debian.nut-ipmi.manpages, {obs =>
	  scripts/obs}/debian.nut-linux-i2c.install, {obs =>
	  scripts/obs}/debian.nut-linux-i2c.manpages, {obs =>
	  scripts/obs}/debian.nut-modbus.install, {obs =>
	  scripts/obs}/debian.nut-modbus.manpages, {obs =>
	  scripts/obs}/debian.nut-monitor.install, {obs =>
	  scripts/obs}/debian.nut-monitor.menu, {obs =>
	  scripts/obs}/debian.nut-monitor.xpm, {obs =>
	  scripts/obs}/debian.nut-powerman-pdu.install, {obs =>
	  scripts/obs}/debian.nut-powerman-pdu.manpages, {obs =>
	  scripts/obs}/debian.nut-server.dirs, {obs =>
	  scripts/obs}/debian.nut-server.init.in, {obs =>
	  scripts/obs}/debian.nut-server.install, {obs =>
	  scripts/obs}/debian.nut-server.manpages, {obs =>
	  scripts/obs}/debian.nut-server.postinst, {obs =>
	  scripts/obs}/debian.nut-server.postrm, {obs =>
	  scripts/obs}/debian.nut-server.preinst, {obs =>
	  scripts/obs}/debian.nut-server.prerm.in, {obs =>
	  scripts/obs}/debian.nut-snmp.docs, {obs =>
	  scripts/obs}/debian.nut-snmp.install, {obs =>
	  scripts/obs}/debian.nut-snmp.manpages, {obs =>
	  scripts/obs}/debian.nut-xml.install, {obs =>
	  scripts/obs}/debian.nut-xml.manpages, {obs =>
	  scripts/obs}/debian.nut.README.Debian, {obs =>
	  scripts/obs}/debian.nut.TODO.Debian, {obs =>
	  scripts/obs}/debian.nut.changes, {obs =>
	  scripts/obs}/debian.nut.docs, {obs =>
	  scripts/obs}/debian.python-nut.install, {obs =>
	  scripts/obs}/debian.rules, {obs => scripts/obs}/debian.series, {obs
	  => scripts/obs}/debian.watch, {obs => scripts/obs}/nut.dsc, {obs =>
	  scripts/obs}/nut.spec, {obs => scripts/obs}/pkgsrc.obs: Move obs/
	  to scripts/obs/ for consistency with other helper code
	* obs/nut.spec: shebangs: fix shell and sed syntax
	* obs/nut.spec: abstract the DOCPATH as a spec-var
	* obs/nut.spec: do not mention man1
	* obs/nut.spec: abstract the LIBEXECPATH as a spec-var
	* obs/nut.spec: reject found apache_serverroot that is under
	  /usr/share
	* obs/nut.spec: announce where and how we rewrite shebangs
	* obs/nut.spec: seems there is no "%if X != Y" syntax
	* obs/nut.spec: comment about alias man pages seen as duplicate files
	  in package
	* obs/nut.spec: specify system locations we use via %dir
	* obs/nut.spec: do not dump sockdebug and NDE script into
	  /usr/libexec directly
	* obs/nut.spec: avoid what looks like spec-var expansion in comments
	* obs/debian.rules: try harder to detect python2/3 helper
	* ci_build.sh: pkg*: pre-cleanup more
	* ci_build.sh: pkg-deb: clean away cdbs temp leftovers
	* ci_build.sh: pkg-deb: install prereqs (TBD;: optional?)
	* ci_build.sh: pkg-deb: force debuikd differently
	* ci_build.sh: pkg-deb: fix shell and sed syntax
	* obs/Makefile.am, obs/control: obs/*: drop "control" symlink
	* ci_build.sh, obs/Makefile.am, obs/{nut-linux-i2c.install =>
	  debian.nut-linux-i2c.install}, obs/{nut-linux-i2c.manpages =>
	  debian.nut-linux-i2c.manpages}, obs/{nut-modbus.install =>
	  debian.nut-modbus.install}, obs/{nut-modbus.manpages =>
	  debian.nut-modbus.manpages}, obs/{nut.changes =>
	  debian.nut.changes}: obs.*, ci_build.sh: rename debiam recipe files
	  to standard pattern
	* ci_build.sh: wrap pkg-rpm and pkg-deb (PoC)
	* obs/debian.rules: convince cdbs about dh_python3 when it is the
	  only viable option
	* obs/nut.dsc, obs/debian.control: do not require "python-is-..."
	  which confuses cdbs
	* NEWS.adoc, UPGRADING.adoc: Drop git-tracked compile script
	* Makefile.am: EXTRA_DIST the autotools compile script
	* .gitignore, compile: Drop git-tracked compile script

=== 2025-10-08  Jim Klimov <jimklimov+nut@gmail.com>

	* obs/nut.spec: reshuffle NUT_SYSTEMD_UNITS_SERVICE_TARGET definition
	* obs/debian.rules: fix pkg-config search for systemd vars
	* obs/debian.rules: fix iteration for debian *.install fixup (DMF)
	* obs/debian.rules: fix check for NUTPKG_WITH_DMF
	* obs/debian.rules: search for systemd configs also in libsystemd
	* obs/nut.spec: udev rules no longer under /etc - not a %config
	  (hopefully)
	* obs/nut.spec: fix rpm-var expansion for conditionals
	* obs/debian.rules: fix sed with parentheses
	* obs/nut.spec: only package docs/cables/*.txt, not the whole
	  builddir
	* obs/nut.spec: address some concerns from rpmlint
	* obs/nut.spec: %pre: try to groupadd to be sure
	* obs/debian.rules: make NUTPKG_WITH_DMF optional (based on the
	  branch we build)
	* obs/debian.nut-cgi.docs: README renamed to *.adoc
	* obs/README.adoc, docs/nut.dict: update info about OBS recipes
	  [#1209]
	* obs/nut.spec: require basic tooling used in rpmlint checks
	* obs/nut.spec: try another way of checking that apache_serverroot is
	  defined and not empty
	* obs/debian.rules: bump SO_MAJOR_LIB* vars and add libnutconf
	  installation
	* obs/nut.spec: comment about %(cmd) definitions
	* obs/debian.rules: binary-install/nut-monitor: use dh_python* more
	  clearly
	* obs/debian.rules: fix a shell/make typo
	* obs/nut.spec: try another way of checking that apache_serverroot is
	  defined and not empty
	* obs/nut.spec: exclude in root package whatever we put into
	  sub-packages (rpmbuild seems to duplicate this)
	* obs/nut.spec: post: neuter faults of chown/chgrp/chmod (some
	  rpmbuilds fail self-check due to lack of accounts)
	* obs/nut.spec: update comments
	* obs/nut.spec: actually detect ability to build NUTPKG_WITH_DMF
	  (sources available or not in this branch)
	* obs/nut.spec: only use apache_serverroot if we can detect it;
	  otherwise dump NUT CGI artifacts under our _libexecdir and _datadir
	* NEWS.adoc, UPGRADING.adoc, docs/man/Makefile.am,
	  .../{nutdrv_siemens_sitop.txt => nutdrv_siemens-sitop.txt}:
	  docs/man/nutdrv_siemens-sitop.txt, docs/man/Makefile.am,
	  UPGRADING.adoc: Fixed man page naming for
	  `nutdrv_siemens-sitop(.8)` (dash vs. underscore) to match the
	  driver program name [#1209, #545]
	* configure.ac, scripts/python/Makefile.am: Avoid "make install"
	  writing PyNUT.py and test_nutclient.py to same location twice
	* drivers/mge-hid.c: add Eaton Ellipse PRO 5S1600 [#2380]

=== 2025-10-07  Jim Klimov <jimklimov+nut@gmail.com>

	* obs/nut.spec: fix sub-package name for NUT-Monitor (GUI)
	* obs/debian.nut-monitor.install: GUI glade files have moved
	* obs/nut.spec: avoid "chown USER:GROUP" syntax
	* obs/debian.nut.docs: update file name lists
	* obs/nut.spec: only run udevadm where available
	* obs/nut.spec: rename "GROUP" which tends to pull in package type
	  string
	* obs/nut.spec: deliver files that are built and installed but were
	  not listed
	* obs/debian.control: support several libusb implementations
	* obs/debian.rules: do not run python directly anymore
	* obs/debian.changelog, obs/nut.dsc: bump formal versioning
	* obs/nut.spec: many docs files were renamed to *.adoc
	* obs/nut.spec: exclude DMF artifacts from main pkg only if
	  NUTPKG_WITH_DMF in the first place
	* obs/nut.spec: reword comment
	* obs/nut.spec: hide dblatex
	* obs/nut.spec: explicitly "Prefer" something when OBS sees we "have
	  choice for (X or Y)"
	* obs/nut.spec: do not call "python" directly
	* obs/nut.spec: revise neon dependency
	* obs/nut.spec: LUA only needed for DMF builds
	* obs/nut.spec: fix typos; make cppunit-devel optional (not in RHEL7)
	* obs/nut.spec: make TCP_WRAPPERS builds optional (if package seems
	  available to be installed - was obsoleted in many distros)
	* obs/nut.spec: refactor BuildRequires to avoid catering to
	  distro-specific macro names
	* obs/nut.spec: make IPMI, AVAHI and POWERMAN builds optional (if
	  package seems available to be installed)
	* obs/nut.spec: make DMF builds and deliveries optional (currently
	  off by default)
	* obs/nut.spec: accept either httpd-devel or apache2-devel
	* obs/nut.spec: accept either libusb-0.1 or 1.0
	* obs/nut.spec: update heading metadata
	* obs/nut.spec: expand python requirements
	* clients/upssched.c: start_timer(): drop unneeded NULLness checks
	  [#3105]
	* conf/upsmon.conf.sample.in: align NOTIFYFLAG samples with NOTIFYMSG
	  definitions [#3084]  Also helps NIT generate an upsmon.conf to
	  report those events in tests.
	* tests/NIT/upssched.conf.in: add handling for SHUTDOWN_HOSTSYNC
	  [#3084]
	* docs/man/upsmon.txt, docs/nut.dict: introduce SHUTDOWN ACTIVITY
	  WORKFLOW section [#3003, #3110]
	* docs/man/upsmon.txt: in SIMULATING POWER FAILURES section, refer to
	  NIT scripts as a source of inspiration
	* docs/man/upsmon.txt: from UPS CONNECTION TYPES AND UPSMON ROLES
	  section, refer to TIMED SHUTDOWNS section
	* docs/man/upsmon.txt: reword intro (and name) of UPS CONNECTION
	  TYPES AND UPSMON ROLES section

=== 2025-10-06  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/upssched.txt: suggest using FSD notification for early
	  shutdown activity on the upsmon primary system [#3003]
	* docs/man/upssched.conf.txt, docs/man/upssched.txt: note that
	  command execution is not async in upssched
	* NEWS.adoc, clients/upsmon.c, clients/upsmon.h:
	  clients/upsmon.{c,h}, NEWS.adoc: Make sure `FSD` notifications are
	  always issued at latest when shutdown handling just starts (or
	  earlier) [#3003, #3110]
	* ci_build.sh: consider_cleanup_shortcut(): better react to changes
	  of sources for configure script  ...even if there is no Makefile
	  yet
	* scripts/misc/nut.bash_completion.in: fix indentations
	* configure.ac, scripts/Makefile.am, scripts/misc/.gitignore,
	  scripts/misc/{nut.bash_completion => nut.bash_completion.in}:
	  scripts/misc/nut.bash_completion: convert to .in template to use
	  TAIL_ARGS_FROM_NTH_LINE [#3099]
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: use
	  TAIL_ARGS_FROM_NTH_LINE [#3099]
	* configure.ac: detect TAIL_ARGS_FROM_NTH_LINE [#3099]
	* configure.ac: fix indent

=== 2025-10-04  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/Solaris/postinstall.in: Update comments/messages for legacy
	  init script usage on Solaris older than 10 [#3099]
	* scripts/Solaris/preremove.in, scripts/Solaris/postinstall.in:
	  quiesce upsdrvctl activity; add tweak-ability for debugging NUT
	  programs in the install script context (possibly with custom
	  package builds) [#3099]
	* scripts/misc/nut.bash_completion,
	  scripts/Solaris/reset-ups-usb-solaris.sh.sample,
	  scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: avoid "tail -n
	  \+/-NUM" syntax as unportable [#3099]
	* .github/workflows/codeql.yml: disable ccache use for actual
	  compilation, for CodeQL analysis to hook into compiler correctly

=== 2025-10-02  Jim Klimov <jimklimov+nut@gmail.com>

	* ci_build.sh: fix typo in message
	* ci_build.sh: USE_CONFIG_SHELL at least from explicit caller envvar
	  [#3099]
	* ci_build.sh: revise indentation
	* clients/upssched.c: simplify loop processing [#3097]
	* tests/NIT/upssched.conf.in: rename parameters passed to "EXECUTE"
	  methods, for less confusing dev-testing logs [#3105]
	* clients/upsmon.c: add debug logging to NOTIFYCMD (WIN32) [#3097]
	* docs/man/upssched.txt: list common and unique options
	* NEWS.adoc, clients/upssched-cmd, clients/upssched.c,
	  conf/upssched.conf.sample.in, docs/man/upssched.conf.txt,
	  docs/man/upssched.txt, scripts/misc/notifyme-debug: upssched:
	  introduce passing of NOTIFYMSG to CMDSCRIPT [#3105]

=== 2025-10-01  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am: work around lack of "id -u" [#3099]
	* ci_build.sh: detect_platform_PKG_CONFIG_PATH_and_FLAGS(): fix use
	  of PKG_CONFIG variable [#3099]
	* ci_build.sh: work around NCPUS prefixed with white-space [#3099]
	* ci_build.sh: work around lack of "find -maxdepth" [#3099]
	* scripts/python/Makefile.am: add a fallback TOUPPER/TOLOWER
	  implementation [#3099]
	* ci_build.sh, scripts/subdriver/gen-snmp-subdriver.sh,
	  scripts/subdriver/gen-usbhid-subdriver.sh: add a fallback
	  TOUPPER/TOLOWER implementation [#3099]
	* configure.ac, m4/ax_realpath.m4: introduce a fallback "mktemp"
	  [#3099]
	* scripts/subdriver/gen-usbhid-subdriver.sh: quote calls to mktemp
	  [#3099]
	* scripts/subdriver/gen-snmp-subdriver.sh,
	  scripts/subdriver/gen-usbhid-subdriver.sh: add a fallback mktemp
	  implementation [#3099]
	* scripts/subdriver/gen-snmp-subdriver.sh: avoid grep for char
	  classes, it is also not ubiquitous [#3099]
	* scripts/subdriver/gen-snmp-subdriver.sh: avoid "GREP -e", it is
	  also not ubiquitous [#3099]
	* ci_build.sh: avoid "GREP -e", it is also not ubiquitous [#3099]
	* ci_build.sh: fix GGREP detection [#3099]
	* tools/driver-list-format.sh: revise reaction to "diff" problems or
	  successes [#3099]
	* tools/driver-list-format.sh: sed class [:blank:] is not portable
	  [#3099]
	* tools/driver-list-format.sh, docs/docinfo.xml.sh.in: fallback for
	  absent "diff -u" feature in pretty reporting [#3099]
	* Makefile.am, tests/nut-driver-enumerator-test.sh: fallback for
	  absent "diff -u" feature; use detected or passed EGREP [#3099]
	* NEWS.adoc: update about portability fixes [#3099]
	* tests/NIT/nit.sh: "id -u" is not ubiquitous, find fallback ways to
	  check that I_AM_ROOT [#3099]
	* ci_build.sh, configure.ac, docs/Makefile.am, docs/man/Makefile.am,
	  m4/ax_realpath_lib.m4, m4/nut_check_libnetsnmp.m4,
	  scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: Portability: in
	  some shells, "if" only accepts the list of commands to run (there
	  is no "if ! condition" support) - some better hidden cases [#3099]
	* scripts/installer/common/aix_init,
	  scripts/installer/common/ipp-host-shutdown.sample,
	  scripts/installer/common/ipp-os-shutdown: scripts/installer/*: fix
	  syntax to pass on old Solaris 8 /bin/sh [#3099]
	* Makefile.am, ci_build.sh, configure.ac, docs/Makefile.am,
	  docs/man/Makefile.am, scripts/Windows/build-mingw-prereqs.sh,
	  scripts/python/app/NUT-Monitor, scripts/python/module/Makefile.am,
	  scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in, tests/NIT/nit.sh,
	  tools/Makefile.am, tools/gitlog2version.sh: Portability: in some
	  shells, "if" only accepts the list of commands to run (there is no
	  "if ! condition" support) [#3099]
	* autogen.sh: do fail if configure script did not get generated
	  [#3099]
	* configure.ac, m4/ax_check_compile_flag.m4, m4/ax_realpath_lib.m4,
	  m4/nut_check_asciidoc.m4, m4/nut_check_aspell.m4,
	  m4/nut_check_libmodbus.m4, m4/nut_check_libsystemd.m4,
	  m4/nut_check_os.m4, m4/nut_check_pkgconfig.m4,
	  m4/nut_check_python.m4, m4/nut_compiler_family.m4: configure.ac,
	  m4/*.m4: try to use the detected GREP and EGREP tools [#3099]
	* NEWS.adoc: add historic reference from #3099 to #1660
	* ci_build.sh: handle a couple more "test -e" cases [#3099]
	* docs/Makefile.am, docs/man/Makefile.am: handle a couple more "test
	  -e" cases [#3099]
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: substitute plain
	  GREP too [#3099]
	* docs/man/Makefile.am: substitute plain GREP too [#3099]
	* docs/Makefile.am: substitute plain GREP too [#3099]
	* data/Makefile.am: export GREP or EGREP detected by configure, so
	  further called scripts do not have to re-detect [#3099]
	* tools/gitlog2version.sh: use or discover GREP to avoid literal
	  "grep" [#3099]
	* tools/driver-list-format.sh: use or discover EGREP to avoid literal
	  "grep -E" [#3099]
	* configure.ac: detect and export (E)GREP as early as possible
	  [#3099]
	* configure.ac: avoid "[ -e" or "test -e" which some older shells
	  lack [#3099]
	* tests/NIT/Makefile.am: nut_version.h: export GREP or EGREP detected
	  by configure, so further called scripts do not have to re-detect
	  [#3099]
	* include/Makefile.am: nut_version.h: export GREP or EGREP detected
	  by configure, so further called scripts do not have to re-detect
	  [#3099]
	* autogen.sh, ci_build.sh: export GREP or EGREP if we detect them, so
	  further called scripts do not have to re-detect [#3099]
	* NEWS.adoc: summarize fixes for "grep" and "test" callouts [issue
	  #3099]
	* scripts/Solaris/postinstall.in: avoid "[ -e" or "test -e" which
	  some older shells lack [#3099]
	* m4/ax_realpath.m4: protect against lack of "test -e" even better
	  (some shells do crash trying) [#3099]
	* docs/man/Makefile.am: avoid "[ -e" or "test -e" which some older
	  shells lack [#3099]
	* tests/NIT/nit.sh: use or discover EGREP to avoid literal "grep -E";
	  also GREP [#3099]
	* tools/nut-dumpdiff.sh: use or discover EGREP to avoid literal "grep
	  -E" [#3099]
	* scripts/subdriver/gen-usbhid-subdriver.sh: use or discover EGREP to
	  avoid literal "grep -E"; also GREP; avoid "grep -q" [#3099]
	* scripts/subdriver/gen-snmp-subdriver.sh: use or discover EGREP to
	  avoid literal "grep -E"; also GREP; avoid "grep -q" [#3099]
	* scripts/Solaris/reset-ups-usb-solaris.sh.sample: roll back "grep
	  -E" requirement [#3099, #1660]
	* ci_build.sh: use or discover EGREP to avoid literal "grep -E"
	  [#3099]
	* drivers/nutdrv_hashx.c: do not directly require "stdint.h" [#3099]
	* drivers/Makefile.am: fix library search order for upsdrvctl build
	  [#3099]
	* autogen.sh: avoid "find -not ..." [#3099]
	* autogen.sh: use or discover EGREP to avoid literal "grep -E"
	  [#3099]
	* autogen.sh: report about testing generated script syntax [#3099]
	* tools/gitlog2version.sh: avoid shell substitution missing in older
	  shells [#3099]
	* tools/gitlog2version.sh: use or discover EGREP to avoid literal
	  "grep -E" [#3099]
	* tools/gitlog2version.sh: avoid "[ -e" or "test -e" which some older
	  shells lack and do crash trying [#3099]
	* docs/Makefile.am: avoid "[ -e" or "test -e" which some older shells
	  lack [#3099]
	* Makefile.am: avoid "[ -e" or "test -e" which some older shells lack
	  [#3099]
	* tests/NIT/README.adoc, tests/NIT/nit.sh: tests/NIT/nit.sh: avoid "[
	  -e" or "test -e" which some older shells lack [#3099]
	* ci_build.sh: avoid "[ -e" or "test -e" which some older shells lack
	  [#3099]
	* Makefile.am: EXTRA_DIST some more useful files

=== 2025-09-30  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/net-protocol.txt: log the TODO idea for "Logout pending" of
	  some sort [#3086]
	* docs/net-protocol.txt: cross-link LIST CLIENT and GET NUMLOGINS
	* docs/net-protocol.txt: clarify intro about client libraries and
	  other bindings, in-tree or third-party

=== 2025-09-29  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/snmp-ups.c: allow to actually abort stuck init [#3101]
	* drivers/snmp-ups.c: implement a non-trivial
	  upsdrv_tweak_prognames() to allow aliasing with "snmp-ups-old"
	  [#3101]
	* NEWS.adoc, UPGRADING.adoc, docs/new-drivers.txt, docs/nut.dict,
	  drivers/adelsystem_cbi.c, drivers/al175.c, drivers/apc_modbus.c,
	  drivers/apcsmart-old.c, drivers/apcsmart.c, drivers/apcupsd-ups.c,
	  drivers/asem.c, drivers/bcmxcp.c, drivers/belkin.c,
	  drivers/belkinunv.c, drivers/bestfcom.c, drivers/bestfortress.c,
	  drivers/bestuferrups.c, drivers/bestups.c, drivers/bicker_ser.c,
	  drivers/blazer_ser.c, drivers/blazer_usb.c, drivers/clone-outlet.c,
	  drivers/clone.c, drivers/dummy-ups.c, drivers/etapro.c,
	  drivers/everups.c, drivers/failover.c, drivers/gamatronic.c,
	  drivers/generic_gpio_common.c, drivers/generic_gpio_libgpiod.c,
	  drivers/generic_modbus.c, drivers/genericups.c,
	  drivers/huawei-ups2000.c, drivers/hwmon_ina219.c, drivers/isbmex.c,
	  drivers/ivtscd.c, drivers/liebert-esp2.c, drivers/liebert-gxe.c,
	  drivers/liebert.c, drivers/macosx-ups.c, drivers/masterguard.c,
	  drivers/metasys.c, drivers/mge-utalk.c, drivers/microdowell.c,
	  drivers/microsol-apc.c, drivers/microsol-common.c,
	  drivers/netxml-ups.c, drivers/nhs_ser.c, drivers/nut-ipmipsu.c,
	  drivers/nutdrv_atcl_usb.c, drivers/nutdrv_hashx.c,
	  drivers/nutdrv_qx.c, drivers/nutdrv_siemens_sitop.c,
	  drivers/oneac.c, drivers/optiups.c,
	  drivers/phoenixcontact_modbus.c, drivers/pijuice.c,
	  drivers/powercom.c, drivers/powerman-pdu.c, drivers/powerpanel.c,
	  drivers/powervar_cx_ser.c, drivers/powervar_cx_usb.c,
	  drivers/rhino.c, drivers/richcomm_usb.c, drivers/riello_ser.c,
	  drivers/riello_usb.c, drivers/safenet.c, drivers/skel.c,
	  drivers/sms_ser.c, drivers/snmp-ups.c, drivers/socomec_jbus.c,
	  drivers/solis.c, drivers/tripplite.c, drivers/tripplite_usb.c,
	  drivers/tripplitesu.c, drivers/upscode2.c, drivers/usbhid-ups.c,
	  drivers/ve-direct.c, drivers/victronups.c: drivers/*,
	  docs/new-drivers.txt, UPGRADING.adoc, NEWS.adoc: implement (no-op)
	  upsdrv_tweak_prognames() and bump DRIVER_VERSION numbers [#3101]
	* drivers/main.c, drivers/main.h: drivers/*: introduce
	  upsdrv_tweak_prognames() hook [#3101]
	* common/common.c, drivers/main.c: drivers/main.c: main(): use new
	  sendsignalfnaliases() and sendsignalpidaliases() with prognames[]
	  [#3101]
	* NEWS.adoc, common/common.c, docs/nut.dict, include/common.h:
	  common/common.c, include/common.h, NEWS.adoc: extend with plural
	  sendsignalpidaliases() and sendsignalfnaliases() [#3101]
	* drivers/main.c, drivers/main.h: drivers/main.{c,h}: allow to track
	  several prognames[] for acceptable driver program aliases [#3101]
	* drivers/upsdrvctl.c: help(): fix global vs local arg name
	* NEWS.adoc, common/common.c, docs/nut.dict, include/common.h:
	  common/common.c, include/common.h, NEWS.adoc: extend with plural
	  checkprocnames() and compareprocnames() [#3101]
	* clients/upsmon.c: add comments to methods involved in shutdown to
	  clarify who normally runs as root or not [#3084]

=== 2025-09-28  Nick Briggs <nicholas.h.briggs@gmail.com>

	* Makefile.am, clients/Makefile.am, docs/Makefile.am,
	  docs/docinfo.xml.sh.in, docs/man/Makefile.am,
	  scripts/python/Makefile.am, scripts/systemd/nut-server.service.in,
	  scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: Modifies
	  Makefile.am files and some script ".in" files to use $EGREP  The
	  standard Solaris 10/11 "/usr/bin/grep" does not accept the "-E"
	  option.  The autotools will set EGREP to the best available tool.
	  Makefile.am that need EGREP functionality should use $(EGREP)
	  rather than directly calling "grep -E".  Additionally, scripts that
	  are generated to be installed as part of the package that need
	  EGREP functionality should use the same tool that was located
	  during configuration (assuming no cross-compilation with different
	  EGREP tool availability).  Closes #3099

=== 2025-09-25  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsmon.c: main loop: avoid sleep if FSD signal was raised
	  during the long work cycle [#3084]
	* clients/upsmon.c: user_fsd(), main loop: try to ensure immediate
	  reaction to FSD signals (interrupt a sleep() if needed) [#3084]
	* docs/config-notes.txt: clarify that upsmon exit is now subject to
	  `SHUTDOWNEXIT` setting [#3084, #2133]
	* NEWS.adoc, clients/upsmon.c, clients/upsmon.h, common/nutconf.cpp,
	  common/nutwriter.cpp, conf/upsmon.conf.sample.in,
	  docs/config-notes.txt, docs/man/upsmon.conf.txt,
	  include/nutconf.hpp: clients/upsmon.h, conf/upsmon.conf.sample.in,
	  etc: Introduced a `SHUTDOWN_HOSTSYNC` notification message [#3084]
	* conf/upsmon.conf.sample.in, docs/man/upsmon.conf.txt: revise
	  documentation of FINALDELAY [#3084]  Notably, both primary and
	  secondary upsmon `doshutdown()` to handle FSD.
	* clients/upsmon.c: doshutdown(), runparent(): debug-log just before
	  executing shutdowncmd [#3084]
	* clients/upsmon.c: runparent(): when waiting for a child to exit,
	  and we know its PID, react to the end of specifically that process
	  [#3084]
	* clients/upsmon.c: doshutdown(), runparent(): Take note of start
	  timestamp before calling SHUTDOWNCMD [#3084]
	* clients/upsmon.c: doshutdown(): debug-log about waiting for
	  FINALDELAY [#3084]
	* clients/upsmon.c: set_pdflag(): log if POWERDOWNFLAG is not
	  configured or is being written now [#3084]
	* clients/upsmon.c: doshutdown(), runparent(): initialize
	  "time(&start)" always [#3084]  Avoid (semi-bogus) warnings from
	  clang that `variable 'start' may be uninitialized when used here`
	  in `difftime()` later on.
	* clients/upsmon.c: truly deal with SHUTDOWNEXIT timeout as such, not
	  a countdown [#3084]
	* clients/upsmon.c: revise tracking pid_pipechild when parent exits
	  [#3084]
	* clients/upsmon.c: fix whitespace markup in decls

=== 2025-09-24  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsmon.c: add interaction between upsmon parent and child
	  if SHUTDOWNEXIT is non-trivial [#3084]
	* clients/upsmon.c: revise comments and log messages in
	  forceshutdown(), doshutdown(), start_pipe() [#3084]
	* clients/upsmon.c: start_pipe(), notify(): revise parent/child
	  logging around the fork() [#3084]
	* clients/upsmon.c, clients/upssched.c, drivers/upsdrvctl.c: call
	  first setproctag() after setting up nut_debug_level [#3084]
	* common/common.c, include/common.h: refactor and optimize
	  getprocname(getpid()) calls with caching getmyprocname() and
	  getmyprocbasename() [#3084]
	* common/common.c, include/common.h, clients/upsmon.c,
	  clients/upssched.c, drivers/upsdrvctl.c: move proctag_cleanup()
	  into common code and auto-register during first use of setproctag()
	  [#3084]
	* drivers/upsdrvctl.c, NEWS.adoc: introduce logging of self-assigned
	  forked process tags [#3084]
	* clients/upssched.c, NEWS.adoc: introduce logging of self-assigned
	  forked process tags [#3084]
	* clients/upsmon.c: improve debugging messages of forceshutdown()
	  [#3084]
	* clients/upsmon.c, NEWS.adoc: introduce logging of self-assigned
	  forked process tags [#3084]
	* common/common.c, include/common.h, NEWS.adoc, docs/nut.dict:
	  introduce logging of self-assigned forked process tags [#3084]

=== 2025-09-23  Jim Klimov <jimklimov+nut@gmail.com>

	* ci_build.sh: honour CI_CCACHE_USE=no more diligently
	* NEWS.adoc, clients/upssched.c, conf/upssched.conf.sample.in,
	  docs/man/upssched.conf.txt: clients/upssched.c: revise
	  CANCEL-TIMER, introduce CANCEL-TIMER-MATCHED [#3097]
	* scripts/misc/notifyme-debug: fix shell typo
	* clients/upssched.c: fix START-TIMER-SHARED [#3097]
	* clients/upssched.c: revise logging of timer events [#3097]

=== 2025-09-22  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upssched.c: start_timer(): revise START-TIMER-SHARED
	  behavior [#3097]
	* clients/upssched.c: fix CI suggestions [#3097]
	* clients/upssched.c: log-trace through, and fix, removetimers() and
	  connection loss due to a recent bug there [#3097]
	* clients/upssched.c: send_to_one(): improve debugging [#3097]
	* clients/upssched.c: collect_string(): fix the iteration logic
	  [#3097]
	* clients/upssched.c, docs/man/upssched.txt, NEWS.adoc: introduce
	  `upssched -l` mode [#3097]
	* docs/man/upssched.conf.txt: PIPEFN: chain the paragraphs of one
	  description (indent them correctly) [#3097]
	* NEWS.adoc, clients/upssched.c, conf/upssched.conf.sample.in,
	  docs/man/upssched.conf.txt, tests/NIT/upssched.conf.in:
	  clients/upssched.c, conf/upssched.conf.sample.in,
	  docs/man/upssched.conf.txt, NEWS.adoc: introduce support for
	  DEBUG_MIN in upssched.conf [#3097]
	* clients/upssched.c: update (C) header with major contributors
	* clients/upssched.c: in messages that refer to upsmon, append its
	  man page section
	* clients/upssched.c, NEWS.adoc, conf/upssched.conf.sample.in,
	  docs/man/upssched.conf.txt: let timers pass forward the UPSNAME and
	  NOTIFYTYPE again - now with relevant values; introduce
	  START-TIMER-SHARED [#3092, #3097]

=== 2025-09-21  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upssched.c: update comments [#3092]
	* clients/upssched.c: rename global upsname => ups_name to be on par
	  with global notify_type [#3092]
	* docs/man/nut.txt, docs/nut.dict: describe NUT layer 3.5 - role of
	  the drivers during shutdown
	* docs/man/nut.txt: suggest more packaged user-names for NUT daemons
	* NEWS.adoc, drivers/nutdrv_qx.c, drivers/nutdrv_qx.h:
	  drivers/nutdrv_qx.{c,h}, NEWS.adoc: define an internal
	  QX_FLAG_MAPPING_HANDLED, introduce analyze_mapping_usage() method
	  [#3095]
	* drivers/nutdrv_qx.c: fix whitespace
	* drivers/usbhid-ups.c: analyze_mapping_usage(): rephrase last
	  suggestion with also checking and building recent NUT code [#3082,
	  #3095]

=== 2025-09-19  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/snmp-ups.c, drivers/usbhid-ups.c: drivers/snmp-ups.c:
	  account SU_FLAG_MAPPING_HANDLED and do analyze_mapping_usage()
	  [#3095]
	* NEWS.adoc, drivers/snmp-ups.h: drivers/snmp-ups.{c,h}, NEWS.adoc:
	  define an internal SU_FLAG_MAPPING_HANDLED [#3095]
	* drivers/snmp-ups.c: fix markup
	* drivers/snmp-ups.h: modernize a few comments
	* drivers/snmp-ups.c: suggest in log how to improve a driver where
	  only IETF auto-matched [#3095]
	* drivers/hidtypes.h: update a comment [#3082]
	* drivers/usbhid-ups.c: fix whitespace
	* drivers/usbhid-ups.c: offload analyze_mapping_usage() to a method
	  [#3082, #3095]  Note the activity is now still limited to when
	  debug logging is enabled.

=== 2025-09-18  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/usbhid-ups.c, NEWS.adoc: suggest in log how to improve a
	  driver with too few mappings defined/used [#3082]
	* NEWS.adoc, docs/ci-farm-do-setup.adoc, docs/ci-farm-lxc-setup.txt,
	  docs/config-notes.txt, docs/config-prereqs.txt, docs/configure.txt,
	  docs/daisychain.txt, docs/design.txt, docs/documentation.txt,
	  docs/download.txt, docs/features.txt, docs/hid-subdrivers.txt,
	  docs/net-protocol.txt, docs/new-clients.txt, docs/new-drivers.txt,
	  docs/nut-names.txt, docs/nut-versioning.adoc,
	  docs/nutdrv_qx-subdrivers.txt, docs/outlets.txt,
	  docs/scheduling.txt, docs/security.txt, docs/snmp-subdrivers.txt,
	  docs/sock-protocol.txt, docs/support.txt: docs/*.txt: add asciidoc
	  comments with links to nut-website rendered contents of most
	  interesting pages
	* docs/maintainer-guide.txt: avoid pushing final release tags to
	  upstream more than once, really!
	* scripts/Makefile.am: do not EXTRA_DIST the generated
	  scripts/Windows/Makefile -- the .in template suffices  Thanks to
	  @gdt for the heads-up.

=== 2025-09-12  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsmon.c: doshutdown(): log more loudly that exit_flag is
	  raised, so shutdownexitdelay does not apply currently [#3084]

=== 2025-09-11  Jim Klimov <jimklimov+nut@gmail.com>

	* clients/upsmon.c, NEWS.adoc: doshutdown(): collapse non-zero
	  shutdownexitdelay handling into one clause, and ping the data
	  server(s) while in the loop [#3084]
	* clients/upsmon.c: more logging about ways to exit() the program,
	  and why/when it happened [#3084]

=== 2025-09-10  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/python/module/Makefile.am: emit log note that
	  .pypi-dist-pip-wheel goal does not produce sdist archives [#3056]
	* scripts/python/module/Makefile.am: fix typo in comment
	* NEWS.adoc: fixed PyPI publication to include sdist tarball [#3056]
	* .github/workflows/PyNUTClient.yml: fix shell markup [#3056]
	* .github/workflows/PyNUTClient.yml: actually install "setuptools"
	  module with "pip" [#3056]
	* .github/workflows/PyNUTClient.yml: allow manually running the GHA
	  task

=== 2025-09-08  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/hid-subdrivers.txt, docs/nut.dict: docs/hid-subdrivers.txt:
	  updating existing drivers: suggest newly logged discrepancies of
	  "seen vs. used" data [#3082]
	* drivers/nutdrv_atcl_usb.c: when suggesting other drivers and
	  configs, refer to build-aware man page sections
	* docs/hid-subdrivers.txt: fix a bit of markup
	* clients/upslog.c, NEWS.adoc: update help() and failure messages to
	  suggest -m '*,-'
	* drivers/usbhid-ups.c: process_boolean_info(): handle OB=!OL and
	  OL=!OB here (when the bit is being set) [#3080]
	* drivers/usbhid-ups.c: upsdrv_initups(): upsdebugx() at verbosity 0
	  (always) if there are too few mappings known or used via USB HID
	  [#3082]
	* drivers/apc-hid.c, NEWS.adoc, scripts/upower/95-upower-hid.hwdb:
	  declare support for APC 0x051d:0x0005 as a USB HID device [#3047]
	* drivers/nutdrv_atcl_usb.c: upsdrv_initups() failure mode: suggest
	  using nutdrv_qx(8) or blazer_usb(8) driver instead [#1021, #2152
	  follow-up]
	* data/driver.list.in: add Voltronic Power USB ID 0665:5161 as
	  nutdrv_qx supported (per driver source comments)
	* data/driver.list.in: add "Various" USB interface chip names or IDs
	  {empty}0665:5161 and 0001:0000 as nutdrv_qx or rarely nutdrv_atcl_usb
	  supported
	* data/driver.list.in: add Salicru SPS 500 ONE USB ID 0665:5161 as
	  nutdrv_qx supported [#3079]
	* data/driver.list.in: add Belkin USB ID 0665:5161 as nutdrv_qx
	  supported (per driver source comments)
	* drivers/usbhid-ups.c: upsdrv_initups(): fix variable name for the
	  snprintf() return value [#3083]
	* drivers/usbhid-ups.c: upsdrv_initups(): also report how many
	  hid2nut mappings are known vs. how many were used using USB HID
	  [#3082]
	* drivers/usbhid-ups.c: upsdrv_initups(): generalize the report of
	  unused report descriptor entries to "completely unused" vs.
	  "partially unused" (e.g. Feature vs Input) [#3082]
	* drivers/usbhid-ups.c, drivers/hidtypes.h, NEWS.adoc: check if the
	  subdriver code (mappings) and the device report sit together well
	  [#3082]
	* drivers/usbhid-ups.c: callback(): update logged message that not
	  only Manufacturer, but possibly an explicit Model, may be
	  not-supported
	* NEWS.adoc: update about usbhid-ups suggestion to iterate
	  "subdriver" values
	* drivers/usbhid-ups.c: upsdrv_initups(): check that if no ups_status
	  bit was set, suggest that wrong "subdriver" is used then [#3080,
	  #3061, #2058]
	* drivers/usbhid-ups.c: callback(): add log messages to stress that
	  the dump of Report Descriptor actually seen, and its later
	  hid_ups_walk() with a particular subdriver, may not match up well
	  [#3061]
	* drivers/usbhid-ups.c: upsdrv_initups(): add log messages to help
	  trace logical progress through the code [#3061]
	* drivers/usbhid-ups.c: possibly_supported(): suggest iterating
	  "subdriver" values [#2058]
	* NEWS.adoc, drivers/usbhid-ups.c, drivers/usbhid-ups.h:
	  drivers/usbhid-ups.c: do not assume that "!online"=="offline"
	  [#3080]
	* drivers/usbhid-ups.c: fix indentation (cosmetic)
	* drivers/usbhid-ups.c: ups_status_set(): revise code markup/style

=== 2025-09-07  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/mge-hid.c, NEWS.adoc: Improved support for Eaton 5S1500LCD
	  (US version). [#2380]
	* NEWS.adoc, docs/config-prereqs.txt, docs/configure.txt,
	  docs/developers.txt, docs/download.txt, docs/maintainer-guide.txt,
	  docs/man/apcsmart.txt, docs/man/belkin.txt,
	  docs/man/genericups.txt, docs/man/mge-shut.txt,
	  docs/man/upsdrvsvcctl.txt, docs/man/upsmon.conf.txt,
	  docs/man/upssched.conf.txt, docs/man/upsset.cgi.txt,
	  docs/man/usbhid-ups.txt, docs/new-drivers.txt, docs/outlets.txt,
	  docs/packager-guide.txt, docs/scheduling.txt,
	  scripts/Windows/README.adoc,
	  scripts/external_apis/enphase/README.adoc: Reword multiple docs to
	  avoid admonition blocks with invalid sentences
	* docs/Makefile.am: spellcheck: help avoid admonition blocks with
	  invalid sentences (after rendering as a box)
	* docs/download.txt: revise markup for Windows downloads
	* docs/download.txt: revise info about/from Repology
	* docs/download.txt: revise note about official releases
	* docs/download.txt: revise part about source archives from github

=== 2025-09-06  desertwitch <24509509+desertwitch@users.noreply.github.com>

	* drivers/nutdrv_qx_megatec.c: trim battery.runtime variable

=== 2025-09-05  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/codeql.yml: fix syntax for codeql queries

=== 2025-09-04  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/codeql.yml: Revert ".github/workflows/codeql.yml:
	  use modern "language" ID "c-cpp""  This reverts commit
	  {empty}972358ec7663007419f0b1926d30f9f5a494d910.
	* .github/workflows/codeql.yml: enable ccache per scenario, follow
	  experience from networkupstools/wmnut#24
	* .github/workflows/codeql.yml: enable more codeql queries
	* .github/workflows/codeql.yml: relocate comments, drop dead code
	* .github/workflows/codeql.yml: avoid man-db update in APT actions
	* .github/workflows/codeql.yml: report the location and version of
	  compiler used
	* .github/workflows/codeql.yml: add a way to vary matrix.build-mode
	  for codeql
	* .github/workflows/codeql.yml: only init CodeQL just before the
	  actual build, not before other filesystem changes
	* .github/workflows/codeql.yml: use modern "language" ID "c-cpp"  "c"
	  and "cpp" are older names, now aliases to this one
	* .github/workflows/codeql.yml: revise markup and comments of the
	  matrix definition
	* .github/workflows/codeql.yml: Allow manually running the action,
	  e.g. if disabled after some quietness in the source

=== 2025-09-03  Laurent Bigonville <bigon@bigon.be>

	* docs/Makefile.am: Fix installation of the pdf files

=== 2025-09-03  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/developers.txt: clarify use of "void" argument lists

=== 2025-09-02  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/nut-usbinfo.pl: update comment
	* tools/nut-usbinfo.pl: use binmode for written files to have same
	  markup regardless of builder OS
	* ci_build.sh: when reporting host envvars, use backslashes to
	  facilitate copy-paste reproduction of CI builds
	* ci_build.sh: when reporting CONFIGURING NUT, use backslashes to
	  facilitate copy-paste reproduction of CI builds
	* configure.ac, docs/configure.txt, m4/nut_check_python.m4,
	  NEWS.adoc: allow to configure Python module install location more
	  generally [#3062]
	* scripts/python/app/NUT-Monitor-py2gtk2.in,
	  scripts/python/app/NUT-Monitor-py3qt5.in,
	  scripts/python/app/NUT-Monitor-py3qt6.in:
	  scripts/python/app/NUT-Monitor-py*.in: try to honour a customized
	  PyNUT(Client) module path [#3062]

=== 2025-09-02  Hector Martin <marcan@marcan.st>

	* drivers/apc_modbus.c: apc_modbus: Fix invalid memory access for USB
	  vendor/product/serial

=== 2025-08-31  Jim Klimov <jimklimov+nut@gmail.com>

	* configure.ac, docs/configure.txt, m4/nut_check_python.m4,
	  NEWS.adoc: allow to configure PyNUT(Client) install location
	  [#3062]

=== 2025-08-21  me <me@LIONINE>

	* drivers/upsdrvctl.c: In case of WIN32 build, most drivers are
	  located in "bin". but referred Relative running path, it is "sbin".
	  So changing to "NULL(running path)" to "bin"
	* scripts/Windows/wininit.c: nut.exe are call upsdrvctl.exe in bin.
	  but upsdrvctl.exe located in sbin. So, change bin to sbin.

=== 2025-08-09  Colin Dean <colindean@users.noreply.github.com>

	* docs/download.txt, docs/nut.dict: Include macOS with Mac OS X
	  Apple shortened the name to "OS X" in 2011 and then changed it to
	  "macOS" in 2016 to align with the branding of Apple's other
	  operating systems.
	  https://en.wikipedia.org/w/index.php?title=MacOS&oldid=1304698699
	* docs/download.txt: Update download.txt with link to Homebrew
	  formula for macOS  nut has been in Homebrew since 2014.

=== 2025-08-08  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc, UPGRADING.adoc: prepare for v2.8.5.x iterations
	* NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: Revert "NEWS.adoc,
	  UPGRADING.adoc, docs/docinfo.xml.in: finalize text before NUT
	  v2.8.4 release"  This reverts commit
	  {empty}8f14140bbc395baa108bd06a9f664bd0a6f00bc8.
	* tools/gitlog2version.sh: for development, set fallback
	  NUT_VERSION_DEFAULT=2.8.4.1
	* configure.ac: for now do not require (pre-)release tagged commits
	  to build changelog by default - keep doing it on systems where we
	  can though
	* configure.ac: rephrase the message about --enable-docs-changelog
	  [#3019, #3053]
	* ci_build.sh: limit default "configure --enable-docs-changelog=no"
	  for CI builds on systems where CANBUILD_DOCS_ALL!=yes
	* ci_build.sh: add support for WITH_CHANGELOG envvar to pass down as
	  configure --enable-docs-changelog=...
	* .github/workflows/codeql.yml: configure --disable-docs-changelog in
	  CI builds
	* configure.ac: for (pre-)release builds we default
	  nut_enable_docs_changelog auto=>yes - do so loudly, and default
	  --with-doc man=>auto as well for all builds to have a chance to try
	  this
	* docs/maintainer-guide.txt: update the guide
	* docs/maintainer-guide.txt: commit that in tools/gitlog2version.sh:
	  for development, set fallback NUT_VERSION_DEFAULT=X.Y.Z.1
	* docs/maintainer-guide.txt: remind to double-check that release
	  NUT_VERSION_DEFAULT in tools/gitlog2version.sh must be a triplet
	* tools/gitlog2version.sh: for release, set fallback
	  NUT_VERSION_DEFAULT=2.8.4
	* appveyor.yml: SKIP for now NUT-Monitor prereqs

=== 2025-08-07  Jim Klimov <jimklimov+nut@gmail.com>

	* appveyor.yml: parallelize "make install"
	* appveyor.yml: also install gettext for NUT-Monitor resources
	* appveyor.yml: disable back the docs-config attempt, we do not have
	  tools nor time for that
	* appveyor.yml: try to enable build of HTML docs, notably man pages
	* appveyor.yml, NEWS.adoc: include mingw-w64-x86_64-python-pyqt6
	  [#3046]
	* docs/config-prereqs.txt: suggest PyQt5/6 for Windows builds
	* appveyor.yml: re-enable build with docs and installation, and
	  zipping it  Even if not really tested by that CI in recent
	  iterations, or rather in the iteration which would result from this
	  commit, this can help us get the artifacts made for a release
	  build.
	* appveyor.yml: re-enable some of the activity (except costlier NUT
	  docs and checks so far)

=== 2025-08-06  Jim Klimov <jimklimov+nut@gmail.com>

	* .github/workflows/PyNUTClient.yml, appveyor.yml,
	  scripts/Windows/build-mingw-nut.sh, tools/gitlog2version.sh: Update
	  versions for release of NUT v2.8.4
	* docs/docinfo.xml.in: add docs increment summary for NUT v2.8.4
	  release
	* NEWS.adoc: remove "PLANNED" from section title before NUT v2.8.4
	  release
	* NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text
	  before NUT v2.8.4 release
	* docs/maintainer-guide.txt: revise instructions
	* appveyor.yml: Revert "appveyor.yml: TEMPORARILY disable actual
	  build/test of NUT, to re-cache prereqs and their ccache objects"
	  This reverts commit 43376f874b8c0bc66d08136a522e60a80b9021af after
	  https://ci.appveyor.com/project/nut-travis/nut cache was refreshed.
	* appveyor.yml: cache built nut-win-deps before .ccache objects and
	  pacman pkgs - v2
	* appveyor.yml: cache built nut-win-deps before .ccache objects and
	  pacman pkgs
	* appveyor.yml: re-enable part of the recipe to do build NUT, just
	  not test and install it  ...still saving time allowance to re-seed
	  the caches; while fixing caches, skip docs build
	* NEWS.adoc: mention rebalancing of Appveyor CI recipe to speed up
	  the builds
	* docs/docinfo.xml.in: fix typo in summary for NUT v2.8.3 release
	* appveyor.yml: TEMPORARILY disable actual build/test of NUT, to
	  re-cache prereqs and their ccache objects
	* appveyor.yml: comment about reduced scope of build-mingw-prereqs.sh
	* scripts/Windows/build-mingw-prereqs.sh: comment about netsnmp
	  configure --disable-daemon
	* scripts/Windows/build-mingw-prereqs.sh: log timing of configure,
	  make, house-keeping operations
	* scripts/Windows/build-mingw-prereqs.sh: reduce the scope of netsnmp
	  build
	* appveyor.yml: comment more about profiling/timing different build
	  steps; comment away some more troubleshooting time-hogs
	* appveyor.yml: do not update the MSYS2 ecosystem to bleeding edge,
	  save some time to fit in the 1hr we are given

=== 2025-08-04  Jim Klimov <jimklimov+nut@gmail.com>

	* ci_build.sh: try to increase ulimit
	* docs/config-prereqs.txt, docs/nut.dict: suggest `ulimit` settings
	  via /etc/login.conf for OpenBSD

=== 2025-08-03  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c, NEWS.adoc: warn that printf(%n) is deprecated on
	  some newer platforms
	* drivers/nutdrv_qx.c: avoid %n in printf  nutdrv_qx.c:4499:27:
	  error: '%n' specifier not supported on this platform
	  [-Werror,-Wformat]

=== 2025-08-02  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/Makefile.am: fix SED syntax  Kudos to Greg Troxel for the
	  catch

=== 2025-08-01  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/nut-usbinfo.pl: find_usbdevs(): skip files that are not *.c
	  or *.h [#3030]
	* drivers/libusb0.c, drivers/libusb1.c: drivers/libusb{0,1}.c:
	  nut_libusb_open(): for libusb specifically, we have a Wiki page
	  about Insufficient Permissions [#3041]
	* NEWS.adoc, common/common-nut_version.c, drivers/libusb0.c,
	  drivers/libusb1.c, include/common.h: common/common-nut_version.c,
	  include/common.h, drivers/libusb{0,1}.c, NEWS.adoc: introduce
	  suggest_NDE_conflict() [#477, #3040]
	* Makefile.am: check-parallel-builds: ensure that we are in the
	  top_builddir when starting operations relative to it [#3030]  Be
	  pedantic to work around some quirk in NetBSD 9.2 bmake essentially.
	* ci_build.sh: check-parallel-builds: pass
	  CHECK_PARALLEL_BUILDS_REGEN=false as a make argument also, not just
	  envvar [#3030]
	* ci_build.sh: build_to_only_catch_errors_target(): fix
	  "CI_PARMAKE_VERBOSITY=verbose" logging handling

=== 2025-07-31  Jim Klimov <jimklimov+nut@gmail.com>

	* Makefile.am: check-parallel-builds: pre-clean before checking the
	  source locations [#3033]
	* Makefile.am: check-parallel-builds: for out-of-tree builds, check
	  the source locations starting from the correct root [#3033]
	* Makefile.am: check-parallel-builds: call automake portably - in a
	  way detected by configure script [#3033]
	* Makefile.am: check-parallel-builds: if called, automake must be in
	  top_srcdir where configure.ac lives [#3033]
	* .circleci/config.yml: drop explicit "make check-parallel-builds"
	  [#3030]  It is now invoked where applicable for scenarios with
	  `BUILD_TYPE=default-all-errors*` and note it was not buildable as
	  added anyway (earlier ci_build.sh wiped the work area).

=== 2025-07-30  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/qa-guide.adoc: mention OBS [#1209]
	* obs/README.adoc, obs/Makefile.am, Makefile.am, configure.ac:
	  document the "obs" directory and cover it with scripting [#1209]
	* docs/qa-guide.adoc: move CodeQL up (alphabetically, and before
	  semi-defunct Travis)
	* docs/nut-versioning.adoc, docs/developers.txt: rename to "NUT
	  Semantic Versioning" consistently
	* ci_build.sh: restore NEWS and README (if needed) between loops of
	  default-all-errors [#3030]
	* ci_build.sh: add a failsafe for CI via
	  NUT_BUILD_CAPS=check-parallel-builds=no label [#3030]
	* Makefile.am: spellcheck-quick/check-parallel-builds: refactor
	  SET_PARMAKES_OPT() code to be reusable [#3030]
	* Makefile.am: check-parallel-builds: fix suggested shell scriptlet
	  to investigate failures [#3030]  Notably, MAKEFLAGS may include the
	  "make" options without the leading dash, or other values that did
	  not have one originally. Better leave it as an environment variable
	  and let the particular "make" program deal with it.
	* ci_build.sh: optionally call "make check-parallel-builds" in
	  BUILD_TYPE="default-all-errors*" [#3030]
	* Makefile.am: check-parallel-builds: allow
	  CHECK_PARALLEL_BUILDS_REGEN=false (to speed up runs where
	  developer/CI did not change recipes anyway) [#3030]
	* tools/nutconf/Makefile.am: libnutscan.la indirectly requires
	  libcommonclient.la (for libupsclient-version.h) so bolt it into
	  deps list [#3030]

=== 2025-07-29  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/.gitignore, docs/man/Makefile.am: docs/man/Makefile.am:
	  linkman-driver{,tool}-names.txt: use unique "*.tmp.$$" filenames to
	  fix parallel builds [#3030]
	* scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in, NEWS.adoc: fixed
	  NDE to not consider "masked" systemd units as non-existent [#3033]
	* NEWS.adoc: move voltronic-axpert to existing nutdrv_qx section
	  [#1407]

=== 2025-07-28  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/phoenixcontact_modbus.txt: clarify that new options can be
	  set only once (via init) at this time [#2986]
	* NEWS.adoc: clarify how new options for phoenixcontact_modbus can be
	  set [#2986]

=== 2025-07-27  Jim Klimov <jimklimov+nut@gmail.com>

	* tools/gitlog2version.sh: do not pollute stdout [#3030]
	* tools/gitlog2version.sh, docs/nut-versioning.adoc: tack on current
	  commit if known, even if we fall back to built-in version otherwise
	  [#3030]
	* .github/workflows/codeql.yml: drop attempts to describe git-derived
	  version better [#3030]
	* tools/gitlog2version.sh: if we fail to "discover a
	  NUT_VERSION_GIT_TRUNK" or "git describe", check and report if the
	  current checkout is shallow [#3030]  CI builds often do check out
	  the built commit with minimal "depth" (often having just it), which
	  is much faster, cheaper computationally and by traffic. This
	  however precludes finding history intersections of current
	  (single-commit) tree with other trees even if we fetch them.
	* .github/workflows/codeql.yml: separate "make check-parallel-builds"
	  from main build; troubleshoot gitlog2version [#3030]
	* .circleci/config.yml, .github/workflows/codeql.yml, NEWS.adoc:
	  .circleci/config.yml, .github/workflows/codeql.yml: invoke "make
	  check-parallel-builds" [#3030]
	* clients/Makefile.am, drivers/Makefile.am, server/Makefile.am,
	  tests/Makefile.am, tools/nut-scanner/Makefile.am,
	  tools/nutconf/Makefile.am: */Makefile.am: spell out known build
	  order between out-of-dir dependencies [follows up from PR #2825,
	  highlights why issue #2584 better be solved]
	* Makefile.am, NEWS.adoc: introduced a `make check-parallel-builds`
	  recipe [follows up from PR #2825]
	* drivers/snmp-ups.c: re-order includes (keep eatons together)
	* data/driver.list.in: update entry for Kebo UPS-1000D (add
	  langid_fix and subdriver); add Tescom LEO Plus LCD 1500A which
	  works with same config [#981]
	* tools/nut-scanner/Makefile.am: ensure we only call NUT_SCANNER_DEPS
	  and it has work to do only once [follows up from PR #2825]  In
	  practice we do call it as many times as there are listed dependency
	  files, but it only generates them on the first run and quicky bails
	  out later on. This should help avoid writing into same files in
	  parallel, ending up with garbled or incomplete files when we want
	  to use them.

=== 2025-07-24  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/images/ci/jenkins-nut.css: new style in town with Jenkins LTS
	  {empty}2.516.1

=== 2025-07-22  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/phoenixcontact_modbus.c: fix typo in what is now a
	  formatting string [#2986]
	* drivers/phoenixcontact_modbus.c,
	  docs/man/phoenixcontact_modbus.txt: fix tweaks according to
	  nut-names, use dstate (so standard variable default.* or override.*
	  settings) [#2986]
	* drivers/phoenixcontact_modbus.c: log FIXMEs for more use of NUT
	  dstate overrides/defaults instead of addvar() tweaks
	* drivers/phoenixcontact_modbus.c,
	  docs/man/phoenixcontact_modbus.txt: fix according to nut-names:
	  "(ups.)delay.shutdown" => "(battery.)energysave.delay" [#2986]
	* drivers/phoenixcontact_modbus.c: fix whitespace in comments [#2986]

=== 2025-07-21  Jim Klimov <jimklimov+nut@gmail.com>

	* configure.ac, docs/configure.txt: fix ASCIIDOC_TEMPLATE_LINKMANEXT*
	  with HTML URL query part [#3027]  ...and a typo about quoting.
	* configure.ac: define default ASCIIDOC_TEMPLATE_LINKMANEXT*
	  according to target_os family (solarish, freebsd, openbsd;
	  default=linux) [follow-up to #2797]
	* configure.ac, docs/Makefile.am, docs/configure.txt,
	  docs/man/Makefile.am: Support optional man page section rewrite
	  also for linkmanext* references [follow-up to #2797]
	* NEWS.adoc, configure.ac, docs/.gitignore, docs/{asciidoc.conf =>
	  asciidoc.conf.in}, docs/configure.txt, docs/man/.gitignore,
	  docs/man/{asciidoc.conf => asciidoc.conf.in}: Do not hard-code
	  linux.die.net (and its man sections) into generated linkmanext*
	  that may vary by distro [follow-up to #2797]
	* NEWS.adoc, docs/man/asciidoc.conf, docs/nut.dict:
	  docs/man/asciidoc.conf, NEWS.adoc: fix generation of links to
	  external manual pages [follow-up to #2797]

=== 2025-07-18  Jim Klimov <jimklimov+nut@gmail.com>

	* common/common.c: minimize_formatting_string(): debug-log about
	  "cosmetic" chars at level 7 [#2956]
	* drivers/nutdrv_qx_voltronic.c: voltronic_mode(): word remaining
	  alarms to be complete sentences [#2494]
	* drivers/nutdrv_qx_voltronic.c: voltronic_mode(): add some debug
	  logging [#2494]
	* docs/man/nutdrv_qx.txt: fix quoting style from m4 to text
	* drivers/nutdrv_qx_voltronic.c, NEWS.adoc: revise
	  "vendor:voltronic:*" buzzword setting; these modes are not alarm
	  material [#2494]

=== 2025-07-18  DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

	* drivers/mge-hid.c: input.bypass.switch.on/off set flag quick update
	  instead semi static

=== 2025-07-17  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/mge-hid.c: eaton_input_bypass_check_range(): fix typo
	  checking for "value==1" [#2956]
	* drivers/usbhid-ups.c: ups_alarm_set(): ignore ECOMODE, we handle it
	  in ups_status_set() [#2956]  Avoid extra work and occasional log
	  messages that:  str_add_unique_token: skip token
	  'vendor:default:ECO': was already set
	* drivers/mge-hid.c: eaton_input_eco_mode_check_range(): refine log
	  output if we remain in ECO/non-ECO mode [#2956]
	* drivers/mge-hid.c: eaton_input_eco_mode_check_range(): sanity-check
	  that value==1 [#2956]
	* drivers/mge-hid.c: make "input.eco.switchable" a HU_FLAG_QUICK_POLL
	  value [#2956]  We want it evaluated on every quick-update loop, so
	  that the correct buzzwords are always set (if device serves the
	  feature). Also quick-update the bypass voltage and frequency, so we
	  know relevant clues (keep semi-static settings as they were
	  though).
	* NEWS.adoc: NEWS.adoc, docs/nut.dict: summary mention for recent
	  small PRs [#3019, #3021, #3022, #3023]
	* drivers/mge-hid.c: convert "input.eco.switchable" definition from
	  HU_FLAG_SEMI_STATIC to regular [#2956]
	* drivers/mge-hid.c: move "input.eco.switchable" definition to end of
	  mge_hid2nut[] table [#2956]
	* Makefile.am: install-as-root: do not overly trust in systemctl
	  preset-all  It fails on systemd 252 (known issue): Failed to preset
	  all units: Unit /run/systemd/transient/session-156053.scope is
	  transient or generated.

=== 2025-07-16  Jim Klimov <jimklimov+nut@gmail.com>

	* server/upsd.c: check_command(): try to print all command arguments
	  (if debugging) [#3023]
	* common/common.c: compareprocname(): Linux /proc/X/exe can end with
	  " (deleted)" if the program was removed or replaced
	* drivers/snmp-ups.c: su_setOID(): cast returned enum constants to
	  int [#3017]  Avoid error claimed by clang-20 et al:  conditional
	  expression between different enumeration types ('enum (unnamed at
	  ./upshandler.h:25:1)' and 'enum (unnamed at ./upshandler.h:34:1)')
	  [-Werror,-Wanon-enum-enum-conversion]
	* docs/Makefile.am: ChangeLog => ChangeLog.adoc: avoid "$<" as this
	  is not a suffix rule

=== 2025-07-15  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/Makefile.am: ChangeLog => ChangeLog.adoc: typo fix in fallback
	  INPUT
	* configure.ac, Makefile.am, docs/configure.txt, NEWS.adoc: introduce
	  confgure option to customize git log ending point [#3019]
	* tools/gitlog2changelog.py.in: allow specifying end of commit range,
	  report it in text  Technically a step to multi-section changelogs,
	  covering each release separately as a range between git tags,
	  regardless of timestamp overlap (with much older prepared commits
	  going into much newer release later on).
	* tools/gitlog2changelog.py.in: typo in comment
	* docs/Makefile.am: ChangeLog => ChangeLog.adoc: revise definition of
	  INPUT  Actually saw it with two tokens recently, for the text and
	  .prep-src-docs touch-file
	* docs/Makefile.am: when writing temporary outputs, make sure they
	  are not empty before moving to final name (else delete and bail
	  out)
	* docs/Makefile.am: .adoc => .adoc-parsed: double-check that input
	  file exists  If a recipe iteration is written incorrectly, make can
	  skip work on some rules (evaluating them as true without writing
	  outputs we need)
	* configure.ac, docs/.gitignore, docs/Makefile.am,
	  docs/configure.txt, docs/{docinfo.xml.sh => docinfo.xml.sh.in}:
	  docs/docinfo.xml.sh.in: make it a template for configure script to
	  generate and embed a @GITLOG_START_POINT@ value to consider
	* configure.ac, Makefile.am, docs/configure.txt, NEWS.adoc: introduce
	  confgure option to customize git log starting point
	* ci_build.sh: configure --disable-docs-changelog in developer
	  iterations
	* configure.ac, docs/Makefile.am, docs/configure.txt, NEWS.adoc,
	  docs/nut.dict: introduce option to "configure
	  --enable-docs-changelog" (or not)
	* docs/ci-farm-lxc-setup.txt: update link to
	  conflict-aware-ondemand-strategy-plugin

=== 2025-07-14  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/mge-hid.c: fix back eaton_input_bypass_mode_on_info[];
	  update comments; make use of errno=0/EINVAL
	* docs/nut.dict: add "nuf" to dict [#3017, #2956]
	* drivers/usbhid-ups.c, NEWS.adoc: hid_ups_walk(HU_WALKMODE_INIT):
	  report if exactly one of fun/nuf is defined in a one-line table,
	  and it would preclude reads/writes [#2956]
	* docs/nut.dict: add "nuf" to dict [#3017, #2956]
	* drivers/mge-hid.c: introduce eaton_input_buzzwordmode_setvar_nuf()
	  [#2956]
	* drivers/usbhid-ups.c, NEWS.adoc: add a way for fun/nuf methods to
	  report EINVAL for unsupported arguments, and bail out [#3017]  Made
	  for progresing on PR #2956
	* drivers/nutdrv_qx.c, NEWS.adoc: add a way for item->preprocess()
	  and qx_process() methods to report EINVAL for unsupported
	  arguments, and bail out [#3017]
	* drivers/snmp-ups.c: su_setOID(): refactor many elvises into one
	  val_practical [#3017]
	* drivers/usbhid-ups.c, NEWS.adoc: add a way for fun/nuf methods to
	  report EINVAL for unsupported arguments, and bail out [#3017]  Made
	  for progresing on PR #2956
	* drivers/snmp-ups.c, NEWS.adoc: add a way for fun/nuf methods to
	  report EINVAL for unsupported arguments, and bail out [#3017]
	* drivers/snmp-ups.c: su_setOID(): return *_CONVERSION_FAILED where
	  applicable; use upslog_*_RESULT() in callers
	  su_setvar()/su_instcmd() for maintainability
	* drivers/snmp-ups.c: su_setOID(): rectify returns of STAT_SET_* vs.
	  STAT_INSTCMD_*  Be pedantically correct about these, even if they
	  map to same numbers for logical names at the moment.
	* drivers/upshandler.h: define loggers for CONVERSION_FAILED, and
	  generally for common RESULT [#2957]
	* drivers/mge-hid.c: fix indentations (TAB vs space) to be consistent
	  [#2956]
	* NEWS.adoc, common/common.c: common/common.c:
	  minimize_formatting_string(): do not loudly log complaints about
	  known cosmetic formatting chars [#2450]
	* common/common.c: minimize_formatting_string(): update comments
	  [#2450]

=== 2025-07-13  Axel Gembe <axel@gembe.net>

	* docs/man/apc_modbus.txt: apc_modbus: Add another tested device
	  model to the man page
	* NEWS.adoc, drivers/apc_modbus.c: apc_modbus: Fix missing variables
	  due to mismatching format string  Calls to `dstate_setinfo_dynamic`
	  were using a different format string in `fmt_dynamic` than spcified
	  in `fmt_reference`.  This causes the following variables to be
	  missing:  ``` battery.runtime experimental.output.energy
	  ups.timer.shutdown ups.timer.start ups.timer.reboot
	  input.transfer.high input.transfer.low ups.delay.shutdown
	  ups.delay.start ups.delay.reboot outlet.group.0.delay.shutdown
	  outlet.group.0.delay.start outlet.group.0.delay.reboot
	  outlet.group.1.delay.shutdown outlet.group.1.delay.start
	  outlet.group.1.delay.reboot outlet.group.2.delay.shutdown
	  outlet.group.2.delay.start outlet.group.2.delay.reboot
	  outlet.group.3.delay.shutdown outlet.group.3.delay.start
	  outlet.group.3.delay.reboot ```  Since #2450 this caused this or
	  similar error messages on our integer values:  ``` [D1]
	  validate_formatting_string: dynamic formatting string '%u' is not
	  equivalent to expected '%lu' ```  This in turn caused the variable
	  to not exist and later calls to `dstate_setflags` to output:  ```
	  apc_modbus: dstate_setflags: base variable (battery.runtime) does
	  not exist ```  We fix this by using the correct format string.

=== 2025-07-10  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/snmp-ups.c, NEWS.adoc: fix debug-logging of skipping
	  SU_FLAG_STATIC entries [#3011]
	* drivers/apc-mib.c, NEWS.adoc: fix "ups.test.date" from
	  SU_FLAG_STATIC to SU_FLAG_SEMI_STATIC [#3011]

=== 2025-07-09  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: mention both APC BVKxxxM2 and BKxxxM2-CH in same fix for
	  usbhid-ups

=== 2025-07-08  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/usbhid-ups.c, drivers/powercom-hid.c,
	  docs/man/usbhid-ups.txt, NEWS.adoc: introduce
	  powercom_sdcmd_discrete_delay flag for Powercom Raptor and Smart
	  KING Pro series [#3000]
	* drivers/powercom-hid.c: WIP fixes for discrete shutdown timings
	  (per RAPTOR RPT-1500AP LCD practice) - fix messages [#3000]
	* NEWS.adoc, drivers/powercom-hid.c: fix shutdown delays for Powercom
	  HID [#3000]
	* drivers/powercom-hid.c: WIP fixes for discrete shutdown timings
	  (per RAPTOR RPT-1500AP LCD practice) [#3000]  Authored-by:
	  https://github.com/aleka204

=== 2025-07-07  Jim Klimov <jimklimov+nut@gmail.com>

	* scripts/systemd/nutshutdown.in, NEWS.adoc: bail out if MODE=none
	  explicitly [#2935]
	* drivers/mge-hid.c: refactor old (pegasus) and new (ECO/ESS) mapping
	  tables with fun/nuf methods [#2956]
	* drivers/mge-hid.c: comment which info_lkp_t[] tables are in fact
	  wrong examples of mapping function usage [#2956]
	* docs/man/phoenixcontact_modbus.txt: reconcile config setting names
	  with strings used in the driver [#2986]
	* docs/man/phoenixcontact_modbus.txt: align shutdown variables
	  descriptions with comments in code [#2986]
	* docs/man/nutupsdrv.txt: document `override.*` or `default.*` names
	  for `var=val` settings
	* docs/man/phoenixcontact_modbus.txt: wrap long lines; anticipate
	  renaming/obsoletion of some driver-specific settings [#2986]
	* NEWS.adoc: document recent changes to start-up messages and loop
	  flushing in upsmon [#3003]
	* clients/upsmon.c: report in debug-log which SHUTDOWNCMD/NOTIFYCMD
	  would be used (and if no NOTIFYCMD was set) [#3003]
	* clients/upsmon.c: fflush() at end of each main loop cycle, just in
	  case
	* clients/upsmon.c: make "Warning: no shutdown command defined"
	  visible when the daemon starts  Being a printf() to stdout, it got
	  buffered and often only appeared on buffer flush when the daemon
	  exited.
	* NEWS.adoc, data/driver.list.in, docs/man/usbhid-ups.txt,
	  docs/nut.dict, drivers/usbhid-ups.c: drivers/usbhid-ups.c: handle
	  also APC BKnnnM2[_-]CH tweaks for
	  lbrb_log_delay_without_calibrating/onlinedischarge_calibration
	  [#3006, #2347]  Update docs, data/driver.list.in suggestions;
	  refactor the if-clause to detect if the tweak applies to the device
	  being handled.

=== 2025-07-04  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: note further ECO mode updates in mge-hid [#2956]
	* NEWS.adoc: clarify message for bcmxcp fix [#3002]
	* NEWS.adoc: re-order ddriver updates alphabetically

=== 2025-07-03  desertwitch <24509509+desertwitch@users.noreply.github.com>

	* NEWS.adoc: add bcmxcp fixes [#3002]
	* drivers/bcmxcp.c: fix latched on to RB alarm

=== 2025-07-03  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/packager-guide.txt: suggest a nut-common package for shared
	  stuff
	* drivers/powervar_cx.c: remove space before parenthesis after
	  status_set() to simplify review for issue [#2708]
	* drivers/pijuice.c, NEWS.adoc: revise use of status_set() [#2708]

=== 2025-06-25  Jim Klimov <jimklimov+nut@gmail.com>

	* NEWS.adoc: announce updates to phoenixcontact_modbus [#2986]
	* docs/man/phoenixcontact_modbus.txt: fix asciidoc markup for man
	  page [#2986]  This is not directly a troff file
	* drivers/phoenixcontact_modbus.c: fix CI complaints [#2986]  *
	  static methods * declarations before code * mismatches of int type
	  vs printf formatting string (hex)
	* docs/man/phoenixcontact_modbus.txt, docs/nut.dict: update
	  authors/contributors list [#2986]
	* drivers/phoenixcontact_modbus.c: fix author/contributor list
	  [#2986]
	* drivers/phoenixcontact_modbus.c: fix back broken whitespace [#2986]
	* drivers/powervar_cx.c, drivers/powervar_cx_ser.c,
	  drivers/powervar_cx_usb.c: drivers/powervar_cx*: fix more
	  formatting string vs. int type mismatches [#2988]

=== 2025-06-25  DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

	* drivers/mge-hid.c: try return int instead double to check compiler
	  issue
	* drivers/mge-hid.c: add some more debug

=== 2025-06-24  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/powervar_cx.c: instcmd(): fix int type of ShowTime [#2988]
	* drivers/powervar_cx.c, drivers/powervar_cx.h: drivers/powervar_cx*:
	  fix int type of GetSubstringPosition() [#2988]
	* drivers/powervar_cx.c, drivers/powervar_cx.h,
	  drivers/powervar_cx_usb.c: drivers/powervar_cx*: fix visibility of
	  some declarations [#2988]
	* drivers/powervar_cx.c: prefer snprintf() over strncpy() [#2988]
	* drivers/powervar_cx.c, drivers/powervar_cx_ser.c,
	  drivers/powervar_cx_usb.c: drivers/powervar_cx*.c: use same style
	  for space after comma [#2988]
	* drivers/powervar_cx.c, drivers/powervar_cx_usb.c:
	  drivers/powervar_cx*.c: use same style for space after "if" [#2988]
	* drivers/powervar_cx.c: avoid unbound strcpy() and strcat() [#2988]
	* drivers/Makefile.am, drivers/powervar_cx.c, drivers/powervar_cx.h,
	  drivers/powervar_cx_ser.c, drivers/powervar_cx_usb.c:
	  powervar_cx_{ser,usb}: split helper code powervar_cx.{c,h} into a
	  true C header and compiled C source (do not "include" the latter)
	  [#2988]
	* NEWS.adoc, docs/man/Makefile.am, docs/man/powervar_cx_ser.txt,
	  docs/man/{powervar-cx.txt => powervar_cx_usb.txt},
	  drivers/Makefile.am, drivers/{powervar-cx.h => powervar_cx.h},
	  drivers/{powervar-cs.c => powervar_cx_ser.c},
	  drivers/{powervar-cu.c => powervar_cx_usb.c}:
	  powervar_cx_{ser,usb}: rename sources, separate man pages [#2988]
	* drivers/powervar-cu.c, drivers/powervar-cx.h: drivers/powervar-c*:
	  avoid sub-standard "uint" type [#2988]
	* drivers/powervar-cu.c: SendRequest(): revise nulling of outbuff[],
	  add sanity-checks and comment about them [#2988]
	* drivers/powervar-cu.c: fix upsdebugx(verbosity) vs
	  upslogx(facility) [#2988]
	* drivers/powervar-cu.c: SendRequest(), PowervarGetResponse(): align
	  int vars with print format and return types [#2988]

=== 2025-06-24  DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

	* data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: rename
	  enable/diasble to start/stop

=== 2025-06-24  Bill Elliot <bill@wreassoc.com>

	* drivers/powervar_cx.c, drivers/powervar_cx.h,
	  drivers/powervar_cx_usb.c: Add comment(s) in source about compiling
	  common driver file.  Add FIXME note.

=== 2025-06-23  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/man/powervar-cx.txt: fix NAME section to generate the alias
	  man pages [#2988]  NOTE: man aliases are special reference files,
	  so the target powervar-cx.8 file must be delivered wherever *-cs
	  and/or *-cu are the one(s) really needed.

=== 2025-06-20  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/powervar-cu.c: use NUT standard population of regex_array
	  for USB config parameters [#2988]
	* drivers/powervar-cu.c: fix int size mismatch [#2988]  Code scanning
	  / CodeQL: Comparison of narrow type with wide type in loop
	  condition: Comparison between [i](1) of type uint8_t and
	  [ReqLen](2) of wider type size_t.
	* drivers/powervar-cu.c, drivers/powervar-cx.h: drivers/powervar-c*:
	  fix clang complaints about method visibility/declaration [#2988]
	* docs/man/Makefile.am: neuter powervar-c{s,u}.html (similar to other
	  fictional HTML aliases) for now [#2988]
	* drivers/powervar-cu.c, drivers/powervar-cx.h: drivers/powervar-c*:
	  slightly revise C markup (indentations, declarations on top)
	  [#2988]
	* UPGRADING.adoc: note packaging of powervar-cX man pages [#2988]
	* docs/man/Makefile.am: fix recipes to nominally deliver the
	  powervar-c[us] pages, aliased from one powervar-cx [#2988]
	* docs/man/powervar-cx.txt: fix asciidoc markup; clarify that there
	  are two powervar* drivers (USB/Serial) at this time [#2988]
	* NEWS.adoc: introduced powervar-cs and powervar-cu drivers [#2988]
	* data/driver.list.in: update top comment with formatting
	  requirements for markup of this file [#2988]
	* data/driver.list.in: parsing scripts expect single-TAB separation
	  of fields [#2988]

=== 2025-06-19  Jim Klimov <jimklimov+nut@gmail.com>

	* docs/Makefile.am: specify VPATH for sub-makes doing spellcheck
	* docs/Makefile.am, docs/man/Makefile.am, NEWS.adoc: only SED text
	  source files for *-prepped (man page section, nut-website, etc.)
	  rewrites [#2989]
	* clients/upsmon.c: when warning about no SHUTDOWNCMD, check about no
	  MINSUPPLIES too (maybe not a problem)
	* scripts/systemd/nutshutdown.in: update notes on purpose, location
	  and likely variations
	* conf/upsmon.conf.sample.in: update notes on Windows SHUTDOWNCMD
	* conf/upsmon.conf.sample.in: update notes on semi-required settings

=== 2025-06-16  haul <ulfathasangarayev@gmail.com>

	* docs/man/phoenixcontact_modbus.txt,
	  drivers/phoenixcontact_modbus.c: Fix issues from previous PR review
	  - Bumped internal version to 0.09 (two-digit format) - Replaced
	  single-line // comments with /* ... */ block comments - Added
	  missing variable descriptions to the man page - Preserved original
	  authors in metadata - Standardized config variable names to align
	  with nut-names.txt where possible - Declared all variables at top
	  of scope as per C89 style  Feedback originally provided by
	  @jimklimov on PR #2986 (superseded by this commit)

=== 2025-06-16  DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

	* drivers/mge-hid.c: try again in one func
	  eaton_input_eco_mode_auto_on_off_info()
	* drivers/mge-hid.c: Fix value ("1") in nuf
	* drivers/mge-hid.c: for test value after compile

=== 2025-06-15  DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

	* drivers/mge-hid.c: separate on / off as only fisrt command is used
	  in this case

=== 2025-06-13  haul <haul@tgw-group.com>

	* drivers/phoenixcontact_modbus.c: Add support for shutdown
	  variables, mode selector, PC reset timing, and battery switch
	  threshold  - Introduced new variables to the phoenixcontact_modbus
	  driver especially for QUINTS 4 USB: - shutdown variables - mode
	  selector 9 = PC_MODE - PC reset delay after main power recovers -
	  automatic switch to battery mode if main power is below or above a
	  defined threshold.

=== 2025-06-12  Jim Klimov <jimklimov@gmail.com>

	* docs/man/nut.txt, docs/man/index.txt: introduce
	  "ifndef::included-skip-title[]" toggle
	  [networkupstools/nut-website#61]

=== 2025-06-12  DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

	* drivers/mge-hid.c: return on/off
	* drivers/mge-hid.c: another typo
	* drivers/mge-hid.c: double, small fixes
	* drivers/mge-hid.c: convert from two functions to one
	  `eaton_input_eco_mode_auto_on_off_fun/[nuf]()`
	* drivers/mge-hid.c: return double (0.0 and 0.1) instead of named
	  double

=== 2025-06-11  Jim Klimov <jimklimov+nut@gmail.com>

	* drivers/apc_modbus.c, NEWS.adoc: bump version, add summary [#2982]
	* docs/man/pijuice.txt, docs/nut.dict: some more nuances [#2985]
	* lib/libupsclient-config.in: single-quote ConfigFlags value
	* lib/libupsclient-config.in: define commonly customized dirs so
